########################################################################### ###
#@File
#@Copyright     Copyright (c) Imagination Technologies Ltd. All Rights Reserved
#@License       Dual MIT/GPLv2
#
# The contents of this file are subject to the MIT license as set out below.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# Alternatively, the contents of this file may be used under the terms of
# the GNU General Public License Version 2 ("GPL") in which case the provisions
# of GPL are applicable instead of those above.
#
# If you wish to allow use of your version of this file only under the terms of
# GPL, and not to allow others to use your version of this file under the terms
# of the MIT license, indicate your decision by deleting the provisions above
# and replace them with the notice and other provisions required by GPL as set
# out in the file called "GPL-COPYING" included in this distribution. If you do
# not delete the provisions above, a recipient may use your version of this file
# under the terms of either the MIT license or GPL.
#
# This License is also included in this distribution in the file called
# "MIT-COPYING".
#
#
# EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
# PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
# BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
# PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
### ###########################################################################
PVRSRVKM_NAME = $(PVRSRV_MODNAME)

#0~8
#CONFIG_POWER_CFG:0   GFX#:4 Corner:TT GFXVset:0.79V VIDVset:0.75V SOCVset:0.75V GFXFreq:1400MHz VIDECLK:750MHz VIDDCLK:750MHz Encoder:33 TGP:62.3 TDP:52.79
#CONFIG_POWER_CFG:1   GFX#:4 Corner:FF GFXVset:0.75V VIDVset:0.75V SOCVset:0.75V GFXFreq:1400MHz VIDECLK:750MHz VIDDCLK:750MHz Encoder:33 TGP:57.9 TDP:49.21
#CONFIG_POWER_CFG:2   GFX#:4 Corner:SS GFXVset:0.84V VIDVset:0.75V SOCVset:0.75V GFXFreq:1200MHz VIDECLK:750MHz VIDDCLK:750MHz Encoder:33 TGP:60.8 TDP:51.70

#CONFIG_POWER_CFG:3   GFX#:2 Corner:TT GFXVset:0.75V VIDVset:0.75V SOCVset:0.75V GFXFreq:1000MHz VIDECLK:400MHz VIDDCLK:400MHz Encoder:36 TGP:31.8 TDP:27.02
#CONFIG_POWER_CFG:4   GFX#:2 Corner:FF GFXVset:0.75V VIDVset:0.75V SOCVset:0.75V GFXFreq:1000MHz VIDECLK:400MHz VIDDCLK:400MHz Encoder:36 TGP:31.8 TDP:27.02
#CONFIG_POWER_CFG:5   GFX#:2 Corner:SS GFXVset:0.76V VIDVset:0.75V SOCVset:0.75V GFXFreq:1000MHz VIDECLK:400MHz VIDDCLK:400MHz Encoder:36 TGP:32.1 TDP:27.32

#CONFIG_POWER_CFG:6   GFX#:2 Corner:TT GFXVset:0.75V VIDVset:0.75V SOCVset:0.75V GFXFreq:0800MHz VIDECLK:810MHz VIDDCLK:810MHz Encoder:72 TGP:32.0 TDP:27.20
#CONFIG_POWER_CFG:7   GFX#:2 Corner:FF GFXVset:0.75V VIDVset:0.75V SOCVset:0.75V GFXFreq:0800MHz VIDECLK:810MHz VIDDCLK:810MHz Encoder:72 TGP:32.0 TDP:27.20
#CONFIG_POWER_CFG:8   GFX#:2 Corner:SS GFXVset:0.75V VIDVset:0.75V SOCVset:0.75V GFXFreq:0800MHz VIDECLK:810MHz VIDDCLK:810MHz Encoder:72 TGP:32.0 TDP:27.20
CONFIG_POWER_CFG = 0

# FOR JS PROJECT
CONFIG_PROBE_RESET = n

# FOR VIDEO MAKE CONFIG
CONFIG_VASTAI_VIDEO = y

#FOR AI MAKE CONFIG
CONFIG_VASTAI_AI = y
CONFIG_VASTAI_AI_EMU = n

#FOR GFX
CONFIG_VASTAI_GFX = n
#0:ATU 1:GART
CONFIG_ATUO_GART_EN = 1
CONFIG_DDK_ALLOC_MEM = n
export CONFIG_VASTAI_GFX

ifdef ATUO_GART_EN
	CONFIG_ATUO_GART_EN = $(ATUO_GART_EN)
endif

ifdef ALLOC_MEM_FROM_DDK
	CONFIG_DDK_ALLOC_MEM = $(ALLOC_MEM_FROM_DDK)
endif

#FOR TOOLS suit
CONFIG_VASTAI_TOOLS_SUITE = y

#FOR BOOT MAKE CONFIG
CONFIG_VASTAI_PCI_ONLY_DOWNLOAD_BL1 = n
#FOR only boot master pkg for dualpkg, debug purpose.
CONFIG_VASTAI_PCI_FORCE_SINGLE_DIE = n
#Debug AIC dualpkg(16GB DDR) card to disable some PF2/3/6/7 in boot branch
CONFIG_VASTAI_CARD_AIC_16GB = n

#FOR DMA MAKE CONFIG
CONFIG_VASTAI_SYNOPSIS_PCIE_DMA_HOST = n

CONFIG_VASTAI_PCIE_DMA_ENABLE = n
#for sdma size/address check
CONFIG_VASTAI_SDMA_CHECK = y

#FOR PCIE DRV
CONFIG_ENV_EMULATOR = n
CONFIG_ENV_SILICON = y

export CONFIG_VASTAI_PCI_BOOT = y
CONFIG_VASTAI_BOOT_GMCU = n
CONFIG_VASTAI_MULTI_PF = y
CONFIG_VASTAI_VF_TILE_MODE_EN = n
CONFIG_DYNAMIC_SRIOV_EN = y

#for performance test
CONFIG_VASTAI_PERFORMANCE_TEST = n
#for mmio performance test
CONFIG_VASTAI_MMIO_PERF_TEST = n
#FOR DV Diag
DIAG_TEST_MODE = n
DIAG_TEST_DDK = n
DIAG_TEST_WC = n
DIAG_TEST_GFX_PERF = n

CONFIG_PVP_HASH_CMP_EN = y

#For AI emulation
ifeq ($(CONFIG_VASTAI_AI_EMU),y)
$(warning This branch is used for running AI emulation.)
ccflags-$(CONFIG_VASTAI_AI_EMU) += -DCONFIG_VASTAI_AI_EMU
CONFIG_VASTAI_VIDEO = n
#CONFIG_VASTAI_PCI_FORCE_SINGLE_DIE = y
endif

# Temp for VIDEO, remove this when all module is OK
ifeq ($(CONFIG_VASTAI_VIDEO),y)
$(warning This branch is used for ruing VIDEO decoder for temp.)
#CONFIG_VASTAI_CARD_AIC_16GB = n
#CONFIG_VASTAI_VF_TILE_MODE_EN = n
endif

#CONFIG MAKE SUBDIR
subdir-ccflags-y := \
	-I$(src)/include \
	-I$(src)/logsys \
	-I$(src) \
	-I$(src)/common \
	-I$(TOP)/gfx
subdir-ccflags-$(CONFIG_VASTAI_VIDEO) += -I$(src)/video_driver
subdir-ccflags-$(CONFIG_VASTAI_VIDEO) += -I$(src)/video_driver/common \
					-I$(src)/video_driver/enc_drv \
					-I$(src)/video_driver/dec_drv
subdir-ccflags-$(CONFIG_VASTAI_TOOLS_SUITE) += -I$(src)/tools_driver

$(warning subdir-ccflags-y := '$(subdir-ccflags-y)')


#CONFIG MAKE PRE-MACRO
#boot by pcie
ccflags-$(CONFIG_PROBE_RESET) += -DCONFIG_PROBE_RESET
ccflags-$(CONFIG_ENV_EMULATOR) += -DCONFIG_ENV_EMULATOR
ccflags-$(CONFIG_ENV_SILICON)      += -DCONFIG_ENV_SILICON
ccflags-$(CONFIG_VASTAI_PCI_BOOT) += -DCONFIG_VASTAI_PCI_BOOT
ccflags-$(CONFIG_VASTAI_PCI_FORCE_SINGLE_DIE) += -DCONFIG_VASTAI_PCI_FORCE_SINGLE_DIE
ccflags-$(CONFIG_VASTAI_CARD_AIC_16GB) += -DCONFIG_VASTAI_CARD_AIC_16GB
ccflags-$(CONFIG_VASTAI_PCI_ONLY_DOWNLOAD_BL1) += -DCONFIG_VASTAI_PCI_ONLY_DOWNLOAD_BL1
ccflags-$(CONFIG_VASTAI_VIDEO) += -DCONFIG_VASTAI_VIDEO
ccflags-$(CONFIG_VASTAI_AI) += -DCONFIG_VASTAI_AI
ccflags-$(CONFIG_VASTAI_TOOLS_SUITE) += -DCONFIG_VASTAI_TOOLS_SUITE -DCONFIG_TOOLS_V2
ccflags-$(CONFIG_VASTAI_GFX) += -DCONFIG_VASTAI_GFX
ccflags-$(CONFIG_DDK_ALLOC_MEM) += -DCONFIG_DDK_ALLOC_MEM
ccflags-$(CONFIG_VASTAI_BOOT_GMCU) += -DCONFIG_VASTAI_BOOT_GMCU
ccflags-$(CONFIG_VASTAI_MULTI_PF) += -DVASTAI_MULTI_PF_SUPPORT
ccflags-$(CONFIG_VASTAI_VF_TILE_MODE_EN) += -DVASTAI_VF_TILE_MODE_SUPPORT
ccflags-$(CONFIG_DYNAMIC_SRIOV_EN) += -DDYNAMIC_SRIOV_EN
ccflags-$(DIAG_TEST_MODE) += -DDIAG_TEST_MODE
ccflags-$(DIAG_TEST_DDK)  += -DDIAG_TEST_DDK
ccflags-$(DIAG_TEST_WC)   += -DDIAG_TEST_WC
ccflags-$(DIAG_TEST_GFX_PERF)   += -DDIAG_TEST_GFX_PERF
ccflags-$(CONFIG_VASTAI_PCIE_DMA_ENABLE) += -DPCIE_DMA_ENABLE
ccflags-$(CONFIG_PVP_HASH_CMP_EN) += -DCONFIG_PVP_HASH_CMP_EN

ccflags-$(CONFIG_VASTAI_PERFORMANCE_TEST) += -DVASTAI_PERFORMANCE_TEST
ccflags-$(CONFIG_VASTAI_MMIO_PERF_TEST) += -DVASTAI_MMIO_PERF_TEST
ccflags-y += -DCONFIG_POWER_CFG=$(CONFIG_POWER_CFG)
ccflags-y += -DCONFIG_ATUO_GART_EN=$(CONFIG_ATUO_GART_EN)
ccflags-y += -Wno-date-time

ccflags-y += -DVIDEO_COMPAT
ccflags-y += -DVIDEO_COMPAT_ENC
ccflags-$(CONFIG_VASTAI_SDMA_CHECK) += -DCONFIG_VASTAI_SDMA_CHECK

ccflags-y += -I$(TOP)/include \
	     -I$(TOP)/include/export \
	     -I$(TOP)/common \
	     -I$(TOP)/ep_driver \
	     -I$(TOP)/logsys \
	     -I$(TOP)/gfx \
	     -I$(TOP)/ep_driver/hw \
	     -I$(TOP)/ep_driver/hw/smcu \
		 -I$(TOP)/ep_driver/hw/ras \
		 -I$(TOP)/ep_driver/hw/vsync \
		 -I$(TOP)/gfx/services/server/env/linux \
	     -I$(TOP)/video_driver \
	     -I$(TOP)/video_driver/common \
	     -I$(TOP)/video_driver/enc_drv \
	     -I$(TOP)/video_driver/dec_drv \
	     -I$(TOP)/tools_driver \
	     -I$(TOP)
	     
$(warning ccflags-y := '$(ccflags-y)')

# aresding add CONFIG_VASTAI_SOC_HW_TYPE temporarily, it will be removed once [gfx_kmd] united with [pcie]
# CONFIG_VASTAI_SOC_HW_TYPE=1 --- SV100
# CONFIG_VASTAI_SOC_HW_TYPE=2 --- SG100
ccflags-y += -DCONFIG_VASTAI_SOC_HW_TYPE=2
include $(TOP)/ai_driver/ai_driver.mk

$(PVRSRVKM_NAME)-$(CONFIG_VASTAI_VIDEO) += video_driver/common/vastai_video_utils.o \
		    video_driver/common/vastai_render.o \
		    video_driver/enc_drv/vastai_enc.o \
		    video_driver/dec_drv/subsys.o \
		    video_driver/dec_drv/vastai_dec.o

$(PVRSRVKM_NAME)-$(CONFIG_VASTAI_PCI_BOOT) += boot/vastai_pci_boot.o
$(PVRSRVKM_NAME)-y += debug/vastai_pci_test.o \
		    debug/vastai_udma_test.o \
		    debug/vastai_pci_ioctl.o \
		    debug/vastai_pci_version.o \
			debug/vastai_cfg.o
$(PVRSRVKM_NAME)-y += ep_driver/vastai_state.o  \
		    ep_driver/vastai_dmabuf.o      \
		    ep_driver/vastai_dmi_table.o \
		    ep_driver/vastai_pci_basic.o \
		    ep_driver/vastai_udma_engine.o \
		    ep_driver/vastai_pci_access.o 
$(PVRSRVKM_NAME)-y += logsys/logsys.o
$(PVRSRVKM_NAME)-$(CONFIG_VASTAI_TOOLS_SUITE) += tools_driver/vatools_common.o\
                                               tools_driver/vatools_sharedmem.o\
                                               tools_driver/vatools_smi.o\
                                               tools_driver/vatools_profiler.o\
                                               tools_driver/vatools_debugger.o\
                                               tools_driver/vatools_logger.o\
                                               tools_driver/vatools_dummy.o\
                                               tools_driver/vatools_driver.o

$(PVRSRVKM_NAME)-y += gfx/gfx_drv.o
$(PVRSRVKM_NAME)-$(CONFIG_VASTAI_GFX) += gfx/gfx_mm.o
$(PVRSRVKM_NAME)-y += ep_driver/hw/va_irq.o common/hw_queue.o vastai_cmd.o common/hw_config.o

$(PVRSRVKM_NAME)-y += ep_driver/hw/va_hw_init.o \
		    ep_driver/hw/dma_test.o \
		    ep_driver/hw/va_dma_core.o \
		    ep_driver/hw/pcie_2_dma.o \
		    ep_driver/hw/sdma_test.o \
		    ep_driver/hw/smmu.o \
		    ep_driver/hw/sdma.o \
		    ep_driver/hw/dsu.o \
		    ep_driver/hw/smcu/smcu.o \
			ep_driver/hw/smcu/va_inventory.o \
			ep_driver/hw/ras/exception.o \
			ep_driver/hw/ras/heartbeat.o \
			ep_driver/hw/ras/vastai_pcie_aer.o \
			ep_driver/hw/ras/smcu_cfg_err.o \
			ep_driver/hw/ras/vastai_reset.o \
			ep_driver/hw/ras/flr.o \
		    ep_driver/hw/ai/ai_info.o \
			ep_driver/hw/ai/ai_int.o \
		    ep_driver/vastai_fifo.o \
		    ep_driver/hw/vsync/va_vsync.o

$(PVRSRVKM_NAME)-$(CONFIG_VASTAI_SYNOPSIS_PCIE_DMA_HOST) += ep_driver/hw/pcie_2_dma_host.o
ccflags-$(CONFIG_VASTAI_SYNOPSIS_PCIE_DMA_HOST) += -DCONFIG_VASTAI_SYNOPSIS_PCIE_DMA_HOST
