# SG100 PCIe Driver Install Guide

This guide is intended to help you install the latest version of SG100 PCIe driver on your system.

## 1. Overview

PCIe driver 是瀚博 SG100 架构系列芯片的内核驱动。

## 2. PCIe driver安装包

```bash
# RPM
vastai-pci-xx_xx.xx.xx.xx_xx.rpm
# DEB
vastai-pci-xx_xx.xx.xx.xx_xx.deb
```
## 3. 安装准备

请检查下列环境及版本要求是否已经安装：

- dkms (>=1.95, <=2.8)
- linux-headers
- dpkg (Ubuntu)
- rpm  (CentOS)
- python2
- python3

## 4. 全新安装

### 4.1 Ubuntu Installation

1. 安装环境准备：

```bash
sudo apt-get install dh-make dkms dpkg dpkg-dev python2 python3
```

2. PCIe driver安装

```bash
sudo dpkg -i vastai-pci-xx_xx.xx.xx.xx_xx.deb
```

3. Verify the installation.

Step 1: 运行如下命令，查看deb包是否安装成功；
```bash
dpkg-query -l |grep vastai-pci
```
```bash
# output
ii vastai-pci-xx-dkms xx.xx.xx.xx all vastai-pci-release-drv-v5-11-hwtype-0 driver in DKMS format.
```

Step 2: 运行如下命令，确认deb包是否安装成功；
```bash
dpkg --status vastai-pci-xx-dkms
```
```bash
# output
Package: vastai-pci-xx-dkms
Status: install ok installed
……
Version: xx.xx.xx.xx
Provides: vastai-pci-xx-modules (= xx.xx.xx.xx)
Depends: dkms (>= 1.95)
Description: vastai-pci-xx driver in DKMS format.

```

Step 3: 运行如下命令查看驱动是否已加载到内核。
```bash
lsmod | grep vastai_pci
```
```bash
# output
vastai_pci  xxx  x
```

(注意：SG100 设备需插入服务器，否则驱动无法加载到内核)

### 4.2 CentOS Installation

1. 安装环境准备：

```bash
sudo yum install epel-release python2 python3
sudo yum install kernel-headers kernel-devel dkms
```

2. PCIe driver安装

```bash
sudo rpm -i vastai-pci-xx_xx.xx.xx.xx_xx.rpm
```
3. Verify the installation.

Step 1: 运行如下命令，查看rpm包是否安装成功；
```bash
rpm -qa | grep vastai-pci
```
```bash
# output
vastai-pci-xx-xx.xx.xx.xx-dkms.xx
```

Step 2: 运行如下命令查看驱动是否已加载到内核。
```bash
lsmod | grep vastai_pci
```
```bash
#output
vastai_pci  xxx  x
```

(注意：SG100 设备需插入服务器，否则驱动无法加载到内核)


## 5. 升级驱动

### 5.1 Ubuntu Upgrade

```bash
sudo dpkg -i vastai-pci-xx_xx.xx.xx.xx_xx.deb
```

### 5.2 CentOS Upgrade

```bash
# 升级到新版本
sudo rpm -U vastai-pci-xx_xx.xx.xx.xx_xx.rpm
# 回退到老版本
sudo rpm -U --oldpackage vastai-pci-xx_xx.xx.xx.xx_xx.rpm
# 重新安装相同版本(分两步)
sudo rpm -e vastai-pci-xx_xx.xx.xx.xx_xx.rpm
sudo rpm -i vastai-pci-xx_xx.xx.xx.xx_xx.rpm
```

## 6. 卸载驱动

### 6.1 Ubuntu

```bash
# 查询安装包名字
dpkg -l | grep vastai
# 卸载安装包
sudo dpkg -r vastai-pci-xx-dkms
```

### 6.2 CentOS

```bash
#查询安装包名字
rpm -qa | grep vastai
#卸载安装包
sudo rpm -e vastai-pci-xx-xx.xx.xx.xx-dkms.xx
```

## 7. Troubleshooting

For troubleshooting, please contact us directly.
