#!/bin/bash

OLD_STR_MIN_VA="vastai"
OLD_STR_MAJ_VA="VASTAI"
OLD_STR_HUMP_VA="Vastai"
#OLD_STR_PRE_VA="va"
OLD_STR_MAJ_VG="VG1000"

NEW_STR_MIN_VA="daocloud"
NEW_STR_MAJ_VA="DaoCloud"
NEW_STR_HUMP_VA="Daocloud"
#NEW_STR_PRE_VA="dc"
NEW_STR_MAJ_VG="DC1000"

CUR_PATH=$(readlink -f "$(dirname "$0")")
SRC_ROOT="${CUR_PATH}/.."
OUT_DIR="${SRC_ROOT}"


# 0. change to source tree and make clean
cd $SRC_ROOT
make clean

# 1. string substitution
# 1.1 .c and .h
find -name "*.[ch]" | xargs sed -i 's/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g'
find -name "*.[ch]" | xargs sed -i 's/'${OLD_STR_MAJ_VA}'/'${NEW_STR_MAJ_VA}'/g'
find -name "*.[ch]" | xargs sed -i 's/'${OLD_STR_HUMP_VA}'/'${NEW_STR_HUMP_VA}'/g'
find -name "*.[ch]" | xargs sed -i 's/'${OLD_STR_MAJ_VG}'/'${NEW_STR_MAJ_VG}'/g'
#find -name "*.[ch]" | xargs sed -i 's/'${OLD_STR_PRE_VA}'/'${NEW_STR_PRE_VA}'/g'

# 1.2 Misc files
find -name "Makefile" | xargs sed -i 's/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g'
find -name "Makefile" | xargs sed -i 's/'${OLD_STR_MAJ_VA}'/'${NEW_STR_MAJ_VA}'/g'
find -name "Makefile" | xargs sed -i 's/'${OLD_STR_HUMP_VA}'/'${NEW_STR_HUMP_VA}'/g'
#find -name "Makefile" | xargs sed -i 's/'${OLD_STR_PRE_VA}'/'${NEW_STR_PRE_VA}'/g'

find -name "*.mk" | xargs sed -i 's/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g'
find -name "*.mk" | xargs sed -i 's/'${OLD_STR_MAJ_VA}'/'${NEW_STR_MAJ_VA}'/g'
find -name "*.mk" | xargs sed -i 's/'${OLD_STR_HUMP_VA}'/'${NEW_STR_HUMP_VA}'/g'
#find -name "*.mk" | xargs sed -i 's/'${OLD_STR_PRE_VA}'/'${NEW_STR_PRE_VA}'/g'

find -name "*.py" | xargs sed -i 's/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g'
find -name "*.py" | xargs sed -i 's/'${OLD_STR_MAJ_VA}'/'${NEW_STR_MAJ_VA}'/g'
find -name "*.py" | xargs sed -i 's/'${OLD_STR_HUMP_VA}'/'${NEW_STR_HUMP_VA}'/g'
#find -name "*.py" | xargs sed -i 's/'${OLD_STR_PRE_VA}'/'${NEW_STR_PRE_VA}'/g'

sed -i 's/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g' .gitignore

cd dkms
sed -i 's/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g' `grep -rn --exclude="mk_novastai_sg100.sh" "${OLD_STR_MIN_VA}" . | awk -F : '{print $1}'`
sed -i 's/'${OLD_STR_MAJ_VA}'/'${NEW_STR_MAJ_VA}'/g' `grep -rn --exclude="mk_novastai_sg100.sh" "${OLD_STR_MAJ_VA}" . | awk -F : '{print $1}'`
sed -i 's/'${OLD_STR_HUMP_VA}'/'${NEW_STR_HUMP_VA}'/g' `grep -rn --exclude="mk_novastai_sg100.sh" "${OLD_STR_HUMP_VA}" . | awk -F : '{print $1}'`
#sed -i 's/'${OLD_STR_PRE_VA}'/'${NEW_STR_PRE_VA}'/g' `grep -rn --exclude="mk_novastai_sg100.sh" "${OLD_STR_PRE_VA}" . | awk -F : '{print $1}'`
#sed -i 's/'${OLD_STR_MAJ_VG}'/'${NEW_STR_MAJ_VG}'/g' `grep -rn --exclude="mk_novastai_sg100.sh" "${OLD_STR_MAJ_VG}" . | awk -F : '{print $1}'`
cd ..

# 2. rename files
mv tool/"${OLD_STR_MIN_VA}"_user_lib tool/"${NEW_STR_MIN_VA}"_user_lib
mv tool/"${OLD_STR_MIN_VA}"_dump tool/"${NEW_STR_MIN_VA}"_dump
mv tool/"${OLD_STR_MIN_VA}"_jtag tool/"${NEW_STR_MIN_VA}"_jtag
find . -path "./dkms/mk_no"${OLD_STR_MIN_VA}"_sg100.sh" -prune -o -name "*${OLD_STR_MIN_VA}*" -print | sed -e 'p;s/'${OLD_STR_MIN_VA}'/'${NEW_STR_MIN_VA}'/g' | xargs -n2 mv

# 3. restore node name
find -name "*.[ch]" | xargs sed -i 's/'${NEW_STR_MIN_VA}'%d_ctl/'${OLD_STR_MIN_VA}'%d_ctl/g'
find -name "*.[ch]" | xargs sed -i 's/'${NEW_STR_MIN_VA}'_version_%d/'${OLD_STR_MIN_VA}'_version_%d/g'
find -name "*.[ch]" | xargs sed -i 's/'${NEW_STR_MIN_VA}'_video%d/'${OLD_STR_MIN_VA}'_video%d/g'

# 4. restore modinfo
find -name "*.[ch]" | xargs sed -i 's/'${NEW_STR_MIN_VA}'tech.com/'${OLD_STR_MIN_VA}'tech.com/g'
