%{?!module_name: %{error: You did not specify a module name (%%module_name)}}
%{?!version: %{error: You did not specify a module version (%%version)}}
%{?!kernel_versions: %{error: You did not specify kernel versions (%%kernel_version)}}
%{?!packager: %define packager DKMS <dkms-devel@lists.us.dell.com>}
%{?!license: %define license Unknown}
%{?!_dkmsdir: %define _dkmsdir /var/lib/dkms}
%{?!_srcdir: %define _srcdir %_prefix/src}
%{?!_datarootdir: %define _datarootdir %{_datadir}}
%define VASTAI_FW_PATH /lib/firmware/va/sgpu100
%define VASTAI_FW_LIST va_bl1.bin va_fw.bin


Summary:	%{module_name} %{version} dkms package
Name:		%{module_name}
Version:	%{version}
License:	%license
Release:	dkms
BuildArch:	aarch64
Group:		System/Kernel
Requires: 	dkms >= 1.95
BuildRequires: 	dkms
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root/


%description
Kernel modules for %{module_name} %{version} in a DKMS wrapper.


%prep
if [ "%mktarball_line" != "none" ]; then
	/usr/sbin/dkms mktarball -m %module_name -v %version %mktarball_line --archive `basename %{module_name}-%{version}.dkms.tar.gz`
	cp -af %{_dkmsdir}/%{module_name}/%{version}/tarball/`basename %{module_name}-%{version}.dkms.tar.gz` %{module_name}-%{version}.dkms.tar.gz
fi

%pre
if [ $1 == 1 ]; then
	echo -e "[Initial installation] Start"
elif [ $1 == 2 ]; then
	echo -e "[Upgrade] Start"
else
	echo "[ERROR] Invalid $1 value, neither install nor upgrade, abort!"
	exit 1
fi

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi
mkdir -p $RPM_BUILD_ROOT/%{_srcdir}
mkdir -p $RPM_BUILD_ROOT/%{_datarootdir}/%{module_name}

if [ -d %{_sourcedir}/%{module_name}-%{version} ]; then
	cp -Lpr %{_sourcedir}/%{module_name}-%{version} $RPM_BUILD_ROOT/%{_srcdir}
fi

if [ -f %{module_name}-%{version}.dkms.tar.gz ]; then
	install -m 644 %{module_name}-%{version}.dkms.tar.gz $RPM_BUILD_ROOT/%{_datarootdir}/%{module_name}
fi

if [ -f %{_sourcedir}/common.postinst ]; then
	install -m 755 %{_sourcedir}/common.postinst $RPM_BUILD_ROOT/%{_datarootdir}/%{module_name}/postinst
fi

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi


%post
if [ $1 == 1 ];then
	if [ ! -d %{VASTAI_FW_PATH} ]; then
		mkdir -p %{VASTAI_FW_PATH}
	fi

	for BIN_NAME in %{VASTAI_FW_LIST}; do
		if [ -f %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME ]; then
			cp %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME %{VASTAI_FW_PATH}
		else
			echo -e "[WARN]: Copying $BIN_NAME to %{VASTAI_FW_PATH} failed"
		fi
	done

	if [ -f %{_srcdir}/%{module_name}-%{version}/va.rules ]; then
		install -m 644 %{_srcdir}/%{module_name}-%{version}/va.rules /etc/udev/rules.d/
		echo "[Initial installation] Install udev rules done!"
	else
		echo "[ERROR]: Find %{_srcdir}/%{module_name}-%{version}/va.rules failed!"
		exit 1
	fi

	for POSTINST in %{_prefix}/lib/dkms/common.postinst %{_datarootdir}/%{module_name}/postinst; do
		if [ -f $POSTINST ]; then
			findResult=$(find /lib/modules -name va_pci.ko*)
			if [[ ${findResult} != "" ]]; then
				rm -rf ${findResult}
				echo "[Initial installation] Remove ${findResult} done!"
			fi

			$POSTINST %{module_name} %{version} %{_datarootdir}/%{module_name}
			if [ $? != 0 ]; then
				if grep -q 'Error\|failed\|error' /var/lib/dkms/%{module_name}/%{version}/build/make.log > /dev/null 2>&1
				then
					cat /var/lib/dkms/%{module_name}/%{version}/build/make.log
				fi
				echo "[Initial installation] [ERROR]: Installation failed!"
				exit 1
			fi

			udevadm control --reload
			udevadm trigger --action=add
			exit 0
		fi
		echo "[Initial installation] [WARNING]: $POSTINST does not exist."
	done
	exit 1

elif [ $1 == 2 ];then
	rm -rf %{VASTAI_FW_PATH}
	if [ $? -eq 0 ]; then
		echo "[Upgrade] Remove old directory %{VASTAI_FW_PATH} done!"
	else
		echo "[Upgrade] [WARNING] Old directory %{VASTAI_FW_PATH} is not removed!"
	fi

	rmmod va-pci
	if [ $? -eq 0 ]; then
		echo "[Upgrade] Remove old driver done!"
	else
		echo "[Upgrade] [WARNING] Old driver is not removed!"
	fi

	findResult=$(find /lib/modules -name va_pci.ko*)
	if [[ ${findResult} != "" ]]; then
		rm -rf ${findResult}
		echo "[Upgrade] Remove old file ${findResult}!"
	fi

	if [ ! -d %{VASTAI_FW_PATH} ]; then
		mkdir -p %{VASTAI_FW_PATH}
		echo "[Upgrade] Create directory %{VASTAI_FW_PATH}!"
	else
		echo "[Upgrade] %{VASTAI_FW_PATH} direction already exist"
	fi

	for BIN_NAME in %{VASTAI_FW_LIST}; do
		if [ -f %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME ]; then
			cp %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME %{VASTAI_FW_PATH}
		else
			echo -e "[Upgrade] [WARNING]: Query file $BIN_NAME failed!"
		fi
	done

	if [ -f %{_srcdir}/%{module_name}-%{version}/va.rules ]; then
		install -m 644 %{_srcdir}/%{module_name}-%{version}/va.rules /etc/udev/rules.d/
		echo "[Upgrade] Install udev rules done!"
	else
		echo "[Upgrade] ERROR: Find file %{_srcdir}/%{module_name}-%{version}/va.rules fail!"
		exit 1
	fi

	for POSTINST in %{_prefix}/lib/dkms/common.postinst %{_datarootdir}/%{module_name}/postinst; do
		if [ -f $POSTINST ]; then
			findResult=$(find /lib/modules -name va_pci.ko*)
			if [[ ${findResult} != "" ]]; then
				rm -rf ${findResult}
				echo "[Upgrade] Remove ${findResult} done!"
			fi

			$POSTINST %{module_name} %{version} %{_datarootdir}/%{module_name}
			if [ $? != 0 ]; then
				if grep -q 'Error\|failed\|error' /var/lib/dkms/%{module_name}/%{version}/build/make.log > /dev/null 2>&1
				then
					cat /var/lib/dkms/%{module_name}/%{version}/build/make.log
				fi
				echo "[Upgrade] [ERROR]: Installation failed!"
				exit 1
			fi

			udevadm control --reload
			udevadm trigger --action=add
			exit 0
		fi
		echo "[Upgrade] [WARNING]: $POSTINST does not exist."
	done
	exit 1
else
	echo "[ERROR] Invalid $1 value, neither install nor upgrade, abort!"
	exit 1
fi


%preun
if [ "$1" = "0" ]; then
	echo -e "\n[Uninstall] Uninstall of %{module_name} module (version %{version}) beginning: \n"
	rmmod va-pci
	if [ $? -eq 0 ]; then
		echo "[Uninstall] Remove $(echo %{module_name} | awk -F '-' '{print $1}') done!"
	fi

	rm -rf %{VASTAI_FW_PATH}

	dkms remove -m %{module_name} -v %{version} --all --rpm_safe_upgrade

	findResult=$(find /lib/modules -name va_pci.ko*)
	if [[ ${findResult} != "" ]]; then
		rm -rf ${findResult}
		echo "[Uninstall] Remove ${findResult} done!"
	fi

elif [ "$1" = "1" ]; then
	echo "[Upgrade] remove %{module_name}-%{version} in dkms"
	dkms remove -m %{module_name} -v %{version} --all --rpm_safe_upgrade
else
	echo "[ERROR] Invalid $1 value, neither install nor upgrade, abort!"
	exit 1
fi


%files
%defattr(-,root,root)
%{_srcdir}
%{_datarootdir}/%{module_name}/


%changelog
* %(date "+%a %b %d %Y") %packager %{version}-%{release}
- Automatic build by DKMS
