#include "vastai_pci.h"
#include "../va_irq.h"
#include "hw_config.h"
#include "vastai_pcie_public.h"
#include "hw_queue.h"
#include "vastai_pci.h"
#include "vastai_cmd.h"
#include "../smmu.h"
#include "vastai_fifo.h"
#include "sg100_cmd.h"
#include "../vsync/va_vsync.h"
#include "msgq_struct_share.h"

static int g_dsu_ring_buf_index;

static int dsu_msix_handler(struct vastai_pci_info *priv, struct vdm_irq_data *msix_info)
{
	VASTAI_PCI_INFO(priv, DUMMY_DIE_ID, "%s\n", __func__);
	return 0;
}

static void dsu_msix_callback(void *arg)
{
	int ret;
	struct vastai_pci_info *priv = (struct vastai_pci_info *) arg;
	struct vdm_irq_data irq_msg;
	while (1) {
		if(vastai_pci_receive_msg(priv, 0, g_dsu_ring_buf_index, &irq_msg)){
			break;
		}
		ret = dsu_msix_handler(priv,&irq_msg);
		if (ret) {
			VASTAI_PCI_ERR(NULL, DUMMY_DIE_ID, "dsu_msix_handler failed\n");
		}
	}

	return;
}

int dsu_to_host_msix_init(struct vastai_pci_info *priv)
{
	int ret;

	if (1 != priv->priv_hw_cfg->sys_cfg.dp_en)
		return -EIO;

	VASTAI_PCI_INFO(priv, DUMMY_DIE_ID, "%s\n", __func__);

	switch (priv->priv_hw_cfg->sys_cfg.fn_mode)
	{
		case ONLY_1_PF:
			ret = va_register_pcie_interrupt(priv, ONLY_1_PF_MSIX_DSU_VECTOR, dsu_msix_callback, priv);
			g_dsu_ring_buf_index = ONLY_1PF_DISPLAY_D2H_BUF;
			break;
		
		case ONLY_2_PF:
			ret = va_register_pcie_interrupt(priv, ONLY_2_PF_MSIX_DSU_VECTOR, dsu_msix_callback, priv);
			g_dsu_ring_buf_index = ONLY_2PF_DISPLAY_D2H_BUF;
			break;

		default:
			ret = -EIO;
			break;
	}
	if (ret) {
		VASTAI_PCI_ERR(priv, DUMMY_DIE_ID, "%s: va_register_pcie_interrupt() fail!, %d\n", __func__, ret);
		ret = -EIO;
	}

	return ret;
}
