#ifndef __VASTAI_RAS_H__
#define __VASTAI_RAS_H__
/* define core num */
#define CORE_POINT_SMCU				(0)					/* 0x942058 */
#define CORE_POINT_PMCU				(1)					/* 0x94205C */
#define CORE_POINT_CMCU				(2)					/* 0x942060 */
#define CORE_POINT_OMCU0			(3)					/* 0x942064 */
#define CORE_POINT_OMCU1			(4)					/* 0x942068 */
#define CORE_POINT_GMCU0			(5)					/* 0x94206C */
#define CORE_POINT_GMCU1			(6)					/* 0x942070 */
#define CORE_POINT_GMCU2			(7)					/* 0x942074 */
#define CORE_POINT_GMCU3			(8)					/* 0x942078 */
#define CORE_POINT_VEMCU0			(9)					/* 0x94207C */
#define CORE_POINT_VEMCU1			(10)				/* 0x942080 */
#define CORE_POINT_VEMCU2			(11)				/* 0x942084 */
#define CORE_POINT_VEMCU3			(12)				/* 0x942088 */
#define CORE_POINT_ODSP0			(13)				/* 0x94208C */
#define CORE_POINT_ODSP1			(14)				/* 0x942090 */
#define CORE_POINT_VDSP0			(15)				/* 0x942094 */
#define CORE_POINT_VDSP1			(16)				/* 0x942098 */
#define CORE_POINT_VDMCU0			(CORE_POINT_GMCU0)	/* GMCU0/2 will be used as VDMCU0/1 */
#define CORE_POINT_VDMCU1			(CORE_POINT_GMCU2)
#define CORE_TOTAL_NUM				(17)

void vastai_pci_vemcu_reset_ack(struct vastai_pci_info *priv, struct pcie_transfer_cmd *msix_info);
void vastai_pci_vemcu_exception(struct vastai_pci_info *priv, struct pcie_transfer_cmd *msix_info);
void vastai_pci_video_exception(struct vastai_pci_info *priv, struct pcie_transfer_cmd *msix_info);
void vastai_exception_init(struct vastai_pci_info *priv);
void vastai_heartbeart_monitor_deinit(struct vastai_pci_info *priv);
void vastai_heartbeat_monitor_init(struct vastai_pci_info *priv);
char* core_name(struct vastai_pci_info *priv,u8 core_id);
void check_soc(struct vastai_pci_info *priv);
void vastai_pci_mcux_exception(struct vastai_pci_info *priv, struct pcie_transfer_cmd *msix_info);
void vastai_pci_mcux_reset_ack(struct vastai_pci_info *priv, struct pcie_transfer_cmd *msix_info);
void vastai_pci_msg1_exception(struct vastai_pci_info *priv, struct pcie_transfer_cmd *msix_info);
int vastai_gfx_reset(void *pci_info);
void vastai_gfx_will_reset(struct vastai_pci_info *priv,struct pcie_transfer_cmd *reset_info);
void vastai_gfx_reset_done(struct vastai_pci_info *priv);
void pf_unload_meta_fw(struct vastai_pci_info *priv);
void pf_load_meta_fw(struct vastai_pci_info *priv);
#endif