#ifndef __VA_INVENTORY_H__
#define __VA_INVENTORY_H__


#define CARD_ID_ERROR_DEFAULT_CODE   0x1EC6EFEF
#define CARD_ID_EMPTY_DEFAULT_CODE   0x1EC60200

#define TLV_START_ADDR   			 12
#define INVENTORY_CODE_MAX_SZ        256
#define MAX_INVENTORY_ITEM_NUM       30

typedef enum
{
	Nothing = 0,
	Model_Name,
	HW_Version,
	Product_SN,
	MFG_PN,
	PCB_Supplier,
	Mech_Supplier,
	Manufacturer,
	MFG_Date,
	Main_Chip_PN,
	Main_Chip_Version,
	Max_Power,
	Main_Chip_Quantity,
	Single_Memory_Chip_Capacity,
	Memory_Chip_Quantity_Per_Main_Chip,
	Input_Clock_Type,
	Input_Clock_Frequency,
	PCIe_Max_Lane_Num,
	PCIe_Max_Speed,
	Core_OT_Throttling_Threshold,
	Core_OT_Shutdown_Threshold,
	Inlet_OT_Throttling_Threshold,
	Inlet_OT_Shutdown_Threshold,
	Outlet_OT_Throttling_Threshold,
	Outlet_OT_Shutdown_Threshold,
	GF_OC_Throttling_Threshold,
	GF_OC_Shutdown_Threshold,
	AUX1_OC_Throttling_Threshold,
	AUX1_OC_Shutdown_Threshold,
	AUX2_OC_Throttling_Threshold,
	AUX2_OC_Shutdown_Threshold,
	DP_Interface_Support,
}inventory_type;

void show_inventory_info(struct vastai_pci_info *priv);
u8 va_read_parse_inventory(struct vastai_pci_info* priv);
u8* va_get_model_name(void *pci_info);
u8* va_get_product_sn(void *pci_info);
#endif