#ifndef __VA_HW_CONFIG_H__
#define __VA_HW_CONFIG_H__

#include "va_hw_init.h"
#include "../../common/sg100_gmcu.h"
#include "pcie_2_dma.h"
#include "../../gfx/gfx_drv.h"
#include "sdma.h"
#include "smmu.h"

/**
 * mode of va_dev_owner for sg100
 */
#define SG100_MODE_STANDALONE 0

/**
 * Enable SDMA. Only one of SDMA & pcie2 dma can be used in the system
 * we plan to assign each VF's two dedicate channel for gfx data transfer (low priority and high priority, total is 28x2), 
 * 4 channels for encoder to transmit video streams (each channel per core), and remain 4 channels for PF usage or other purpose.
 * Dma channel assignment is not hardcoded, Sw can assign dma channel as requir.
 */
#if 0
struct vastai_sdma_cfg va_sdma_cfgs[] = {
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 0),
		.name = "va_sdma0",
		.device_id = 0,
		.irq_num = PCIE2_HDMA0_IRQ,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch0",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 8),
		.name = "va_sdma1",
		.device_id = 8,
		.irq_num = PCIE2_HDMA0_IRQ + 1,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch1",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 9),
		.name = "va_sdma2",
		.device_id = 9,
		.irq_num = PCIE2_HDMA0_IRQ + 2,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch2",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 10),
		.name = "va_sdma3",
		.device_id = 10,
		.irq_num = PCIE2_HDMA0_IRQ + 3,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch3",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	//pf1
		{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 1),
		.name = "va_sdma8",
		.device_id = 1,
		.irq_num = PCIE2_HDMA1_IRQ,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch8",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 16),
		.name = "va_sdma9",
		.device_id = 16,
		.irq_num = PCIE2_HDMA1_IRQ + 1,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch9",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 17),
		.name = "va_sdma10",
		.device_id = 17,
		.irq_num = PCIE2_HDMA1_IRQ + 2,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch10",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 18),
		.name = "va_sdma11",
		.device_id = 18,
		.irq_num = PCIE2_HDMA1_IRQ + 3,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch11",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	//pf2
		{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 2),
		.name = "va_sdma16",
		.device_id = 2,
		.irq_num = PCIE2_HDMA2_IRQ,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch16",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 24),
		.name = "va_sdma17",
		.device_id = 24,
		.irq_num = PCIE2_HDMA2_IRQ + 1,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch17",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 25),
		.name = "va_sdma18",
		.device_id = 25,
		.irq_num = PCIE2_HDMA2_IRQ + 2,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch18",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 26),
		.name = "va_sdma19",
		.device_id = 26,
		.irq_num = PCIE2_HDMA2_IRQ + 3,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch19",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	//pf3
		{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 3),
		.name = "va_sdma24",
		.device_id = 3,
		.irq_num = PCIE2_HDMA3_IRQ,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch24",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 32),
		.name = "va_sdma25",
		.device_id = 32,
		.irq_num = PCIE2_HDMA3_IRQ + 1,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch25",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 33),
		.name = "va_sdma26",
		.device_id = 33,
		.irq_num = PCIE2_HDMA3_IRQ + 2,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch26",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 34),
		.name = "va_sdma27",
		.device_id = 34,
		.irq_num = PCIE2_HDMA3_IRQ + 3,
		.ch0_cfg = VASTAI_SDMA_CH_CFG_ITEM("sdma0_ch27",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0),
	},
};
#endif

#if 0
//smmu cfg
struct vastai_smmu_cfg va_smmu_cfgs[] = {
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 0),
		.name = "va_smmu0",
		.device_id = 0,
		.stream_id = 0,
		.sub_streamid = 0,
		.vmid = 0,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu0",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu0",
				0x1041000000,
				0x1041000000 + 0x100000,
				0x1041000000 + 0x110000,
				0x1041000000 + 0x120000,
				0x1041000000 + 0x130000),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 8),
		.name = "va_smmu1",
		.device_id = 8,
		.stream_id = 1,
		.sub_streamid = 0,
		.vmid = 1,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu1",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu1",
				0x1047000000,
				0x1047000000 + 0x100000,
				0x1047000000 + 0x110000,
				0x1047000000 + 0x120000,
				0x1047000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 9),
		.name = "va_smmu2",
		.device_id = 9,
		.stream_id = 2,
		.sub_streamid = 0,
		.vmid = 2,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu2",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu2",
				0x108d000000,
				0x108d000000 + 0x100000,
				0x108d000000 + 0x110000,
				0x108d000000 + 0x120000,
				0x108d000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 10),
		.name = "va_smmu3",
		.device_id = 10,
		.stream_id = 3,
		.sub_streamid = 0,
		.vmid = 3,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu3",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu3",
				0x10d3000000,
				0x10d3000000 + 0x100000,
				0x10d3000000 + 0x110000,
				0x10d3000000 + 0x120000,
				0x10d3000000 + 0x130000),


	},
	//pf1
		{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 1),
		.name = "va_smmu8",
		.device_id = 1,
		.stream_id = 8,
		.sub_streamid = 0,
		.vmid = 8,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu8",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu8",
				0x1231000000,
				0x1231000000 + 0x100000,
				0x1231000000 + 0x110000,
				0x1231000000 + 0x120000,
				0x1231000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 16),
		.name = "va_smmu9",
		.device_id = 16,
		.stream_id = 9,
		.sub_streamid = 0,
		.vmid = 9,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu9",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu9",
				0x1237000000,
				0x1237000000 + 0x100000,
				0x1237000000 + 0x110000,
				0x1237000000 + 0x120000,
				0x1237000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 17),
		.name = "va_smmu10",
		.device_id = 17,
		.stream_id = 10,
		.sub_streamid = 0,
		.vmid = 10,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu10",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu10",
				0x127d000000,
				0x127d000000 + 0x100000,
				0x127d000000 + 0x110000,
				0x127d000000 + 0x120000,
				0x127d000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 18),
		.name = "va_smmu11",
		.device_id = 18,
		.stream_id = 11,
		.sub_streamid = 0,
		.vmid = 11,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu11",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu11",
				0x12c3000000,
				0x12c3000000 + 0x100000,
				0x12c3000000 + 0x110000,
				0x12c3000000 + 0x120000,
				0x12c3000000 + 0x130000),


	},
	//pf2
		{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 2),
		.name = "va_smmu16",
		.device_id = 2,
		.stream_id = 16,
		.sub_streamid = 0,
		.vmid = 16,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu16",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu16",
				0x1421000000,
				0x1421000000 + 0x100000,
				0x1421000000 + 0x110000,
				0x1421000000 + 0x120000,
				0x1421000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 24),
		.name = "va_smmu17",
		.device_id = 24,
		.stream_id = 17,
		.sub_streamid = 0,
		.vmid = 17,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu17",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu17",
				0x1427000000,
				0x1427000000 + 0x100000,
				0x1427000000 + 0x110000,
				0x1427000000 + 0x120000,
				0x1427000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 25),
		.name = "va_smmu18",
		.device_id = 25,
		.stream_id = 18,
		.sub_streamid = 0,
		.vmid = 18,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu18",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu18",
				0x146d000000,
				0x146d000000 + 0x100000,
				0x146d000000 + 0x110000,
				0x146d000000 + 0x120000,
				0x146d000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 26),
		.name = "va_smmu19",
		.device_id = 26,
		.stream_id = 19,
		.sub_streamid = 0,
		.vmid = 19,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu19",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu19",
				0x14b3000000,
				0x14b3000000 + 0x100000,
				0x14b3000000 + 0x110000,
				0x14b3000000 + 0x120000,
				0x14b3000000 + 0x130000),


	},
	//pf3
		{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 3),
		.name = "va_smmu24",
		.device_id = 3,
		.stream_id = 24,
		.sub_streamid = 0,
		.vmid = 24,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu24",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu24",
				0x1611000000,
				0x1611000000 + 0x100000,
				0x1611000000 + 0x110000,
				0x1611000000 + 0x120000,
				0x1611000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 32),
		.name = "va_smmu25",
		.device_id = 32,
		.stream_id = 25,
		.sub_streamid = 0,
		.vmid = 25,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu25",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu0",
				0x1617000000,
				0x1617000000 + 0x100000,
				0x1617000000 + 0x110000,
				0x1617000000 + 0x120000,
				0x1617d000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 33),
		.name = "va_smmu26",
		.device_id = 33,
		.stream_id = 26,
		.sub_streamid = 0,
		.vmid = 26,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu26",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu26",
				0x165d000000,
				0x165d000000 + 0x100000,
				0x165d000000 + 0x110000,
				0x165d000000 + 0x120000,
				0x165d000000 + 0x130000),


	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 34),
		.name = "va_smmu27",
		.device_id = 34,
		.stream_id = 27,
		.sub_streamid = 0,
		.vmid = 27,
		.asid = 0,
		.smmu_msgq_cfg = VASTAI_SMMU_MSGQ_CFG_ITEM("smmu27",
				0,
				0,
				0),
		.smmu_entry_cfg = VASTAI_SMMU_ENTRY_CFG_ITEM("smmu27",
				0x16a3000000,
				0x16a3000000 + 0x100000,
				0x16a3000000 + 0x110000,
				0x16a3000000 + 0x120000,
				0x16a3000000 + 0x130000),


	},
};
#endif

/**
 * pcie2 dma config
 */
#define PCIE2_DMA_ENABLE  0
#define PCIE2_DMA_RAW_ENABLE  0
struct pcie2_dma_cfg pcie2_dma_cfgs[] = {
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 0),
		.name = "pcie2_dma0",
		.device_id = 0,
		.irq_num = PCIE2_HDMA0_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma0_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma0_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},	
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 1),
		.name = "pcie2_dma1",
		.device_id = 1,
		.irq_num = PCIE2_HDMA1_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma1_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma1_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 2),
		.name = "pcie2_dma2",
		.device_id = 2,
		.irq_num = PCIE2_HDMA2_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma2_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma2_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 3),
		.name = "pcie2_dma3",
		.device_id = 3,
		.irq_num = PCIE2_HDMA3_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma3_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma3_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
    {
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 4),
		.name = "pcie2_dma4",
		.device_id = 4,
		.irq_num = PCIE2_HDMA3_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma4_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma4_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 5),
		.name = "pcie2_dma5",
		.device_id = 5,
		.irq_num = PCIE2_HDMA3_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma5_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma5_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 6),
		.name = "pcie2_dma6",
		.device_id = 6,
		.irq_num = PCIE2_HDMA3_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma6_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma6_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
	{
		.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, 7),
		.name = "pcie2_dma7",
		.device_id = 7,
		.irq_num = PCIE2_HDMA3_IRQ,
		.wr_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma7_wr",
				PCIE2_DMA_WR_DEV_TO_MEM,
				0,
				0,
				0,
				15),
		.rd_cfg = PCIE2_DMA_CFG_ITEM("pcie2_dma7_rd",
				PCIE2_DMA_RD_MEM_TO_DEV,
				0,
				0,
				0,
				15),
	},
};

//SG100_GFX1_REG_BASE

/**
 * gfx heap and reg config
 */
#define GFX_CFG(__num) {	\
	.owner = VA_DEV_OWNER(SG100_MODE_STANDALONE, __num),	\
	.regs = VA_ADDR_REGION(2,				\
			       SG100_GFX_REG_OFFSET,	\
			       SG100_GFX##__num##_REG_BASE,	\
			       SG100_GFX_REG_SIZE),		\
	.gfx_heap = VA_ADDR_REGION(SG100_DDR_GFX_BAR,			\
				   SG100_GFX_HEAP_BAR_OFFSET,		\
				   SG100_DDR_GFX##__num##_BASE		\
				    + SG100_GFX_HEAP_DEV_OFFSET,	\
				   SG100_GFX_HEAP_SIZE),		\
	.disp_heap = VA_ADDR_REGION(SG100_DDR_GFX_BAR,			\
				    SG100_DISP_HEAP_BAR_OFFSET,		\
				    SG100_DDR_GFX##__num##_BASE		\
				     + SG100_DISP_HEAP_DEV_OFFSET,	\
				    SG100_DISP_HEAP_SIZE),		\
}

#define VA_GFX_ENABLE 1
struct va_gfx_cfg gfx_cfg;
struct va_gfx_cfg gfx_cfgs[] = {
	GFX_CFG(0),
	GFX_CFG(1),
	GFX_CFG(2),
	GFX_CFG(3),
};

#endif
