########################################################################### ###
#@File
#@Copyright     Copyright (c) Imagination Technologies Ltd. All Rights Reserved
#@License       Dual MIT/GPLv2
#
# The contents of this file are subject to the MIT license as set out below.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# Alternatively, the contents of this file may be used under the terms of
# the GNU General Public License Version 2 ("GPL") in which case the provisions
# of GPL are applicable instead of those above.
#
# If you wish to allow use of your version of this file only under the terms of
# GPL, and not to allow others to use your version of this file under the terms
# of the MIT license, indicate your decision by deleting the provisions above
# and replace them with the notice and other provisions required by GPL as set
# out in the file called "GPL-COPYING" included in this distribution. If you do
# not delete the provisions above, a recipient may use your version of this file
# under the terms of either the MIT license or GPL.
#
# This License is also included in this distribution in the file called
# "MIT-COPYING".
#
# EXCEPT AS OTHERWISE STATED IN A NEGOTIATED AGREEMENT: (A) THE SOFTWARE IS
# PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
# BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
# PURPOSE AND NONINFRINGEMENT; AND (B) IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
### ###########################################################################

MODULE_HOST_BUILD := true

MODULE_AR := $(HOST_AR)
MODULE_CC := $(HOST_CC)
MODULE_CXX := $(HOST_CXX)
MODULE_NM := $(HOST_NM)
MODULE_OBJCOPY := $(HOST_OBJCOPY)
MODULE_RANLIB := $(HOST_RANLIB)
MODULE_STRIP := $(HOST_STRIP)

MODULE_CFLAGS   := $(ALL_HOST_CFLAGS) $($(THIS_MODULE)_cflags)
MODULE_CXXFLAGS := $(ALL_HOST_CXXFLAGS) $($(THIS_MODULE)_cxxflags)
MODULE_LDFLAGS  := $(ALL_HOST_LDFLAGS) -L$(MODULE_OUT) $($(THIS_MODULE)_ldflags)

ifeq ($(USE_LLD),1)
 MODULE_LDFLAGS += -fuse-ld=lld
endif

ifneq ($(BUILD),debug)
ifeq ($(USE_LTO),1)
MODULE_LDFLAGS := \
 $(sort $(filter-out -W% -D% -isystem /%,$(ALL_HOST_CFLAGS) $(ALL_HOST_CXXFLAGS))) \
 $(MODULE_LDFLAGS)
endif
endif

ifeq ($(SUPPORT_ANDROID_PLATFORM),1)
 MODULE_LIBRARY_FLAGS_SUBST += \
  clang_rt:$(__clang_bindir)../lib64/clang/$(__clang_version)/lib/linux/libclang_rt.builtins-x86_64-android.a
endif

MESON_CROSS_SYSTEM  := linux
MESON_CROSS_CPU_FAMILY := x86_64
MESON_CROSS_CPU := x86_64
MESON_CROSS_ENDIAN := little
MESON_CROSS_CROSS_COMPILE :=
MESON_CROSS_CC := $(patsubst @%,%,$(HOST_CC))
MESON_CROSS_C_ARGS :=
MESON_CROSS_C_LINK_ARGS :=
MESON_CROSS_CXX := $(patsubst @%,%,$(HOST_CXX))
MESON_CROSS_CXX_ARGS :=
MESON_CROSS_CXX_LINK_ARGS :=
