#ifndef __GFX_DRV_H__
#define __GFX_DRV_H__

#include "../ep_driver/hw/va_hw_init.h"
struct va_addr_region {
	u32 bar_num;
	u64 bar_offset;
	u64 dev_paddr;
	u64 size;
};

#define VA_ADDR_REGION(_bar_num, _bar_offset, _dev_paddr, _size) {	\
	.bar_num = _bar_num,						\
	.bar_offset = _bar_offset,					\
	.dev_paddr = _dev_paddr,					\
	.size = _size,							\
}

struct va_gfx_cfg {
	struct va_dev_owner owner;

	/* rogue-regs */
	struct va_addr_region regs;
	/* gfx heap */
	struct va_addr_region gfx_heap;
	/* display heap */
	struct va_addr_region disp_heap;
	struct va_addr_region display_reg;
	struct va_addr_region dsu_reg;
};

struct va_gfx_render_info
{
	int drm_major;
	int gfx_primary_id; // index in /dev/dri/cardxxx for gfx drm device.
	int gfx_render_id;  // index in /dev/dri/renderxxx for gfx drm device.
};

struct va_gfx_display_info
{
	int drm_major;
	int nulldisp_primary_id; // index in /dev/dri/cardxxx for nulldisp drm device.
};

int va_dma_free_gfx(struct device *dev, void *dma);
int va_pcie_ddk_init(struct vastai_pci_info *priv, struct va_gfx_cfg *cfg);
int va_pcie_ddk_deinit(struct vastai_pci_info *priv);
void RegisterGfxMMCallBack(void *priv, void *heapPtr, u64 (*alloc)(void *, int), void (*free)(void *, u64));
int vastai_get_render_info(struct vastai_pci_info *priv, struct va_gfx_render_info *info);
int vastai_get_display_info(struct vastai_pci_info *priv, struct va_gfx_display_info *info);
int vastai_get_gfx_status(struct vastai_pci_info *priv, u32 cmd, u64 cmd_args, u32 cmd_args_size, u64 info, u32 info_size);
void va_install_pvr_devnode(void *priv, void *dev_node);
void va_print_pci_devid(void *priv);

#endif
