#include "gfx_mm.h"

PVRSRV_DEVICE_NODE *g_psDevNode = NULL;
static PG_HANDLE_HEAP *g_psPGHandleList = NULL;

IMG_UINT64 alloc_physmem_by_ddk(void *priv, IMG_UINT32 ui32MemSize)
{
    PVRSRV_ERROR ret = PVRSRV_OK;
        IMG_DEV_PHYADDR sDevPhysAddr_int = {0};
        IMG_PID uiPid = 0;

    PG_HANDLE_HEAP *psHandleHeap = kmalloc(sizeof(PG_HANDLE_HEAP), GFP_KERNEL);

    if (psHandleHeap == NULL)
    {   
        PVR_DPF((PVR_DBG_ERROR, "%s: kmalloc for psHandleHeap failed error: %d.", __func__, ret));
        return 0;  
    }   

    ret = PhysHeapPagesAlloc(g_psDevNode->apsPhysHeap[PVRSRV_PHYS_HEAP_GPU_LOCAL],
                            ui32MemSize,
                            &psHandleHeap->MemHandle,
                            &sDevPhysAddr_int,
                            uiPid);
    if (ret != PVRSRV_OK)
    {   
        PVR_DPF((PVR_DBG_ERROR, "%s: alloc physmem_lma by ddk failed error: %d.", __func__, ret));
        return 0;
    }   

    psHandleHeap->ps_next = g_psPGHandleList;
    g_psPGHandleList = psHandleHeap;

    return sDevPhysAddr_int.uiAddr;
}

static PG_HANDLE_HEAP *find_handleheap_then_remove_by_addr(IMG_UINT64 DevPhysAddr)
{
    PG_HANDLE_HEAP *psHandleHeapNode = g_psPGHandleList;
    if (psHandleHeapNode == NULL)
    {   
        return NULL;
    }   
    if (psHandleHeapNode != NULL && psHandleHeapNode->MemHandle.u.ui64Handle == DevPhysAddr)
if (psHandleHeapNode != NULL && psHandleHeapNode->MemHandle.u.ui64Handle == DevPhysAddr)
    {
        return psHandleHeapNode;
    }

    while (psHandleHeapNode->ps_next != NULL)
    {
        if (psHandleHeapNode->ps_next->MemHandle.u.ui64Handle == DevPhysAddr)
        {
            psHandleHeapNode->ps_next = psHandleHeapNode->ps_next->ps_next;

            return psHandleHeapNode;
        }
        psHandleHeapNode = psHandleHeapNode->ps_next;
    }

    return NULL;
}

void free_physmem_by_ddk(void *priv, IMG_UINT64 DevPhysAddr)
{
    PG_HANDLE_HEAP *psHandleHeap = NULL;
    psHandleHeap = find_handleheap_then_remove_by_addr(DevPhysAddr);
    if (psHandleHeap == NULL)
    {
        PVR_DPF((PVR_DBG_ERROR, "%s: find physmem_lma by ddk failed.", __func__));
    }
    else
    {
        PhysHeapPagesFree(g_psDevNode->apsPhysHeap[PVRSRV_PHYS_HEAP_GPU_LOCAL], &psHandleHeap->MemHandle);
    }
    kfree(psHandleHeap);
}

