#ifndef __GFX_MM_H__
#define __GFX_MM_H__

#include "services/server/include/device.h"
#include "services/server/include/physmem.h"

typedef struct _PG_HANDLE_HEAP_
{
    PG_HANDLE MemHandle;
    struct _PG_HANDLE_HEAP_ *ps_next;
}PG_HANDLE_HEAP;


/*************************************************************************/ /*!
@Function       alloc_physmem_by_ddk
@Description    alloc physmem_lma by ddk mm api
@Input          priv                pci info
@Input          ui32MemSize         the size of mem alloc
@Return         IMG_UINT64          return physaddr(if 0 means failed)
*/ /**************************************************************************/
IMG_UINT64 alloc_physmem_by_ddk(void *priv, IMG_UINT32 ui32MemSize);

/*************************************************************************/ /*!
@Function       free_physmem_by_ddk
@Description    free physmem_lma by ddk mm api
@Input          priv                pci info
@Input          DevPhysAddr         phys addr for lma
@Return         void
*/ /**************************************************************************/
void free_physmem_by_ddk(void *priv, IMG_UINT64 DevPhysAddr);

#endif