/*
 * vastai_pci - driver a Vastai PCI device
 * Copyright (C) 2021 Vastai Technologies All Rights Reserved.
 * This work is licensed under the terms of the GNU GPL, version 2.
 *
 * Create on: 2020/09/25
 * Author: gang.wang
 */

#ifndef __VASTAI_DMABUF_H__
#define __VASTAI_DMABUF_H__

#include "vastai_pci.h"
#define VASTAI_MEM_POOL_BUF_SIZE VASTAI_MAX_DMA_BUF
#define VASTAI_MEM_POOL_MIN_NR	 16

struct vastai_buf_list {
	u32 entry_count;
	struct vastai_dma_buf *buf_list[0];
};

struct vastai_dma_buf *get_vastai_dma_buf(struct dma_buf *dma_buf, u32 index);
int vastai_udma_malloc(struct vastai_pci_info *pci_info,
		       struct vastai_dma_buf *dm, int size);
int vastai_udma_free(struct vastai_pci_info *pci_info,
		     struct vastai_dma_buf *dm);
int vastai_mempool_init(struct vastai_pci_info *pci_info);
void vastai_mempool_deinit(struct vastai_pci_info *pci_info);
struct vastai_dma_buf *vastai_mempool_get(struct vastai_pci_info *pci_info,
					  size_t size);
void vastai_mempool_put(struct vastai_pci_info *pci_info,
			struct vastai_dma_buf *dm);
int vastai_dmabuf_init(struct vastai_pci_info *pci_info);
void vastai_dmabuf_deinit(struct vastai_pci_info *pci_info);
int is_vastai_mempool_rich(struct vastai_pci_info *pci_info);
bool iommu_is_enable(struct vastai_pci_info *pci_info);
struct vastai_dma_buf *vastai_dma_buf_sg_get(
			struct vastai_pci_info *pci_info,
			size_t size);
void vastai_dma_buf_sg_put(
			struct vastai_pci_info *pci_info,
			struct vastai_dma_buf *dm);

void vastai_udma_sg_free(struct vastai_pci_info *pci_info,
				struct vastai_dma_buf *dm);

#endif
