/*
 * vastai_pci - driver a Vastai PCI device
 * Copyright (C) 2021 Vastai Technologies All Rights Reserved.
 * This work is licensed under the terms of the GNU GPL, version 2.
 *
 * Create on: 2020/09/25
 * Author: gang.wang
 */

#ifndef _VASTAI_FW_HEX_H
#define _VASTAI_FW_HEX_H


// Below files would locate at file system of user space
#define BL1_PATH  "va/sgpu100/va_bl1.bin"
#define FW_PATH   "va/sgpu100/va_fw.bin"
#define XSPI_FW_BASE_PATH  "va/sgpu100/va_bl0_base.bin"
#define XSPI_FW_VBIOS_PATH "va/sgpu100/va_bl0_vbios.bin"
#define XSPI_FW_BL0_PATH "va/sgpu100/va_bl0.bin"
#define XSPI_FW_FULL_PATH "va/sgpu100/va_bl0_full.bin"
#define XSPI_FW_ALL_PATH "va/sgpu100/va_bl0_all.bin"
#define XSPI_FW_PMCU_PATH "va/sgpu100/va_bl0_pmcu.bin"
#define BMCU_FW_PATH "va/sgpu100/va_bmcu.bin"

// Following files will be wrapped in the ko
#define vastai_bl1_hexcode "../fw/va_bl1.bin.hex"
#define vastai_fw_hexcode  "../fw/va_fw.bin.hex"
#define vastai_xspi_fw_base_hexcode "../fw/va_bl0_base.bin.hex"
#define vastai_xspi_fw_vbios_hexcode "../fw/va_bl0_vbios.bin.hex"
#define vastai_xspi_fw_bl0_hexcode "../fw/va_bl0.bin.hex"
#define vastai_xspi_fw_full_hexcode "../fw/va_bl0_full.bin.hex"
#define vastai_xspi_fw_all_hexcode "../fw/va_bl0_all.bin.hex"
#define vastai_xspi_fw_pmcu_hexcode "../fw/va_bl0_pmcu.bin.hex"
#define vastai_bmcu_fw_hexcode "../fw/va_bmcu.bin.hex"

static unsigned char vastai_bl1_hex_buf[] = {
#include vastai_bl1_hexcode
};

static unsigned char vastai_fw_hex_buf[] = {
#include vastai_fw_hexcode
};

static unsigned char vastai_xspi_fw_base_hex_buf[] = {
#include vastai_xspi_fw_base_hexcode
};

static unsigned char vastai_xspi_fw_vbios_hex_buf[] = {
#include vastai_xspi_fw_vbios_hexcode
};

static unsigned char vastai_xspi_fw_bl0_hex_buf[] = {
#include vastai_xspi_fw_bl0_hexcode
};

static unsigned char vastai_xspi_fw_full_hex_buf[] = {
#include vastai_xspi_fw_full_hexcode
};

static unsigned char vastai_xspi_fw_all_hex_buf[] = {
#include vastai_xspi_fw_all_hexcode
};

static unsigned char vastai_xspi_fw_pmcu_hex_buf[] = {
#include vastai_xspi_fw_pmcu_hexcode
};

static unsigned char vastai_bmcu_fw_hex_buf[] = {
#include vastai_bmcu_fw_hexcode
};

#define VASTAI_BL1_HEX_SIZE sizeof(vastai_bl1_hex_buf)
#define VASTAI_FW_HEX_SIZE  sizeof(vastai_fw_hex_buf)
#define VASTAI_XSPI_FW_BASE_HEX_SIZE sizeof(vastai_xspi_fw_base_hex_buf)
#define VASTAI_XSPI_FW_VBIOS_HEX_SIZE sizeof(vastai_xspi_fw_vbios_hex_buf)
#define VASTAI_XSPI_FW_BL0_HEX_SIZE sizeof(vastai_xspi_fw_bl0_hex_buf)
#define VASTAI_XSPI_FW_FULL_HEX_SIZE sizeof(vastai_xspi_fw_full_hex_buf)
#define VASTAI_XSPI_FW_ALL_HEX_SIZE sizeof(vastai_xspi_fw_all_hex_buf)
#define VASTAI_XSPI_FW_PMCU_HEX_SIZE sizeof(vastai_xspi_fw_pmcu_hex_buf)
#define VASTAI_BMCU_FW_HEX_SIZE sizeof(vastai_bmcu_fw_hex_buf)

#endif /* _VASTAI_FW_HEX_H */
