#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include "uvp_builder.h"
#include "gen_model.h"
#include "run_model.h"

int fd = -1;
int main(int argc, char **argv)
{
    char fileName[256];
    char devName[256];
    char resultPath[256];
    FILE *fp = NULL;
    uint8_t *buf;
    size_t size;
    int ret = 0;
    char *casePath = argv[1];
    int len = strlen(casePath);
    if (casePath[len-1] == '/')
    {
        casePath[len-1] = '\0';
    }
    while (strstr(casePath, "/") != NULL)
    {
        casePath = strstr(casePath, "/") + strlen("/");
    }
    sprintf(fileName, "%s/vastai_uvp_package.dat", argv[1]);
    if (access(fileName, F_OK) == -1)
    {
        printf("case %s does not exist.\n", argv[1]);
	return -1;
    }
    int dev_id = atoi(argv[2]);
    sprintf(devName, "/dev/vacc%d", dev_id);
    fd = open(devName, O_RDWR);
    if (fd < 0)
    {
        printf("open %s failed.\n", devName);
        return -1;
    }
    if (argc > 3)
    {
        if (access(argv[3], F_OK) == -1)
        {
            printf("reslut path does not exist.\n");
            return -1;
        }
        sprintf(resultPath, "%s/%s", argv[3], casePath);
    }
    else
    {
        if (access("./result", F_OK) == -1)
        {
            mkdir("./result", 0755);
        }
        sprintf(resultPath, "./result/%s", casePath);
    }
    if (access(resultPath, F_OK) == -1)
    {
        mkdir(resultPath, 0755);
    }
    fp = fopen(fileName, "rb");
    if (fp == NULL)
    {
        printf("%s open fail.\n", fileName);
	return -1;
    }
    fseek(fp, 0, SEEK_END);
    size = ftell(fp);
    buf = (uint8_t *)malloc(size);
    fseek(fp, 0, SEEK_SET);
    fread(buf, 1, size, fp);
    fclose(fp);
    ns(uvp_package_table_t) uvp_package = ns(uvp_package_as_root(buf));
    if (uvp_package == NULL)
    {
        printf("uvp is null.\n");
	ret = -1;
	goto out;
    }
    model_gen(uvp_package);
    ret = set_input(uvp_package);
    if (ret < 0)
    {
        printf("set input failed.\n");
        goto out;
    }
    ret = run_model(uvp_package);
    if (ret < 0)
    {
        printf("run model failed.\n");
        goto out;
    }
    ret = get_output(uvp_package, resultPath);
    if (ret < 0)
    {
        printf("get output failed.\n");
        goto out;
    }
    ret = compare_result(uvp_package, resultPath);
    if (ret < 0)
    {
        printf("result compare failed.\n");
        goto out;
    }
out:
    model_free();
    free(buf);
    return ret;
}
