#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "vastai_pcie_user_api.h"

typedef unsigned int u32;
typedef unsigned long long int u64;

struct va_ioctk_kchar_cmd {
	union {
		struct {
			u32 size;
			int dma_buf_fd;
		} alloc_cmd;

		struct {
			u32 is_dev_to_host;
			u32 dma_buf_fd;
			u64 axi_addr;
			u32 size;
			u32 die_index;
		} dma_start_cmd;
		struct {
			u32 die_index;
			u32 timeout_water;
			u32 is_timeout;
			void *log_ring_ctl;
		} log_poll_cmd;
	};
};

/* TODO: is this right ? */
void print_mem_u32(void *buf, long long int len)
{
	int i;
	int j;
	for (i = 0; i < len / 16; i++) {
		printf("0x%.08x 0x%.08x 0x%.08x 0x%.08x\n", ((u32 *)buf)[i * 4],
		       ((u32 *)buf)[i * 4 + 1], ((u32 *)buf)[i * 4 + 2],
		       ((u32 *)buf)[i * 4 + 3]);
	}
	for (j = 0; j < (len - i * 16); j++) {
		printf("0x%.08x ", ((u32 *)buf)[i * 4 + j]);
	}
	printf("\n");
}

int main(void)
{
	void *log_ctl_buf = malloc(sizeof(u64) * 2 * 29);

	vastai_get_log_status(log_ctl_buf, 0);
	print_mem_u32(log_ctl_buf, sizeof(u64) * 2 * 29);
	return 0;
}