#!/bin/bash

device_id=0100
device_num=$(lspci -d:$device_id | wc -l)
testcase="ALL"
ko_path="../../va_pci.ko"

function check() {
	for y in $(seq 0 $(($device_num - 1)))
	do
		if [ ! -e /dev/kchar\:$y ]
		then
			echo 'test failed'
			echo "kchar:$y is not exit"
			echo $1 " test failed"
			exit 1
		fi
	done
}

while getopts c:
do
	case $opt in
	c) testcase=$OPTARG;;
	*) echo "ERROR: Unknown option"; exit 2;;
	esac
done

#case 1: test send reset before boot
if [ $testcase=="ALL" ] || [ $testcase=="1" ]
then
	echo "case 1: test send reset before boot"
	for x in {0..10}
	do
		echo loop$x
		insmod $ko_path
		ret=$?
		if [ x$ret != x0 ]
		then
			echo 'insmod ko failed'
			exit $ret
		fi
			check "test case 1" #check!!!!!!
		echo N > /sys/module/vastai_pci/parameters/vastai_pci_reset_out
		rmmod va_pci
		if [ x$ret != x0 ]
		then
			echo 'rmmod ko failed'
			exit $ret
		fi
	done

	insmod $ko_path
	rmmod va_pci
	echo "case 1 success"
fi

#case 2: normal case
if [ $testcase=="ALL" ] || [ $testcase=="2" ]
then
	echo "case 2: normal case"
	for x in {0..10}
	do
		echo loop$x
		insmod $ko_path
		ret=$?
		if [ x$ret != x0 ]
		then
			echo 'insmod ko failed'
			exit $ret
		fi
			check "test case 2" #check!!!!!!
		rmmod va_pci
		if [ x$ret != x0 ]
		then
			echo 'rmmod ko failed'
			exit $ret
		fi
	done

	insmod $ko_path
	rmmod va_pci
	echo "case 2 success"
fi
