#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <malloc.h>
#include <getopt.h>
#include <getopt.h>
#include <unistd.h>

#define VENDOR_ID       0x1ec6
#define DEVICE_ID_0     0x0200
#define DEVICE_ID_1     0x0204
#define SUB_VENDOR_ID   0x1ec6
#define SUB_DEVICE_ID   0x0000

//printf("\033[显示方式;字背景颜色;字体颜色m字符串\033[0m" );
/*
    显示方式:
    1：粗体/高亮
    22：非粗体
    4：单条下划线
    24：无下划线
    5：闪烁
    25：无闪烁
    7：反显、翻转前景色和背景色
    27：无反显
*/

/*
    字背景颜色范围:40----49
    40:黑
    41:深红
    42:绿
    43:黄色
    44:蓝色
    45:紫色
    46:深绿
    47:白色

    字颜色:30-----------39
    30:黑
    31:红
    32:绿
    33:黄
    34:蓝色
    35:紫色
    36:深绿 
    37:白色
    0：默认

*/

static int get_dest_dev_bridge(char* dest_bdf ,char *bridge_path)
{
    DIR *dir = opendir("/sys/bus/pci/devices");
    struct dirent *pdirent = NULL;
    char file_name[128] = {0};
    int fd;
    
    while((pdirent = readdir(dir)) != NULL) {
        // if (NULL == strstr(pdirent->d_name, ".0"))
        //     continue;
        if(strcmp(pdirent->d_name,".")==0 || strcmp(pdirent->d_name,"..")==0)
                continue;

        sprintf(bridge_path, "/sys/bus/pci/devices/%s/config", pdirent->d_name);
        sprintf(file_name,    "/sys/bus/pci/devices/%s/0000:%s", pdirent->d_name , dest_bdf);
        fd = open(file_name, O_RDONLY);
        if (fd < 0) {
            sprintf(file_name,    "/sys/bus/pci/devices/%s/%s", pdirent->d_name , dest_bdf);
            fd = open(file_name, O_RDONLY);
            if(fd < 0){
                continue;
            }            
        } else {
            close(fd);
        }
        close(fd);        
        closedir(dir);        
        return 0;
    }

    closedir(dir);

    return -1;


}

static int get_dest_dev_path(char *dev_path, char* dest_bdf)
{
    DIR *dir = opendir("/sys/bus/pci/devices");
    struct dirent *pdirent = NULL;
    char file_name[128];
    int fd;
    char buf[16];
    
    while((pdirent = readdir(dir)) != NULL) {
        // if (NULL == strstr(pdirent->d_name, ".0"))
        //     continue;
        if(strcmp(pdirent->d_name,".")==0 || strcmp(pdirent->d_name,"..")==0)
                continue;

        sprintf(dev_path,    "/sys/bus/pci/devices/%s/0000:%s/config", pdirent->d_name , dest_bdf);
        fd = open(dev_path, O_RDONLY);
        if (fd < 0) {
            sprintf(dev_path,    "/sys/bus/pci/devices/%s/%s/config", pdirent->d_name , dest_bdf);
            fd = open(dev_path, O_RDONLY);
            if(fd < 0){
                continue;
            }            
        } else {
            close(fd);
        }

        close(fd);         
        closedir(dir);
        
        return 0;
    }

    closedir(dir);

    return -1;


}

int main(int argc, char *argv[])
{
    char **dest_dev_path = NULL;
    char **dest_dev_bdf = NULL;
    char **data_buf = NULL;
    char temp_bdf[16] = {0};
    char input_bdf[16] = {0};
    char dest_bridge_path[128] = {0};
    int pci_config_fd = 0;
    uint8_t val = 0;
    int offset = 0;
    int ret = 0;
    int ipf = 0;
    uint16_t vender_id;
    int loop_num = 100;
    char pf_num = 4;

    
      
    if(NULL != argv[1]){
        memcpy(input_bdf, argv[1], strlen(argv[1]));
    } else {
        printf("[ERROR]Please input the correct parameters on commond line\n");
        printf("[ERROR]For example 0:\33[5;40;32m./check_dev 02:00.0\033[0m\n");
        printf("[ERROR]For example 1:\33[5;40;32m./check_dev 0004:04:00.0\033[0m\n");
        printf("[ERROR]lspci on commond line on linux terminal\n");
        printf("[ERROR][02:00.0] is va pci device\n");
        printf("         |  | |-------->0:function num\n");
        printf("         |  |---------->00:device num\n");
        printf("         |------------->02:bus num\n");

        printf("[ERROR][0004:04:00.0] is va pci device\n");
        printf("           |  | | |-------->0:function num\n");
        printf("           |  | |---------->00:device num\n");
        printf("           |  |------------>04:bus num\n");
        printf("           |--------------->0004:domain num\n");
        return -1;
    }

    dest_dev_path = (char **)malloc(sizeof(char *)*pf_num);
    dest_dev_bdf  = (char **)malloc(sizeof(char *)*pf_num);
    data_buf      = (char **)malloc(sizeof(char *)*pf_num);

    for(ipf=0; ipf<pf_num; ipf++){
        dest_dev_path[ipf] = (char*)malloc(128);
        dest_dev_bdf[ipf]  = (char*)malloc(16);
        data_buf[ipf]      = (char*)malloc(4096);
        memcpy(temp_bdf, input_bdf, strlen(input_bdf)-1);
        sprintf(dest_dev_bdf[ipf],"%s%d", temp_bdf , ipf);
        ret = get_dest_dev_path(dest_dev_path[ipf],dest_dev_bdf[ipf]);
        if(ret){
            goto end;
            printf("ERROR: cann't find va pci dev %s\n",dest_dev_bdf[ipf]);
        } else {
            //save pf config space
            pci_config_fd = open(dest_dev_path[ipf], O_RDWR | O_SYNC);
            if (pci_config_fd < 0) {
                printf("ERROR: %s open failed\n", dest_dev_path[ipf]);
                return -1;
            }
            lseek(pci_config_fd, 0, SEEK_SET);
            read(pci_config_fd, data_buf[ipf], 4096);
            close(pci_config_fd);
        }
    }

    /* find vastai pci device */
    ret = get_dest_dev_bridge(input_bdf,dest_bridge_path);
    if (ret) {
        printf("ERROR: cann't find va pci dev\n");
        goto end;
    }    
    //printf("[bridge_path]%s\n",dest_bridge_path);

    pci_config_fd = open(dest_bridge_path, O_RDWR | O_SYNC);
    if (pci_config_fd < 0) {
        printf("ERROR: %s open failed\n", dest_bridge_path);
        goto end;;
    }

    lseek(pci_config_fd, 0x3e, SEEK_SET);
    val=0x40;
    write(pci_config_fd, &val, 1);
    //hot reset at least delay 20ms , so delay 100ms for security
    usleep(100000);
    lseek(pci_config_fd, 0x3e, SEEK_SET);
    val=0;
    write(pci_config_fd, &val, 1);
    close(pci_config_fd);    

    while(loop_num--) {
        pci_config_fd = open(dest_dev_path[0], O_RDWR | O_SYNC);
        if (pci_config_fd < 0) {
            printf("ERROR:  open %s failed\n", dest_dev_path[0]);
            return -1;
        }
        lseek(pci_config_fd, 0, SEEK_SET);
        read(pci_config_fd, &vender_id, 2);
        close(pci_config_fd);
        if(VENDOR_ID == vender_id){
            printf("\33[25;40;32mthe va device is normal\033[0m\n");
            break;
        }
        printf("\33[25;40;33mwaiting device normal ......\033[0m\n");
        usleep(100000);
        if(1 == loop_num){
            printf("\33[25;40;31m[The va pci device %s] check device fail!\033[0m\n");
            ret = -1;
            goto end;
        }
    } 

    //restore pf config space
    for(ipf=0; ipf<pf_num; ipf++){
        pci_config_fd = open(dest_dev_path[ipf], O_RDWR | O_SYNC);
        if (pci_config_fd < 0) {
            printf("ERROR: %s open failed\n", dest_dev_path[ipf]);
            return -1;
        }
        lseek(pci_config_fd, 0, SEEK_SET);
        write(pci_config_fd, data_buf[ipf], 4096);
        close(pci_config_fd);
    } 
end:
     for(ipf=0; ipf<pf_num; ipf++){
        if(dest_dev_path[ipf] != NULL) {
            free(dest_dev_path[ipf]);
        }

        if(dest_dev_bdf[ipf] != NULL) {
            free(dest_dev_bdf[ipf]);
        }

        if(data_buf[ipf] != NULL) {
            free(data_buf[ipf]);
        }                
    }
    free(dest_dev_path);
    free(dest_dev_bdf);
    free(data_buf);

    if(0==ret)
        printf("\33[25;40;32m[The va pci device %s] check device successly!\033[0m\n",input_bdf);
   
    return ret;
}

