#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <malloc.h>
#include <getopt.h>
#include <getopt.h>
#include <unistd.h>

#define VENDOR_ID       "0x1ec6"
#define DEVICE_ID_0     "0x0200"
#define DEVICE_ID_1     "0x0204"
#define SUB_VENDOR_ID   "0x1ec6"
#define SUB_DEVICE_ID   "0x0000"

static int get_dest_dev_path(char *dev_path, char* dest_bdf)
{
    DIR *dir = opendir("/sys/bus/pci/devices");
    struct dirent *pdirent = NULL;
    char file_name[128];
    int fd;
    char buf[16];
    
    while((pdirent = readdir(dir)) != NULL) {
        // if (NULL == strstr(pdirent->d_name, ".0"))
        //     continue;
        if(strcmp(pdirent->d_name,".")==0 || strcmp(pdirent->d_name,"..")==0)
                continue;

        sprintf(dev_path,    "/sys/bus/pci/devices/%s/0000:%s/config", pdirent->d_name , dest_bdf);
        fd = open(dev_path, O_RDONLY);
        if (fd < 0) {
            sprintf(dev_path,    "/sys/bus/pci/devices/%s/%s/config", pdirent->d_name , dest_bdf);
            fd = open(dev_path, O_RDONLY);
            if(fd < 0){
                continue;
            }            
        } else {
            close(fd);
        }

        close(fd);         
        closedir(dir);
        
        return 0;
    }

    closedir(dir);

    return -1;


}

int main(int argc, char *argv[])
{
    char dev_path[128];
    int ret;
    char dest_dev_bdf[16] = {0};
    int pci_config_fd;
    uint8_t val;
    char *buf = NULL;
    uint32_t tmp_count = 0;
    int i = 0;
    uint32_t offset = atoi(argv[2]);
    uint32_t len = atoi(argv[3]);

    buf = (char*) malloc(len);

    if(NULL != argv[1]){
        memcpy(dest_dev_bdf, argv[1], strlen(argv[1]));
    } else {
        //printf("\033[显示方式;字背景颜色;字体颜色m字符串\033[0m" );
        /*
            显示方式:
            1：粗体/高亮
            22：非粗体
            4：单条下划线
            24：无下划线
            5：闪烁
            25：无闪烁
            7：反显、翻转前景色和背景色
            27：无反显
        */

        /*
            字背景颜色范围:40----49
            40:黑
            41:深红
            42:绿
            43:黄色
            44:蓝色
            45:紫色
            46:深绿
            47:白色

            字颜色:30-----------39
            30:黑
            31:红
            32:绿
            33:黄
            34:蓝色
            35:紫色
            36:深绿 
            37:白色
            0：默认

        */
        printf("[ERROR]Please input the correct parameters on commond line\n");
        printf("[ERROR]For example 0:\33[5;40;32m./pci_cfg_read 02:00.0 offset len\033[0m\n");
        printf("[ERROR]For example 1:\33[5;40;32m./pci_cfg_read 0004:04:00.0 offset len\033[0m\n");
        printf("[ERROR]lspci on commond line on linux terminal\n");
        printf("[ERROR][02:00.0] is va pci device\n");
        printf("         |  | |-------->0:function num\n");
        printf("         |  |---------->00:device num\n");
        printf("         |------------->02:bus num\n");

        printf("[ERROR][0004:04:00.0] is va pci device\n");
        printf("           |  | | |-------->0:function num\n");
        printf("           |  | |---------->00:device num\n");
        printf("           |  |------------>04:bus num\n");
        printf("           |--------------->0004:domain num\n");
        return -1;
    }
    
    
    /* find vastai pci device */
    ret = get_dest_dev_path(dev_path,dest_dev_bdf);
    if (ret) {
        printf("ERROR: cann't find va pci dev\n");
        return -1;
    }    

    pci_config_fd = open(dev_path, O_RDWR | O_SYNC);
    if (pci_config_fd < 0) {
        printf("ERROR: %s open failed\n", dev_path);
        return -1;
    }

    lseek(pci_config_fd, 0, SEEK_SET);
    read(pci_config_fd, buf, len);

    printf("Dump begin :");

    while(len > tmp_count){
        printf("\noffset[0x%08x]:",offset + tmp_count);
        for(i=0;i<4;i++){
            printf(" 0x%08x ", *(uint32_t *)((uint64_t)buf + tmp_count));
            tmp_count += 4;
            if(len < (tmp_count+1))
                break;
        }     
    }

    printf("\n");
    printf("Dump finish :\n");
    close(pci_config_fd);
    free(buf);
    
    return 0;
}

