﻿
#ifndef __VATOOLS_DEFINE_H__
#define __VATOOLS_DEFINE_H__

// 模拟器使用,打开宏
// #define __EMULATTION__

#ifdef __EMULATTION__
#define SMI_CMD_ACK_WAIT_MS (1000 * 50)
#else
#define SMI_CMD_ACK_WAIT_MS (1000)
#endif

//所有和驱动接口的数据按1字节对齐
#pragma pack(push)
#pragma pack(1)
#ifdef __cplusplus
extern "C" {
#endif

// 编译独立的 vatools 驱动。内部测试使用
#ifndef VATOOLS_INDEPENDANCE_DRIVER
#define VATOOLS_INDEPENDANCE_DRIVER 0
#endif

/*****************************************************************
 * 功能定义
*/
// 热插拔功能
//#define VATOOLS_HOT_PLUG_ENABLE
// sv100, sg100 驱动融合
//#define VATOOLS_SV_SG_MERGE
// profiler timeline数据采集：mcu 时间同步
// #define VATOOLS_CORE_TIME_SYNC_ENABLE
// profiler timeline数据采集
// #define VATOOLS_PROFILER_ENABLE
// sharemem lock optimize, don't use node_mutex anymore
//#define VATOOLS_SHAREMEM_LOCK_OPTIMIZE

#define V_UNREFERENCE(param) ((void)param);

#define VATOOLS_CHECK_BYTE_ALIGH (1)

//****************************************************************************
//下面的定义, app, driver 需要保持一致, 拷贝到各个应用中
//****************************************************************************
//定义可以管理的最多的device数目
#ifndef MAX_DEVICE_NUM_PER_MANAGER
#define MAX_DEVICE_NUM_PER_MANAGER 2048
#endif
//定义每个device里面die的最大数目
#ifndef MAX_DIE_NUM_PER_DEVICE
#define MAX_DIE_NUM_PER_DEVICE VASTAI_DIE_MAX_NUM
#endif
//定义每个die里面unit的最大数目, 如果超过, 需要各个命令自己扩充
#define MAX_UNIT_NUM_PER_DIE 32 //这个值和命令定义有关, 不能修改为更大的数目

//每个die内，保存smi数据的地址,
//#define SMI_DIE_ADDRESS_OFFSET ((u64)(0x08cf3600))

//定义vatools 文件节点文件名最大长度
#define VATOOLS_DEVICE_NAME_LEN (32)
// vatools 工具驱动文件节点
#define VATOOLS_DEV_NAME      "vatools"
#define VATOOLS_DEV_PATH_NAME "/dev/vatools"
#define VA_NODE_NAME_CARD     "card"
#define VA_NODE_NAME_RENDER   "renderD"
#define VA_NODE_NAME_KCHAR    "kchar:"

// 定义内部使用错误码
#define E_UNKNOWN_IOCTL	          201 /* 未识别ioctl*/
#define E_UNKNOWN_SUB_CMD	  202 /* 未识别命令*/
#define E_UNPROCCESSED_CMD        203 /* 未支持命令*/

// IOCTL MAIGC CODE
#define VATOOLS_IOCTL_MAGIC 0xA1

#define VATOOLS_BUFFER_SIZE (0x1000)

//定义各个节点ioctlmingl偏移量
#define VATOOLS_GENERAL_IOCTL_BASE		0x10
#define VATOOLS_HARDWARE_PERFORMANCE_IOCTL_BASE 0x50
#define VATOOLS_SHAREDMEMORY_IOCTL_BASE		0x60
#define VATOOLS_LOGGER_IOCTL_BASE		0x70
#define VATOOLS_DEBUG_IOCTL_BASE		0x80
#define VATOOLS_SMI_IOCTL_BASE			0x90
#define VATOOLS_MONITOR_IOCTL_BASE		0xa0

// ioctl 通用命令
/// 测试命令
#define VATOOLS_GENERAL_IOCTL_TEST                                             \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x00)
/// 设置打开的文件fd的类别
#define VATOOLS_GENERAL_IOCTL_SET_APP_CATEGORY                                 \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x01)
/// 获取device 数量
#define VATOOLS_GENERAL_IOCTL_GET_DEVICE_NUM                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x02)
/// 获取die info
#define VATOOLS_GENERAL_IOCTL_GET_DIE_INFO                                     \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x03)
/// 通过 smi 读数据
#define VATOOLS_GENERAL_IOCTL_READ                                             \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x04)
/// 通过 smi 写数据
#define VATOOLS_GENERAL_IOCTL_WRITE                                            \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x05)
/// 通过 dmi 读写数据, 读写通过一次调用完成
#define VATOOLS_GENERAL_IOCTL_FETCH                                            \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x06)
/// 获取 device 的 pcie bus_id
#define VATOOLS_GENERAL_IOCTL_GET_DEV_PCIE_BUS_ID                              \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x07)
/// 获取 die render
#define VATOOLS_GENERAL_IOCTL_GET_DIE_RENDER                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x08)
/// 通过PCIE驱动读取数据, 不发送数据到smi
#define VATOOLS_GENERAL_IOCTL_PCIE                                             \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x09)
/// 获取pcie id
#define VATOOLS_GENERAL_IOCTL_GET_PCIE_ID                                      \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x0a)
/// 获取pcie sub id
#define VATOOLS_GENERAL_IOCTL_GET_PCIE_SUB_ID                                  \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x0b)
/// 获取驱动major minor 版本号
#define VATOOLS_GENERAL_IOCTL_GET_MAJOR_MINOR_ID                               \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x0c)
/// 获取 device 能力集
#define VATOOLS_GENERAL_IOCTL_DEVICE_CAPABILITY                                \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x0d)
/// 获取 firmware log status
#define VATOOLS_GENERAL_IOCTL_LOG_STATUS                                       \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x0e)
/// 分配 DMA 内存
#define VATOOLS_GENERAL_IOCTL_DMA_ALLOC                                        \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x0f)
/// 开始 DMA 传输数据
#define VATOOLS_GENERAL_IOCTL_DMA_START                                        \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x10)
/// 普通方式读取数据
#define VATOOLS_GENERAL_IOCTL_READ_BUF                                         \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x11)
/// 普通方式写入数据
#define VATOOLS_GENERAL_IOCTL_WRITE_BUF                                        \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x12)
/// 使用内核mutex实现进程互斥保护: 加锁
#define VATOOLS_GENERAL_IOCTL_GUARD_LOCK                                       \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x13)
/// 使用内核mutex实现进程互斥保护: 解锁
#define VATOOLS_GENERAL_IOCTL_GUARD_UNLOCK                                     \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x14)
/// 使用内核mutex实现进程互斥保护: trylock
#define VATOOLS_GENERAL_IOCTL_GUARD_TRYLOCK                                    \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x15)
/// 使用内核mutex实现进程互斥保护: is locked
#define VATOOLS_GENERAL_IOCTL_GUARD_IS_LOCKED                                  \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x16)
/// core timestamp sync
#define VATOOLS_GENERAL_IOCTL_CORE_TIME_SYNC                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x17)
/// 获取bmcu xspi的版本信息
#define VATOOLS_GENERAL_IOCTL_GET_BMCU_XSPI_VERSION                            \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x18)
/// 烧入bmcu fw版本
#define VATOOLS_GENERAL_IOCTL_FLASH_BMCU_FW                                    \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x19)
/// 烧入xspi fw版本
#define VATOOLS_GENERAL_IOCTL_FLASH_XSPI_FW                                    \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x1A)
/// 获取烧写状态
#define VATOOLS_GENERAL_IOCTL_GET_FLASH_STA                                    \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x1B)
/// 切换bmcu版本
#define VATOOLS_GENERAL_IOCTL_SWITCH_BMCU                                      \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x1C)
/// 获取device info
#define VATOOLS_GENERAL_IOCTL_GET_DEV_INFO                                     \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x1D)
/// 获取reset event
#define VATOOLS_GENERAL_IOCTL_DEVICE_EVENT                                     \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x1E)

/// 获取sriov的是否使能和VF个数
#define VATOOLS_GENERAL_IOCTL_SRIOV_NUMBER                                     \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x1F)

/// 获取 event 事件
#define VATOOLS_GENERAL_IOCTL_DEVICE_EVENT_SELECT                              \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x20)

/// 释放DMA申请内存空间
#define VATOOLS_GENERAL_IOCTL_DMA_FREE                                         \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x21)
/// DMA: 用户空间内存传递到内核, 使用时无需先 alloc dma 内存
#define VATOOLS_GENERAL_IOCTL_DMA_TRANS                                        \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_GENERAL_IOCTL_BASE + 0x22)

/// 设置采集性能项目命令
#define VATOOLS_PROFILER_SET_PERFORMANCE_CSR                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_HARDWARE_PERFORMANCE_IOCTL_BASE + 0x01)
/// 设置性能命令
#define VATOOLS_PROFILER_SET                                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_HARDWARE_PERFORMANCE_IOCTL_BASE + 0x02)
/// 读取性能命令
#define VATOOLS_PROFILER_GET                                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_HARDWARE_PERFORMANCE_IOCTL_BASE + 0x03)

/// used for ioctrl type stable struct, same as struct memory_entry
struct unref_struct {
	u8 array[72];
};
/* shared memory ioctl */
// lupa modify 2021-12-15
/// 创建共享内存信息
#define VATOOLS_CREATE_SHARE_MEM                                               \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x01,     \
	      struct unref_struct)
/// 删除共享内存信息
#define VATOOLS_DELETE_SHARE_MEM                                               \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x02,     \
	      struct unref_struct)
/// 获取共享内存信息
#define VATOOLS_READ_SHARE_MEM                                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x03,     \
	      struct unref_struct)
/// 写入共享内存信息
#define VATOOLS_WRITE_SHARE_MEM                                                \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x04,     \
	      struct unref_struct)
/// 等待信息开始
#define VATOOLS_POLL_SHARE_MEM                                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x05,     \
	      struct unref_struct)

/// 开始video debugger信息
#define VATOOLS_SHARE_MEM_VIDEO_START_DEBUGGER                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x06,     \
	      struct unref_struct)
/// 停止video  debugger信息
#define VATOOLS_SHARE_MEM_VIDEO_STOP_DEBUGGER                                  \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x07,     \
	      struct unref_struct)
/// 读取video  debugger信息
#define VATOOLS_SHARE_MEM_VIDEO_READ_DEBUGGER                                  \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x08,     \
	      struct unref_struct)
/// 写入video debugger信息
#define VATOOLS_SHARE_MEM_VIDEO_WRITE_DEBUGGER                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x09,     \
	      struct unref_struct)
/// 附加回调函数
#define VATOOLS_CREATE_VIDEO_MEM_FUNCTION                                      \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x0A,     \
	      struct unref_struct)
/// 删除回调函数
#define VATOOLS_DELETE_VIDEO_MEM_FUNCTION                                      \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x0B,     \
	      struct unref_struct)

/// used for compatible with old, same as old struct memory_entry
struct unref_struct_old {
	u8 array[56];
};

/* shared memory ioctl */
// lupa modify 2021-12-15
/// 创建共享内存信息
#define OLD_VATOOLS_CREATE_SHARE_MEM                                               \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x01,     \
	      struct unref_struct_old)
/// 删除共享内存信息
#define OLD_VATOOLS_DELETE_SHARE_MEM                                               \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x02,     \
	      struct unref_struct_old)
/// 获取共享内存信息
#define OLD_VATOOLS_READ_SHARE_MEM                                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x03,     \
	      struct unref_struct_old)
/// 写入共享内存信息
#define OLD_VATOOLS_WRITE_SHARE_MEM                                                \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x04,     \
	      struct unref_struct_old)
/// 等待信息开始
#define OLD_VATOOLS_POLL_SHARE_MEM                                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x05,     \
	      struct unref_struct_old)

/// 开始video debugger信息
#define OLD_VATOOLS_SHARE_MEM_VIDEO_START_DEBUGGER                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x06,     \
	      struct unref_struct_old)
/// 停止video  debugger信息
#define OLD_VATOOLS_SHARE_MEM_VIDEO_STOP_DEBUGGER                                  \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x07,     \
	      struct unref_struct_old)
/// 读取video  debugger信息
#define OLD_VATOOLS_SHARE_MEM_VIDEO_READ_DEBUGGER                                  \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x08,     \
	      struct unref_struct_old)
/// 写入video debugger信息
#define OLD_VATOOLS_SHARE_MEM_VIDEO_WRITE_DEBUGGER                                 \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x09,     \
	      struct unref_struct_old)
/// 附加回调函数
#define OLD_VATOOLS_CREATE_VIDEO_MEM_FUNCTION                                      \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x0A,     \
	      struct unref_struct_old)
/// 删除回调函数
#define OLD_VATOOLS_DELETE_VIDEO_MEM_FUNCTION                                      \
	_IOWR(VATOOLS_IOCTL_MAGIC, VATOOLS_SHAREDMEMORY_IOCTL_BASE + 0x0B,     \
	      struct unref_struct_old)

/* debug tools */
/// 配置调试工具命令
#define VATOOLS_DEBUG_CONFIG                                                   \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_DEBUG_IOCTL_BASE + 0x01)
/// 设置调试工具命令
#define VATOOLS_DEBUG_SET                                                      \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_DEBUG_IOCTL_BASE + 0x02)
/// 读取调试工具命令
#define VATOOLS_DEBUG_GET                                                      \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_DEBUG_IOCTL_BASE + 0x03)
/// 获取调试工具命令
#define VATOOLS_DEBUG_FETCH                                                    \
	_IO(VATOOLS_IOCTL_MAGIC, VATOOLS_DEBUG_IOCTL_BASE + 0x04)

#ifndef ARRAY_SIZE
#define ARRAY_SIZE(ARRAY) (sizeof(ARRAY) / sizeof(ARRAY[0]))
#endif

/// 定义core index 枚举值, core index bitmap, 每个bit代表一个core
enum core_bit_index {
	CORE_SMCU = 0,
	CORE_CMCU = 1,
	CORE_OMCU0 = 2,
	CORE_OMCU1 = 3,
	CORE_GMCU0 = 4,
	CORE_GMCU1 = 5,
	CORE_GMCU2 = 6,
	CORE_GMCU3 = 7,
	CORE_VEMCU0 = 8,
	CORE_VEMCU1 = 9,
	CORE_VEMCU2 = 10,
	CORE_VEMCU3 = 11,
	CORE_ODSP0 = 12,
	CORE_ODSP1 = 13,
	CORE_VDSP0 = 14,
	CORE_VDSP1 = 15,
	CORE_PMCU = 16,
	CORE_NUMBER = 17,
	CORE_HOST_PCIE = CORE_NUMBER, // TODO: 这里借用此枚举.
	VA_CORE_MAX = 32, // 最多 32 core
};

// 使用core enum 计数模拟驱动功能序列
enum driver_simu_core_bit_index {
	CORE_HOST_PCIE_DMA = CORE_HOST_PCIE,
	CORE_HOST_PCIE_MSG,
	CORE_HOST_PCIE_APP,
	CORE_HOST_PCIE_MAX
};

#define CORE_TYPE_CMCU	0x0
#define CORE_TYPE_LMCU	0x1
#define CORE_TYPE_ODSP	0x2
#define CORE_TYPE_VDSP	0x8
#define CORE_TYPE_VDMCU 0xA
#define CORE_TYPE_VEMCU 0xB
#define CORE_TYPE_SMCU	0xF

#define SET_INDEX_CORE(TYPE, ID) ((TYPE) << 6 | (ID))
#define GET_CORE_TYPE(TYPE)	 ((TYPE) >> 6)
#define GET_INDEX_CORE(ID)	 ((ID) & 0x3F)

#define COREID_DEFINE_3(t) (t << 6) | 0, (t << 6) | 1, (t << 6) | 2
#define COREID_DEFINE_4(t)                                                     \
	(t << 6) | 0, (t << 6) | 1, (t << 6) | 2, (t << 6) | 3
#define COREID_DEFINE_8(t)                                                     \
	(t << 6) | 0, (t << 6) | 1, (t << 6) | 2, (t << 6) | 3, (t << 6) | 4,  \
		(t << 6) | 5, (t << 6) | 6, (t << 6) | 7

/// core to core 中断: cmcu ringbuf 数据结构
typedef struct ring_buf_elem_struct {
	union {
		u64 whole;
		struct {
			u8 seq_no : 8; ///< 低8bit, 序列号, 原样回传
			u32 val : 32; ///< 数据值
			u16 sub_cmd : 16; ///< 子命令
			u8 cmd : 7; ///< 命令族
			u8 use_ringbuf : 1; ///< 1: 使用ringbuf, 0: 不使用ringbuf
		};
	};

} ring_buf_elem_t;

#define VATOOLS_INTERRUPT_USE_RINGBUF	  (1)
#define VATOOLS_INTERRUPT_NOT_USE_RINGBUF (0)

#define VATOOLS_INTERRUPT_TOOLS_CATEGARY_CMD                                   \
	(0x01) ///< core2core中断ringbuf数据内,cmd=0x01 标识是debug功能的消息
#define VATOOLS_INTERRUPT_DEBUG_CMD                                            \
	(0x0001) ///< core2core中断ringbuf数据内,cmd=0x01 标识是debug功能的消息
#define VATOOLS_INTERRUPT_PROFILER_CMD                                         \
	(0x0002) ///< core2core中断ringbuf数据内,cmd=0x02 标识是profiler功能的消息
#define VATOOLS_INTERRUPT_CORE_TIME_SYNC                                       \
	(0x0003) ///< core2core中断ringbuf数据内,cmd=0x03 标识是core time sync功能的消息

enum enum_app_category {
	VATOOLS_APP_DUMMY = 0,
	VATOOLS_APP_SMI = 1,
	VATOOLS_APP_PROFILER = 2,
	VATOOLS_APP_DEBUGGER = 3,
	VATOOLS_APP_LOGGER = 4,
	VATOOLS_APP_MONITOR = 5,
	VATOOLS_APP_SHAREDMEM = 6,
	VATOOLS_APP_EVENT = 7,
	VATOOLS_APP_MAX
};

enum enum_cmd_type {
	VATOOLS_MEM_CMD_HANDLE = 0,
	VATOOLS_MEM_CMD_CHANNEL = 1,
	VATOOLS_MEM_CMD_TIMEOUT = 2,
};

// block 数量
#define SMI_BLOCK_ID_MAX (8)

enum __SMI_CMD_BLOCK_IDS {
	SMI_CMD_BLOCK_ID_0 = 0,
	SMI_CMD_BLOCK_ID_1,
	SMI_CMD_BLOCK_ID_2,
	SMI_CMD_BLOCK_ID_3,
	SMI_CMD_BLOCK_ID_4,
	SMI_CMD_BLOCK_ID_5,
	SMI_CMD_BLOCK_ID_6,
	SMI_CMD_BLOCK_ID_7,
	SMI_CMD_BLOCK_ID_MAX = SMI_BLOCK_ID_MAX,
	SMI_CMD_BLOCK_ID_IGNORE = 0x0000FFFF
};

enum __SMI_CMD_BLOCK_USED_FLAG {
	SMI_CMD_BLOCK_IDLE = 0,
	SMI_CMD_BLOCK_BUSY = 1
};

typedef struct s_device {
	u32 dev_id;
	u32 die_id;
	u32 die_index; // low die_id:8;  dev_id:16; high seq_num:8;
	// u32 core_id;    // low core_index:6; high core_type:26;
} T_DEVICE;

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
typedef struct s_vasmi_buf_array {
	u32 buf_size;
	u8 buf[0];
} T_SMI_BUF_ARR;
#endif
#else
typedef struct s_vasmi_buf_array {
	u32 buf_size;
	u8 buf[0];
} T_SMI_BUF_ARR;
#endif

typedef struct s_vasmi_buf_ptr {
	u32 buf_size;
	// void *buf_addr;
	u64 buf_addr;
} T_SMI_BUF_PTR;

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
typedef struct s_vasmi_tlv {
	u32 address;
	u32 length;
	u8 value[0];
} T_SMI_TLV;
#endif
#else
typedef struct s_vasmi_tlv {
	u32 address;
	u32 length;
	u8 value[0];
} T_SMI_TLV;
#endif

//
typedef struct SMI_IOCTL_TRANS_CATEGORY_s {
	u32 app_category;
	u32 block_id;
	//卡信息
	T_DEVICE device;
	// TODO: 为了适配arm服务器, 这里需要结构是8bytes 倍数. 调整变量时, 需要考虑是否8bytes对齐. 暂时不修改这里,
	// 在驱动结构 vatools_reader 里修改; 下次整理代码时, 需要整体考虑
} T_SMI_IOCTL_TRANS_CATEGORY;

// host 使用 ioctl 和驱动进行数据交互传输
typedef struct SMI_IOCTL_TRANS_DATA_s {
	u32 block_id;
	//卡信息
	T_DEVICE device;
	u64 address;
	u32 flag; // 0x1: use pcie interface  0x0: use smi interface
	T_SMI_BUF_PTR
	output_buf; // host侧保存 fw 返回的数据buffer. 数据: fw->host
	T_SMI_BUF_PTR input_buf; // host侧要写入 fw 的数据buffer. 数据: host->fw
	int errcode; //调用内核ioctl返回值
} T_SMI_IOCTL_TRANS_DATA;

typedef struct SMI_DEV_PCIE_BUS_ID {
	int dev_id;
	char pcie_port[16];
} TS_SMI_DEV_PCIE_BUS_ID;

typedef struct SMI_DEV_PCIE_ID {
	int dev_id;
	unsigned int pcie_id;
} TS_SMI_DEV_PCIE_ID;

typedef struct SMI_DEV_PCIE_SUB_ID {
	int dev_id;
	unsigned int pcie_sub_id;
} TS_SMI_DEV_PCIE_SUB_ID;

typedef struct SMI_DEV_MAJOR_MINOR {
	int dev_id;
	unsigned int major_minor;
} TS_SMI_DEV_MAJOR_MINOR;

typedef struct SMI_DIE_RENDER {
	int dev_id;
	int die_id;
	char render[16];
} TS_SMI_DIE_RENDER;

struct vastai_dev_info {
	int dev_id;
	u64 unid;
	char pcie_slot[16]; /* 0000:01:00.00 */
	char pcie_dev_name[16]; /* kchar:0 */
	char device_name[16]; /* sv100 */

	union pci_id_u {
		u32 val;
		struct {
			u16 vender_id;
			u16 device_id;
		};
	} pci_id;

	union pci_sub_id_u {
		u32 val;
		struct {
			u16 sub_vender_id;
			u16 sub_device_id;
		};
	} pci_sub_id;

	union major_minor_uu {
		u32 val;
		struct {
			u16 minor;
			u16 major;
		};
	} major_minor;

	struct ai_video_cap_u {
		int ai_cap;
		int video_cap;
	} cap;

	int die_num;
	struct vastai_die_info_s {
		union die_index_data die_index;
		char vacc_name[16]; /* vacc0 */
		char render_name[16]; /* render129 */
	} die_info[4];
};

typedef struct SMI_DEVICE_CAPABILITY {
	int dev_id;
	int die_id;
	struct vastai_dev_info capability;
} SMI_DEVICE_CAPABILITY;

/// 保存 event 数据的ringbuf size
#define EVENT_FIFO_LENGTH (2 * 1024 * 1024)

//获取 event reset 状态
// CORE_POINT_CMCU 不代表CMCU，代表整个ai-sys, 包括整个ai-sys的所有core; SMCU 没有reset; 其他代表各自的core reset
enum device_common_event_e {
	EVT_RESET_START = RESET_START, // reset 开始
	EVT_RESET_STOP = RESET_END, // reset 完成, 恢复正常状态
	EVT_COMMON_MAX = 10 // common event 最多只能由10个
};

// VEMCU video event 子模块/core 的事件定义, 从11开始
enum vemcu_exception_event_e {
	VCENC_EXCEPTION_ERROR = 11,
	VCENC_EXCEPTION_NULL_ARGUMENT, /**ERROR Null argument**/
	VCENC_EXCEPTION_INVALID_ARGUMENT, /**ERROR Invalid argument*/
	VCENC_EXCEPTION_INVALID_STATUS, /*VCEncStrmEncode: ERROR Invalid status*/
	VCENC_EXCEPTION_INVALID_GOPSIZE, /*VCEncStrmEncode: ERROR Invalid gopSize*/
	VCENC_EXCEPTION_NOTCODED_FRAME, /*VCEncStrmEncode: ERROR Invalid coding type*/
	VCENC_EXCEPTION_STREAM_BUFFER, /*VCEncStrmEncode: ERROR Invalid output stream buffer*/
	VCENC_EXCEPTION_TOO_SMALL_OUTPUT_STREAM_BUFFER, /*VCEncStrmEncode: ERROR Too small output stream buffer*/
	VCENC_EXCEPTION_NOT_SUPPORT_MULTI_CORE, /*VCEncStrmEncode: multi-segment not support multi-core*/
	VCENC_EXCEPTION_INVALID_BASELINE_PROFILE, /*VCEncSetCodingCtrl: ERROR Invalid frame type for baseline profile*/
	VCENC_EXCEPTION_INVALID_INPUT_BUS_CHROMAV, /*VCEncStrmEncode: ERROR Invalid input busChromaV*/
	VCENC_EXCEPTION_INVALID_INPUT_BUS_CHROMAU, /*VCEncStrmEncode: ERROR Invalid input busChromaU*/
	VCENC_EXCEPTION_INVALID_INPUT_BUSLUMA, /*VCEncStrmEncode: ERROR Invalid input busLuma*/
	VCENC_EXCEPTION_INVALID_INPUT_FORMAT, /*VCEncStrmEncodeExt: ERROR Invalid input format*/
	VCENC_EXCEPTION_INVALID_INPUT_BUSLUMASTAB, /*VCEncStrmEncodeExt: ERROR Invalid input busLumaStab*/
	VCENC_EXCEPTION_MEMORY_ERROR, /**ERROR Memery error*/
	VCENC_EXCEPTION_EWL_ERROR, /**ERROR Invalid argument*/
	VCENC_EXCEPTION_EWL_MEMORY_ERROR, /**ERROR Ewl Memery error*/
	VCENC_EXCEPTION_OUTPUT_BUFFER_OVERFLOW, /**ERROR Revert FrameNum Update on output buffer overflow*/
	VCENC_EXCEPTION_HW_BUS_ERROR, /**ERROR Hardware bus error*/
	VCENC_EXCEPTION_HW_DATA_ERROR, /**ERROR Hardware data error*/
	VCENC_EXCEPTION_HW_TIMEOUT, /**ERROR hardware timeout*/
	VCENC_EXCEPTION_HW_RESERVED, /**ERROR Hardware reserved*/
	VCENC_EXCEPTION_SYSTEM_ERROR, /**ERROR System error*/
	VCENC_EXCEPTION_INSTANCE_ERROR, /**ERROR Instance error*/
	VCENC_EXCEPTION_HRD_ERROR, /**ERROR Hrd error*/
	VCENC_EXCEPTION_HW_RESET, /**ERROR Hardware reset*/
	VCENC_EXCEPTION_HASH_LEN_MISMATCH, /**ERROR Hash len mismatch*/
	VCENC_EXCEPTION_FW_RESET, /**ERROR FW reset*/
	VCENC_EXCEPTION_INSATANCE_CHECK_MISMATCH, /**ERROR Instance check mismatch*/
	VCENC_EXCEPTION_IM_RESET, /**ERROR hantrovcmd_isr failed. im reset dev->hwregs */
	VCENC_EXCEPTION_ENCODE_EXT_MCU_V2, /**ERROR  VCEncStrmEncodeExt_mcu_V2*/
	VCENC_EXCEPTION_HANDLE_ENCODER_ISR, /**ERROR  HandleEncoderIsr failed*/
	VCENC_EXCEPTION_HANG_HANTRO_RESET_ISR_FAILED, /**FAILED hang reset hantrovcmd_isr failed irq*/
	VCENC_EXCEPTION_HANTRO_VCMD_ISR_TIMEOUT, /**ERROR hantrovcmd_isr error timeout */
	VCDEC_EXCEPTION_RESERVED /**ERRORR decoder reserved*/
};

// reset event 信息
typedef struct device_event_s {
	u64 timestamp_ns; // event 发生的时间
	u32 die_index;
	u32 core_index;
	u32 event;
} device_event_t;

// TODO:
typedef struct vatools_cmd {
	union ucmd {
		// 申请 dma 空间
		struct {
			u32 size;
			int dma_buf_fd;
			u32 die_index;
			u64 dma_addr_t;
		} alloc_cmd;
		// 开始 dma 传输
		struct {
			u32 is_dev_to_host;
			int dma_buf_fd;
			u64 axi_addr;
			u32 size;
			u32 die_index;
		} dma_start_cmd;
		// 用户空间内存直接传递到内核, 使用前无需 dma alloc 内存
		struct {
			u32 is_dev_to_host;
			void *vir_addr;
			u64 axi_addr;
			u32 length;
			u32 die_index;
			int pid;
		} dma_trans_cmd;
		struct {
			u32 is_dev_to_host;
			u32 die_index;
			u64 axi_addr;
			struct vastai_channel_buf *channel_buf;
			int channel_num;
			int pid;
		} dma_trans_sg_cmd;
		struct {
			u32 die_index;
			u32 timeout_water;
			u32 is_timeout;
			u64 log_ring_ctl;
		} log_poll_cmd;
		struct {
			u32 die_index;
			u64 addr;
			u32 size;
			u64 buf;
		} access_mem_cmd;
		struct {
			u32 event_count;
			device_event_t buf[0];
		} event;
	} cmd;
} T_VATOOLS_CMD;

/**********************************************************************************/
// PCIe 命令, 不使用smcu. 直接访问驱动
enum e_pcie_cmd_flag {
	PCIE_CMD_FLAG_NONE = 0, ///< 无
	PCIE_CMD_FLAG_BANDWIDTH = 1, ///< 获取PCI带宽
	PCIE_CMD_FLAG_RESET = 2, ///< 复位设备(device) reset
	PCIE_CMD_FLAG_REBOOT = 3, ///< 重启设备(device) reboot
	PCIE_CMD_FLAG_STRING = 4, ///< 灵活文本命令
	PCIE_CMD_FLAG_FW_VERSION = 5, ///< 获取固件版本
	PCIE_CMD_FLAG_DDR_ECC_1BIT = 6, ///< 获取DDR ECC 1bit错误数据
	PCIE_CMD_FLAG_DDR_ECC_2BIT = 7, ///< 获取DDR ECC 2bit错误数据
	PCIE_CMD_FLAG_VDSP_COUNT = 8, ///< 获取 vdsp 统计数据
	PCIE_CMD_FLAG_AI_COUNT = 9, ///< 获取ai 统计数据. 512 bytes.
	PCIE_CMD_FLAG_RING_BUF_STATISTIC = 10, ///< 获取ring buffer 统计数据
	PCIE_CMD_FLAG_SET_VIDEO_MULTI_CORE =
		11, ///< 设置video使用multicore; 0: 不使用; 1: 使用
	PCIE_CMD_FLAG_GET_VIDEO_MULTI_CORE =
		12, ///< 读取video multicore 的mode和job count
	PCIE_CMD_FLAG_FW_VERSION_V2 = 13, ///< 获取fw版本号, 读取全部die
	PCIE_CMD_FLAG_GET_BOX_TYPE = 14, ///< 获取bbox type
	PCIE_CMD_FLAG_HEART_BEAT = 15, ///< core heartbeat
	PCIE_CMD_FLAG_BOOT = 16, ///< 启动设备(device) boot
	PCIE_CMD_FLAG_BARRESET = 17, ///< bar复位
	PCIE_CMD_FLAG_BARSTATUS = 18, ///< bar status获取
	PCIE_CMD_FLAG_REBOOT_DDRBW = 19, ///< 切换至 DDR 带宽 bin
	PCIE_CMD_FLAG_REBOOT_PCIEDMA = 20, ///< 切换至测试 PCIE DMA 带宽
	PCIE_CMD_FLAG_RUNTIME_INFO = 21, ///< 获取 runtime info
	PCIE_CMD_FLAG_CURRENT_PROCESS_INFO = 22, ///< 获取当前进程 info
	PCIE_CMD_FLAG_HEART_BEAT_COUNT = 23, ///< 获取 heartbeat 统计数据
	PCIE_CMD_FLAG_DDR_BANDWIDTH = 24, ///< 获取 ddr 带宽统计数据
	PCIE_CMD_FLAG_CARD_CPU_TOPO = 25, ///< 获取设备和CPU拓扑关系
	PCIE_CMD_FLAG_GFX_CMD = 26, ///< 获取gfx数据
	PCIE_CMD_FLAG_RING_BUF_FROM_HW_CFG = 27, ///< 从hw_cfg获取ringbuf信息
	PCIE_CMD_FLAG_MAX,
};

typedef struct S_HOST_ARG_VAL {
	unsigned int
		nType; // 0、 cmd , driver收到后需要发送 中断到 fw  1、  data , driver只负责读写数据, 不发中断到fw
	void *pcBuf;
} T_HOST_ARG_VAL;

/// 进程间互斥锁结构
struct vatools_process_mutex {
	struct list_head list_member_process_mutex;
	struct list_head list_head_filp;
	struct mutex process_mutex;
	char mutex_name[256]; ///< 互斥锁 名, 名字相同为同一个互斥锁
};

/// file* 链表
struct vatools_process_mutex_filp {
	struct list_head list_member_filp;
	struct file *filp;
};

// filter struct size same as video
#pragma pack(push)
#pragma pack(4)
enum EModuleType {
	PROFILER_ENCODER,
	PROFILER_DECODER,
};

struct TVChanInfo {
	uint32_t dwStructVer;
	uint32_t dwSize;
	int32_t nChanID;
	int32_t nDieID;
	int32_t nDeviceID;
	uint32_t dwMemSize;
	int32_t nChanFlag;
	int32_t nCoreID;
	int32_t nReserved;
	enum EModuleType eModuleType;
}; // 10 * 4 = 40

struct TVdecStatis {
	struct TVChanInfo tVChanInfo;
	uint32_t dwDecType;
	uint32_t dwFrameRate;
	uint32_t dwRecvFrame;
	uint32_t dwLoseFrame;
	uint32_t dwPackError;
	uint32_t dwFullLose;
	uint32_t dwBitRate;
	uint32_t dwAvrVideoBitRate;
	uint32_t dwDecWidth;
	uint32_t dwDecHeight;
	uint32_t dwDecInputCnt;
	uint32_t dwDecOutputCnt;
	uint32_t dwFramesLeft;
}; // 10 * 4 + 13 * 4 = 92

struct TVencStatis {
	struct TVChanInfo tVChanInfo;
	int32_t nFrameRate;
	int32_t nBitRate;
	int32_t nAvrBitRate;
	int32_t nIdrCount;
	int32_t nUsrForceIdrCnt;
	int32_t nEncInputCnt;
	int32_t nEncOutputCnt;
	int32_t nFailedNum;
	int32_t nAvgTimeCost;
	int32_t nMaxTimeCost;
	uint32_t dwEncoderVersion;
}; // 10 * 4 + 11 * 4 = 84

struct TVencBasicParams {
	struct TVChanInfo tVChanInfo;
	int32_t nEncWidth;
	int32_t nEncHeight;
	int32_t nRdoLevel;
	int32_t nGopSize;
	int32_t nCompressor;
	int32_t nEnableRdoQuant;
	uint32_t dwEncType;
	uint32_t dwBitRate;
	uint32_t uint32_tFrameRate;
	uint32_t dwGOP;
	uint32_t dwProfile;
	uint32_t dwLevel;
	uint32_t dwPicOrderCountType;
	uint32_t dwLoopFilterMask;
	uint32_t dwEnctroyMode;
	uint32_t dwDeblockMode;
	uint32_t dwSliceMode;
	uint32_t dwSliceSize;
	uint32_t dwFmoMode;
	uint32_t dw8x8Mode;
	uint32_t dwTwoPass;
	uint32_t dwQualityLevel;
	uint32_t dwWeight;
}; // 10 * 4 + 23 * 4 = 132

struct TVencRcParams {
	struct TVChanInfo tVChanInfo;
	int32_t dwRcMode;
	int32_t nIMaxQuant;
	int32_t nIMinQuant;
	int32_t nPBMaxQuant;
	int32_t nPBMinQuant;
	int32_t nAvgQpI;
	int32_t nAvgQpP;
	int32_t nHrdSize;
	int32_t nInitQp;
	int32_t nPicRc;
	int32_t nBlkRc;
	int32_t nPskip;
	int32_t nBitrateWindow;
	int32_t nMaxBitrate;
	int32_t nTargBitrate;
	int32_t nStatTimeSeconds;
}; // 10 * 4 + 16 * 4 = 104

typedef struct tagVencSwRegs {
	struct TVChanInfo tVChanInfo;
	int32_t nDeviceID;
	int32_t nDieID;
	int32_t nCoreID;
	uint32_t dwSwreg215;
	uint32_t dwSwreg216;
	uint32_t dwSwreg217;
	uint32_t dwSwreg218;
	uint32_t dwSwreg219;
	uint32_t dwSwreg220;
	uint32_t dwSwreg221;
	uint32_t dwSwreg222;
	uint32_t dwSwreg223;
	uint32_t dwSwreg82;

} TVencSwRegs; // 10 * 4 + 13 * 4
typedef struct tagVcodecInfo {
	struct TVChanInfo tVChanInfo; // 40
	struct TVdecStatis tVdecStats; // 92
	struct TVencStatis tVencStats; // 84
	struct TVencBasicParams tVencBasicParams; // 132
	struct TVencRcParams tVencRcParams; // 104

} TVcodecInfo;

#define SHAREMEM_VERSION_SV100   0x1
#define SHAREMEM_VERSION_SG100   0x2
#define SHAREMEM_VERSION_OFFSET  24 // offset bit
#define SHAREMEM_VERSION_INITIAL 0x1
struct vatools_sharemem_filter {
	struct TVChanInfo head;
	u32 version;
	int32_t vpid;
	int32_t tid;
	uint64_t ns;
	uint32_t level;
	uint64_t timestamp_ns;
	uint32_t element_len;
	uint32_t rsvd[15];
	uint32_t data_len;
	uint8_t array[0];
};

union vatools_filter {
	//uint8_t data[452];
	//TVcodecInfo info;
	struct vatools_sharemem_filter filter_info; // sharemem_filter;
};
#pragma pack(pop)

#ifndef CONFIG_TOOLS_V2

#define MAX_OCCUPY_DIE_NUM	 (VASTAI_DIE_MAX_NUM * MAX_DEVICE_NUM_PER_MANAGER)
#define MAX_VIDEO_DIE_CAPABILITY 20000
#define MIN_VIDEO_DIE_CAPABILITY 0
#define MAX_OCCUPY_DIE_SINGLE	 128

enum {
	ALLOC_VIDEO_ENCODE,
	ALLOC_VIDEO_DECODE,
	ALLOC_VIDEO_MAX,
};
struct vatools_video_cap_query {
	/// 应用调用输入参数
	u32 version; // 版本号, 现在写0
	u8 flag_encode_or_decode; // 0:编码  1:解码
	u8 flag_specify_die; /* 0: 不指定 1: specify die */
	u8 flag_allocate_policy; // 分配策略方式: 0: 取最小资源占用die
	u8 flag_rsvd;
	u32 die_weight; /* allocated die weight */
	u32 specified_die_seq; /* specified die seq */

	/// 接口返回数据
	/* optimal die seq */
	u32 die_seq;
	u32 die_weight_total; // die 经过此次申请分配后的资源值
	u32 rsvd[16];
	u32 die_array_len;
	u8 die_array[MAX_OCCUPY_DIE_SINGLE];
};

struct vatools_occupy_die {
	u32 die_seq;
	u32 die_weight;
	u8 flag_encode_or_decode; // 0:编码  1:解码
};

#if (TOOLS_WIN == 1)
#pragma pack(push)
#pragma pack(8)
#endif
struct vatools_node {
	struct miscdevice misc;
	wait_queue_head_t wq;
	struct mutex node_mutex;
	// lupa add 2021-12-23 begin 整个业务的资源锁。保障处理该业务时，资源独享
	struct mutex node_sharedmem_mutex;
	struct mutex node_common_mutex;
	struct mutex node_profiler_mutex;
	struct mutex node_debugger_mutex;
	struct mutex node_logger_mutex;
	struct mutex node_smi_mutex;

	// lupa add 2021-12-23 end 整个业务的资源锁。保障处理该业务时，资源独享
	struct list_head list_nodes;
	void *pci_dev;
	unsigned char *node_buffer;
	unsigned int size;
	unsigned int rsv; //适配arm服务器 需要8字节对齐
	struct list_head list_node_readers;
	struct list_head list_node_process_mutex;

	// pcie dma / msg ringbuf, for profiler timeline
	void *profiler_dma_ringbuf;
	void *profiler_msg_ringbuf;

	// core event ringbuf
	void *event_ringbuf;
	// core event mutex
	struct mutex event_mutex;
	// 等待 core 的 event; 例如 reset事件
	wait_queue_head_t event_wait_queue;
	struct vatools_occupy_die die_weights[ALLOC_VIDEO_MAX]
					     [MAX_OCCUPY_DIE_NUM];
	struct vatools_occupy_die die_weights_real[ALLOC_VIDEO_MAX]
						  [MAX_OCCUPY_DIE_NUM];
	// app ringbuf, for profiler timeline
	void *profiler_app_ringbuf;
};

enum va_f_type {
	VATOOLS_OPEN,
	VATOOLS_READ,
	VATOOLS_WRITE,
	VATOOLS_IOCTL,
	VATOOLS_CLOSE,
};

struct vatools_pid_entry {
	int refcount;
	struct pid *pid;
	struct list_head node;
	enum va_f_type type;
};
#if (TOOLS_WIN == 1)
#pragma pack(pop)
#endif

struct vatools_reader {
	struct vatools_node *node;

	struct list_head list_readers;
	struct list_head
		malloc_pointers; // TODO: 保存每个 open 的 fd 申请的内存指针, 如果fd关闭时, 循环释放空间

	// sharedmem
	struct list_head t_sharedmem_mem_info_head;
	// struct list_head t_sharedmem_signal_info_head;
	//添加一个信号量用于触发等待事件
	struct completion debug_comp; // 用于记录触发信号使用 lupa add 2021-12-15
	struct fasync_struct *sharedmem_pt_fasync;
	struct mutex sharedmem_mutex;
	int n_sharedmem_init_done; // 标识是否初始化过; 1-完成初始化 0-未初始化

	// reader 通用变量. 暂未使用.
	size_t r_off;
	int r_all; // 适配arm服务器. 修改boot 类型为int
	int r_ver;
	unsigned int
		profiler_checkpoint_corebitmap; ///< 记录开启profiler checkpoint 的core , 使用 corebitmap记录, 每个core 一个bit

	T_SMI_IOCTL_TRANS_CATEGORY
	trans_category; // 适配arm服务器, 和host交互的结构, 需要注意 8 byte 对齐
	int exit; //是否退出
	// 适配arm服务器, 需要8字节对齐, trans_category 暂不修改, 这里使用保留字段对齐.
	u64 event_timestamp_ns; ///< 标识此时间以及之前的event都已经发送到host线程; 每次发送event到host后, 更新此时间

	// share mem filter
	union vatools_filter filter;
	struct vatools_occupy_die own_dies;
	struct vatools_occupy_die real_own_dies;
};

#endif

typedef struct VASTAI_FIFO_HEADER {
	u32 rd;
	u32 wr;
	u32 elem_count;
	u32 elem_size;
} T_VASTAI_FIFO_HEADER;
typedef struct VASTAI_FIFO_HEADER_WITHNAME {
	u32 rd;
	u32 wr;
	u32 elem_count;
	u32 elem_size;
	char name[CMD_BUF_NAME_LONG];
} T_VASTAI_FIFO_HEADER_WITHNAME;
typedef struct RING_BUF_STATITCS {
	u32 base_addr;
} T_RING_BUF_STATICS;
// vatools bar info struct
typedef struct vatools_bar_info_s {
	u64 mmio_start;
	u64 mmio_end;
	u64 mmio_len;
	u64 mmio_flags;
	/* inbound pcie to axi address translation */
	u64 at_addr;
	u64 mem;
	u64 vmem;
	u64 map_in_addr;
	u64 map_out_addr;
	u64 minish_bar_size;
} vatools_bar_info;

//****************************************************************************
//上面的定义, app, driver 需要保持一致, 拷贝到各个应用中
//****************************************************************************

// csram定义数据地址
// defined in csram_partition_v05.h
// #define PERFORMANCE_AI_BASE (CSRAM_BASE_ADDR + 0x000E2000)
#define PERFORMANCE_AI_LEN (256) // sg100 256 bytes

#define DDR_ECC_1BIT	  0x8CF6400
#define DDR_ECC_2BIT	  0x8CF6800
#define DDR_ECC_1BIT_SIZE (1024) // use csram to store ecc , 1k bytes
#define DDR_ECC_2BIT_SIZE (1024) // use csram to store ecc , 1k bytes

// 读此地址触发bar2切换为bar2默认地址
#define DDR_PCIE_BARRESET 0x814000000

// VEMCU ring buf
#define PERFORMANCE_HOST_2_VEMCU0 (CSRAM_BASE_ADDR + 0x56000)
#define PERFORMANCE_HOST_2_VEMCU1 (CSRAM_BASE_ADDR + 0x56400)
#define PERFORMANCE_HOST_2_VEMCU2 (CSRAM_BASE_ADDR + 0x56800)
#define PERFORMANCE_HOST_2_VEMCU3 (CSRAM_BASE_ADDR + 0x56C00)
// VDMCU ring buf
#define PERFORMANCE_SMCU_2_VDMCU0   (CSRAM_BASE_ADDR + 0x3E000)
#define PERFORMANCE_VDSP0_2_VDMCU0  (CSRAM_BASE_ADDR + 0x3E400)
#define PERFORMANCE_VDSP1_2_VDMCU0  (CSRAM_BASE_ADDR + 0x3E800)
#define PERFORMANCE_VEMCU0_2_VDMCU0 (CSRAM_BASE_ADDR + 0x3EC00)
#define PERFORMANCE_VEMCU1_2_VDMCU0 (CSRAM_BASE_ADDR + 0x3F000)
#define PERFORMANCE_SMCU_2_VDMCU1   (CSRAM_BASE_ADDR + 0x3F400)
#define PERFORMANCE_VDSP1_2_VDMCU1  (CSRAM_BASE_ADDR + 0x3F800)
#define PERFORMANCE_VDSP2_2_VDMCU1  (CSRAM_BASE_ADDR + 0x3FC00)
#define PERFORMANCE_VEMCU1_2_VDMCU1 (CSRAM_BASE_ADDR + 0x40000)
#define PERFORMANCE_VEMCU2_2_VDMCU1 (CSRAM_BASE_ADDR + 0x40400)
#define PERFORMANCE_SMCU_2_VDMCU2   (CSRAM_BASE_ADDR + 0x40800)
#define PERFORMANCE_VDSP2_2_VDMCU2  (CSRAM_BASE_ADDR + 0x40C00)
#define PERFORMANCE_VDSP3_2_VDMCU2  (CSRAM_BASE_ADDR + 0x41000)
#define PERFORMANCE_VEMCU2_2_VDMCU2 (CSRAM_BASE_ADDR + 0x41400)
#define PERFORMANCE_VEMCU3_2_VDMCU2 (CSRAM_BASE_ADDR + 0x41800)
// CMCU ring buf
#define PERFORMANCE_VDSP0_2_CMCU (CSRAM_BASE_ADDR + 0x49400)
#define PERFORMANCE_VDSP1_2_CMCU (CSRAM_BASE_ADDR + 0x49800)
#define PERFORMANCE_VDSP2_2_CMCU (CSRAM_BASE_ADDR + 0x49C00)
#define PERFORMANCE_VDSP3_2_CMCU (CSRAM_BASE_ADDR + 0x4A000)
// VDSP ring buf
#define PERFORMANCE_CMCU_2_VDSP0 (CSRAM_BASE_ADDR + 0x45400)
#define PERFORMANCE_CMCU_2_VDSP1 (CSRAM_BASE_ADDR + 0x46000)
#define PERFORMANCE_CMCU_2_VDSP2 (CSRAM_BASE_ADDR + 0x47000)
#define PERFORMANCE_CMCU_2_VDSP3 (CSRAM_BASE_ADDR + 0x48000)
#define PERFORMANCE_HOST_2_VDSP0 (CSRAM_BASE_ADDR + 0x57000)
#define PERFORMANCE_HOST_2_VDSP1 (CSRAM_BASE_ADDR + 0x57400)
#define PERFORMANCE_HOST_2_VDSP2 (CSRAM_BASE_ADDR + 0x57800)
#define PERFORMANCE_HOST_2_VDSP3 (CSRAM_BASE_ADDR + 0x57C00)
// HOST(PCIE) ring buf
#define PERFORMANCE_SMCU0_2_HOST  (CSRAM_BASE_ADDR + 0x51800)
#define PERFORMANCE_SMCU1_2_HOST  (CSRAM_BASE_ADDR + 0x51C00)
#define PERFORMANCE_VDMCU0_2_HOST (CSRAM_BASE_ADDR + 0x52000)
#define PERFORMANCE_VDMCU1_2_HOST (CSRAM_BASE_ADDR + 0x52400)
#define PERFORMANCE_VDMCU2_2_HOST (CSRAM_BASE_ADDR + 0x52800)
#define PERFORMANCE_VEMCU0_2_HOST (CSRAM_BASE_ADDR + 0x52C00)
#define PERFORMANCE_VEMCU1_2_HOST (CSRAM_BASE_ADDR + 0x53000)
#define PERFORMANCE_VEMCU2_2_HOST (CSRAM_BASE_ADDR + 0x53400)
#define PERFORMANCE_VEMCU3_2_HOST (CSRAM_BASE_ADDR + 0x53800)
#define PERFORMANCE_VDSP0_2_HOST  (CSRAM_BASE_ADDR + 0x53C00)
#define PERFORMANCE_VDSP1_2_HOST  (CSRAM_BASE_ADDR + 0x54000)
#define PERFORMANCE_VDSP2_2_HOST  (CSRAM_BASE_ADDR + 0x54400)
#define PERFORMANCE_VDSP3_2_HOST  (CSRAM_BASE_ADDR + 0x54800)
// Host(DMA) ring buf
#define PERFORMANCE_DMA_HOST_2_DEV (CSRAM_BASE_ADDR + 0x00014000)
#define PERFORMANCE_DMA_DEV_2_HOST (CSRAM_BASE_ADDR + 0x00014000 + 0xA000)
#define PERFORMANCE_DMA_RC_IN	   (CSRAM_BASE_ADDR + 0x00014000 + 0xA000 * 2)
#define PERFORMANCE_DMA_RC_OUT	   (CSRAM_BASE_ADDR + 0x00014000 + 0xA000 * 3)

//****************************************************************************
// profiler host interface
//****************************************************************************
//应用层调用接口
#define MAX_HW_MONITOR_NUM 4
#define MAX_ODMA_NUM	   2
#define MAX_DLC_NUM	   8
#define MAX_MC_NUM	   4

struct T_ADDR_VAL {
	u64 nAddr;
	u32 nLen;
	// u64 pcBuf;
	void *pcBuf;
};

struct T_PERFMON_SEL {
	union {
		u32 n_whole;
		struct {
			u32 n_is_enable : 1;
			u32 n_is_start : 1;
			u32 n_is_stop : 1;
			u32 n_spare : 1;
			u32 n_index : 12;
		};
	};
	u32 n_data_sel;
	u32 n_timer;
};

typedef struct tar_perfmon_mc_fw {
	u32 n_val[6];
} T_PERFMON_MC_FW;

typedef struct tar_perfmon_fw {
	union {
		u32 n_whole;
		struct {
			u32 n_is_enable : 1;
			u32 n_is_start : 1;
			u32 n_is_stop : 1;
			u32 n_spare : 1;
			u32 n_index : 12;
		};
	};
	u8 n_data_sel[MAX_HW_MONITOR_NUM];
	u32 n_timer;
	u32 n_data[MAX_HW_MONITOR_NUM];
} T_PERFMON_FW;

struct T_PERFMON_DATA {
	T_PERFMON_FW tODMA[MAX_ODMA_NUM];
	T_PERFMON_FW tDLC[MAX_DLC_NUM];
	T_PERFMON_MC_FW tMC[MAX_MC_NUM];
};

//****************************************************************************
// smi cmd block
//****************************************************************************

#define SMI_CMD_LOOP_TOTAL_COUNT     (20) //总轮询次数
#define SMI_CMD_LOOP_ADDING_COUNT    (3) //轮询时长增加次数
#define SMI_CMD_LOOP_INTERVAL_START  (2) // 起始轮询时间间隔, 单位ms
#define SMI_CMD_LOOP_INTERVAL_ADDING (10) // 每次增加时间间隔, 单位ms

//****************************************************************************
// driver internal define
//****************************************************************************
#define VATOOLS_UNINIT	  0
#define VATOOLS_INIT_DONE 1

//****************************************************************************
// vadebugger start
//****************************************************************************
#define VADBG_CSRAM_ADDR (0x08cf4400) // debug 使用的 csram base address
#define VADBG_CSRAM_LEN	 (4096) // total size. 0x1000
//****************************************************************************
// vadebugger end
//****************************************************************************

//****************************************************************************
// profiler checkpoint start
//****************************************************************************
// profiler使用的 csram base地址
// defined in csram_partition_v05.h
// #define PERFORMANCE_AI_BASE (CSRAM_BASE_ADDR + 0x000E2000)
#define PERFORMANCE_AI_LEN (256) // sg100 256 bytes

#define PROFILER_CSRAM_ADDR (PERFORMANCE_AI_BASE + PERFORMANCE_AI_LEN)
// profiler使用的csram size
#define PROFILER_CSRAM_LEN (512)

// soc内核数目
#define PROFILER_CORE_COUNT CORE_NUMBER
// 保存profiler的 DDR的起始地址. 模拟log.
#define PROFILER_DDR_ADDR   ((u64)0x814000000LL) // v0.6分配 0x0814000000
#define PROFILER_DDR_ADDR_H 0x8
#define PROFILER_DDR_ADDR_L 0x14000000
// 每个core使用1M的地址
#define PROFILER_DDR_BUFFER_LEN 0x100000
// csram 保存的 profiler control 数据, 每个core 1 byte
#define PROFILER_CTLR_BASE_ADDR (PROFILER_CSRAM_ADDR)
// csram 保存的 rpwp 地址. rp 占低8bytes, wp 占高8bytes
#define PROFILER_RPWP_STARTADDR (PROFILER_CSRAM_ADDR + 0x20)
// csram 保存的每个core对应的rp, wp 长度. 共16bytes
#define PROFILER_RPWP_SIZE 0x10
// 读读取的 rp, wp, host 需要使用mask, 只保留低有效位
#define PROFILER_CORE_BUF_WP_MASK (PROFILER_DDR_BUFFER_LEN - 1)
//****************************************************************************
// profiler checkpoint end
//****************************************************************************

/// profiler 采集数据的命令码
enum e_profiler_checkpoint_msg_type {
	PROFILER_CHECKPOINT_MSG_STOP = 0, ///< 停止采集
	PROFILER_CHECKPOINT_MSG_START = 1, ///< 开始采集
	PROFILER_CHECKPOINT_MSG_READ_RPWP =
		2, ///< 读取读写指针. fw 不会收到此命令
	PROFILER_CHECKPOINT_MSG_WRITE_RPWP =
		3, ///< 写入读写指针. fw 不会收到此命令
	PROFILER_CHECKPOINT_MSG_READ_DATA =
		4, ///< 读取 DDR 数据. fw 不会收到此命令
	PROFILER_CHECKPOINT_MSG_READ_CTRL = 5, ///< 读控制
	PROFILER_CHECKPOINT_MSG_READ_PCIE_DMA = 6, ///< PCIE dma 数据采集
	PROFILER_CHECKPOINT_MSG_READ_PCIE_MSG = 7, ///< PCIE msg 数据采集
	PROFILER_CHECKPOINT_MSG_WRITE_PCIE_APP = 8, ///< app 数据采集: 写入
	PROFILER_CHECKPOINT_MSG_READ_PCIE_APP = 9, ///< app 数据采集: 读取
};

/// 定义timeline采集点数据类型 u8
enum e_profiler_checkpoint_type {
	// general
	PROFILER_CHECKPOINT_UNKNOWN = 0x00,
	PROFILER_CHECKPOINT_IDLE = 0x01,
	PROFILER_CHECKPOINT_DUTY_BEGIN = 0x02,
	PROFILER_CHECKPOINT_DUTY_END = 0x03,
	// vdsp
	PROFILER_CHECKPOINT_HOST_TO_VDSP = 0x04,
	PROFILER_CHECKPOINT_VDSP_TO_HOST = 0x05,
	PROFILER_CHECKPOINT_OPCODE_BEGIN = 0x06,
	PROFILER_CHECKPOINT_OPCODE_END = 0x07,
	PROFILER_CHECKPOINT_VDSP_TO_CMCU = 0x08,
	PROFILER_CHECKPOINT_CMCU_TO_VDSP = 0x09,
	// pcie
	PROFILER_CHECKPOINT_PCIE_DMA = 0x10, // 16
	PROFILER_CHECKPOINT_PCIE_MSG = 0x11, // 17
	PROFILER_CHECKPOINT_PCIE_DMA_HOST_TO_DEVICE = 0x12, // 18
	PROFILER_CHECKPOINT_PCIE_DMA_DEVICE_TO_HOST = 0x13, // 19
	PROFILER_CHECKPOINT_PCIE_DMA_HOST_TO_DEVICE_BANDWIDTH = 0x14, // 20
	PROFILER_CHECKPOINT_PCIE_DMA_DEVICE_TO_HOST_BANDWIDTH = 0x15, // 21

	// cmcu ping: bit7=0  pong: bit7=1
	PROFILER_CHECKPOINT_PING_MODEL_BEGIN = 0x70, // 112
	PROFILER_CHECKPOINT_PING_MODEL_END = 0x71, // 113
	PROFILER_CHECKPOINT_PING_LAYER_BEGIN = 0x72, // 114
	PROFILER_CHECKPOINT_PING_LAYER_END = 0x73, // 115
	PROFILER_CHECKPOINT_PING_TIMESTAMP = 0x74, // 116
	PROFILER_CHECKPOINT_PING_MODEL_DUTY = 0x75, // 117
	PROFILER_CHECKPOINT_PING_LAYER_DUTY = 0x76, // 118
	PROFILER_CHECKPOINT_PING_LAYER_OPCODE = 0x77, // 119

	PROFILER_CHECKPOINT_PONG_MODEL_BEGIN =
		PROFILER_CHECKPOINT_PING_MODEL_BEGIN | 0x80, // 240
	PROFILER_CHECKPOINT_PONG_MODEL_END =
		PROFILER_CHECKPOINT_PING_MODEL_END | 0x80, // 241
	PROFILER_CHECKPOINT_PONG_LAYER_BEGIN =
		PROFILER_CHECKPOINT_PING_LAYER_BEGIN | 0x80, // 242
	PROFILER_CHECKPOINT_PONG_LAYER_END =
		PROFILER_CHECKPOINT_PING_LAYER_END | 0x80, // 243
	PROFILER_CHECKPOINT_PONG_TIMESTAMP =
		PROFILER_CHECKPOINT_PING_TIMESTAMP | 0x80, // 244
	PROFILER_CHECKPOINT_PONG_MODEL_DUTY =
		PROFILER_CHECKPOINT_PING_MODEL_DUTY | 0x80, // 245
	PROFILER_CHECKPOINT_PONG_LAYER_DUTY =
		PROFILER_CHECKPOINT_PING_LAYER_DUTY | 0x80, // 246
	PROFILER_CHECKPOINT_PONG_LAYER_OPCODE =
		PROFILER_CHECKPOINT_PING_LAYER_OPCODE | 0x80, // 247

	PROFILER_CHECKPOINT_MAX,
};

#ifndef MD5_MODEL_ID_LEN
#define MD5_MODEL_ID_LEN 4 // 16 uint32_t 128bit
#endif

#ifndef PROFILER_OPCODE_MAX
#define PROFILER_OPCODE_MAX 32
#endif

/// profiler timeline version
#define PROFILER_CMCU_VERSION 0x01
#define PROFILER_VDSP_VERSION 0x01

#define PROFILER_MODEL_NAME_STR_LEN_MAX (128)
/// cmcu 性能采集数据参数
typedef struct s_profiler_cmcu_section {
	uint8_t version;
	uint8_t type; ///< timeline采集点数据类型 e_profiler_checkpoint_type
	uint16_t length; ///< 数据长度
	uint32_t current_cycle_count; ///< 计时时刻; 使用core cycle count
	uint32_t last_cycle_count_after_checkpoint; ///< 检查点函数调用后采集的时间
	uint32_t sn; ///< 采集数据的序号, 自动增加1
	uint32_t process_vid; ///< 当前执行任务的进程vid
	uint32_t core_timestamp; ///< 250us 定时器

	/// 参数联合体
	union u_param_cmcu {
		/// model 参数
		struct {
			uint32_t model_name;
			uint32_t model_id[MD5_MODEL_ID_LEN];
			uint32_t layer_count;
			uint16_t batch_size;
			uint16_t req_int_src; // req from host or vdsp; use EM_INT_SRC_t
			uint16_t vdsp_total_msg_index; // from vdsp, associate with vdsp checkpoint data
			uint16_t rsvd;
			uint8_t model_name_str
				[PROFILER_MODEL_NAME_STR_LEN_MAX]; // save model_name string in model_info
		} __attribute__((packed)) cmcu_model;
		/// layer 参数
		struct {
			uint32_t model_name;
			uint32_t model_id[MD5_MODEL_ID_LEN];
			uint32_t real_layer_id : 16;
			uint32_t pipeline_id : 16;
			uint32_t group_id : 8;
			uint32_t group_flag : 8; // group_type_t
			uint32_t batch_id : 8;
			uint32_t rsvd : 8;
		} __attribute__((packed)) cmcu_layer;

		/// opcode
		struct {
			uint32_t real_layer_id;
			uint8_t opcode_num;
			uint16_t opcode_duty;
			uint8_t opcode_data_length;
			uint8_t opcode_data[PROFILER_OPCODE_MAX];
		} __attribute__((packed)) cmcu_opcode;

	} param;
	uint8_t rsvd[32];
	uint32_t magic_number; ///< magic number
} __attribute__((packed)) profiler_cmcu_section_t;

/**
时间说明:
  ...  last_section_end|  ckp_occupy0  |section_begin|  ckp_occupy1  |section_end|  ckp_occupy2  |next_section_begin ...

    section_end.last_cycle_count_after_checkpoint 是section真正开始的时间; 对应图像上section的begin
    section_end.last_cycle_count_after_checkpoint - section_begin.current_cycle_count
                                                  是checkpoint 函数占用的时间; 对应ckp_occupy1
    next_section_begin.current_cycle_count - section_end.current_cycle_count 是ckp_occupy2 时间
    section_begin 和 section_end 之间, 包含了checkpoint函数时间, 图像上需要去除.
 */

/// vdsp 性能数据采集参数
typedef struct s_profiler_vdsp_section {
	uint8_t version;
	uint8_t type; ///< timeline采集点数据类型 e_profiler_checkpoint_type
	uint16_t length; ///< 数据长度
	uint32_t current_cycle_count; ///< 计时时刻; 使用core cycle count
	uint32_t last_cycle_count_after_checkpoint; ///< 检查点函数调用后采集的时间
	uint32_t sn; ///< 采集数据的序号, 自动增加1
	uint32_t process_vid; ///< 当前执行任务的进程vid
	uint32_t core_timestamp; ///< WDT clock cycle num,250us 定时器

	union u_param_vdsp {
		struct {
			uint32_t data_id;
			uint32_t stream_id;
			uint32_t msg_ringbuf_index;
		} __attribute__((packed)) host_to_vdsp;
		struct {
			uint32_t data_id;
			uint32_t stream_id;
			uint32_t context_id;
			uint32_t msg_ringbuf_index;
		} __attribute__((packed)) vdsp_to_host;
		struct {
			uint32_t data_id;
			uint32_t stream_id;
			uint32_t context_id;
			uint32_t op_id;
			uint32_t loop_count;
		} __attribute__((packed)) opcode;
		struct {
			uint32_t data_id;
			uint32_t stream_id;
			uint32_t context_id;
			uint32_t msg_ringbuf_index;
			uint16_t loop_index;
			uint16_t total_msg_index; // vdsp to cmcu total message index for correlating information between vdsp and cmcu.
		} __attribute__((packed)) vdsp_to_cmcu;
		struct {
			uint32_t data_id;
			uint32_t stream_id;
			uint32_t context_id;
			uint32_t msg_ringbuf_index;
			uint16_t loop_index;
			uint16_t total_msg_index; // vdsp to cmcu total message index for correlating information between vdsp and cmcu.
		} __attribute__((packed)) cmcu_to_vdsp;
	} param;
	uint8_t rsvd[32];
	uint32_t magic_number; ///< magic number
} profiler_vdsp_section_t;

/// Driver timeline:
#define PROFILER_DMA_VERSION 0x01
#define PROFILER_MSG_VERSION 0x01

/// dma:4个：Driver接收到DMA请求的时间、Driver通知用户DMA完成的时间、DMA的实际开始执行时间、DMA实际执行结束时间，对应给出.
/// 时间段
typedef struct s_profiler_dma_checkpoint {
	u8 version;
	u8 rsvd[3];
	s64 pid;
	u32 dev_id;
	u32 die_id;
	u32 die_index;
	u64 time_of_driver_recv_dma_req; // host. 1970.1.1 ns begin
	u64 time_of_host_trigger_dma; // host 2
	u32 time_of_dma_run; // smcu 3
	u32 time_of_dma_finish; // smcu 4
	u64 time_of_driver_notify_host_dma_done; // host 5 ; end
	u64 dma_axi_addr;
	u32 dma_dir;
	u32 dma_data_size;
	u32 rsvd2[4];
} profiler_dma_checkpoint_t;

/// Driver timeline: Msg: 2个：FW收到Msg的时间，Dev发起 out_desc的时间, 时间点
typedef struct s_profiler_msg_checkpoint {
	u8 version;
	u8 rsvd[3];
	s64 pid;
	u32 dev_id;
	u32 die_id;
	u32 die_index;
	u64 time_of_host_send_msg; // 1970.1.1 ns begin
	u64 time_of_fw_recv_msg; // device_send_out_desc 有点困难, 暂时不做. 1970.1.1 ns end
	u32 core_bitmap; // 0x0010: vdsp0 ; 0x0020: vdsp1 ; 0x0040: vdsp2 ; 0x0080: vdsp3
	u32 msg_cmd;
	// command number used in FW
	// #define CMD_RUN_MODEL	  0x40185602
	// #define CMD_RUN_STREAM	  0x40185603
	// #define CMD_LOAD_MODEL	  0x40185604
	// #define CMD_DESTROY_MODEL 0x40185605
	// #define CMD_LOAD_VDSP_OPERATOR 0x40185606
	// #define CMD_LOAD_ODSP_OPERATOR 0x40185607
	u32 rsvd2[4];
} profiler_msg_checkpoint_t;

/// timeline: app checkpoint 数据采集，通用接口
#define PROFILER_APP_JSON_STR_LENGTH (256)
typedef struct s_profiler_app_checkpoint {
	u8 version;
	u8 rsvd[3];
	s64 pid;
	u32 tid;
	u64 ns;
	u32 level;
	u64 timestamp_ns;
	u32 sn;
	u32 die_index;
	u32 file_node_id; // 业务使用的设备文件节点序号
	u32 rsvd2[8];
	u32 type; // 区分采集数据类型
	u32 json_str_len; // 0: 不使用json，数据按照u32 解析 1: 使用json string
	// 保存具体信息
	union {
		u8 json_str[PROFILER_APP_JSON_STR_LENGTH];
		u32 data[PROFILER_APP_JSON_STR_LENGTH / sizeof(u32)];
	} info;
} profiler_app_checkpoint_t;

/// 保存pcie dma 采集数据的ringbuf
#define PROFILER_PCI_DMA_FIFO_LENGTH (100 * 1024 * 1024)
/// 保存pcie msg 采集数据的ringbuf
#define PROFILER_PCI_MSG_FIFO_LENGTH (100 * 1024 * 1024)
/// 保存 app 采集数据的ringbuf
#define PROFILER_PCI_APP_FIFO_LENGTH (100 * 1024 * 1024)

extern void *gp_profiler_dma_fifo;
extern void *gp_profiler_msg_fifo;

//****************************************************************************
// profiler checkpoint end
//****************************************************************************

//****************************************************************************
// core time sync start
//****************************************************************************

/// core time sync 命令码
enum e_core_time_sync_msg_type {
	CORE_TIME_SYNC_MSG_STOP = 0, ///< 停止时钟同步
	CORE_TIME_SYNC_MSG_START = 1, ///< 开始时钟同步
	CORE_TIME_SYNC_MSG_READ = 2, ///< 读取csram时钟同步数据
	CORE_TIME_SYNC_MSG_MAX
};

// 保存各个core的time , 各个core收到同步中断时, 写入.
typedef struct core_time_sync_s {
	unsigned int
		perfmon_data_index; // 读取oak6的perfmon PERFMON_DATA_INDEX 寄存器
	unsigned int cycle_count; // 读取当前core的cycle count: XT_RSR_CCOUNT
	unsigned int core_freq; // 由smcu写入
	unsigned int core_timestamp; // WDT clock cycle num,250us 定时器
} core_time_sync_t;

/// 保存core time sync 数据地址, 数据 core_time_sync_t . 每个core一个.
#define INTER_CORE_TIME_SYNC_ADDR (0x08cf3e00) // TODO: 临时使用, 需要申请

typedef struct core_time_sync_data_s {
	core_time_sync_t core_time[CORE_NUMBER];
	u64 host_time_ns[CORE_NUMBER];
} core_time_sync_data_t;

extern struct mutex pcie_timeline_dma_mutex;
extern struct mutex pcie_timeline_msg_mutex;

//****************************************************************************
// core time sync end
//****************************************************************************

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
struct bmcu_xspi_ver {
	s32 buf_size;
	union die_index_data die_index;
	char bmcu_active[32];
	char bmcu_backup[32];
	s32 die_num;
	struct {
		char xspi_ver[32];
	} dies[0];
};
#endif
#else
struct bmcu_xspi_ver {
	s32 buf_size;
	union die_index_data die_index;
	char bmcu_active[32];
	char bmcu_backup[32];
	s32 die_num;
	struct {
		char xspi_ver[32];
	} dies[0];
};
#endif
struct sriov_number_s {
	int dev_id;
	int sriov_num;
};

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
struct flash_bmcu_xspi {
	union die_index_data
		die_index; //If you flash bmcu, pls check this die_index is master die
	s32 buf_size;
	char buf[0];
};
#endif
#else
struct flash_bmcu_xspi {
	union die_index_data
		die_index; //If you flash bmcu, pls check this die_index is master die
	s32 buf_size;
	char buf[0];
};
#endif

struct flash_state {
	union die_index_data die_index;
	u32 flash_type; // 0: bmcu; 1: xspi; 2: pmcu;
	s32 flash_state; // 0: doing; 1: done; other: errno;
};

//-------------------------------------------------------
//v2 version

/// 版本号字符串长度
#define VASTAI_VER_LEN (64)

#define VASTAI_BUF_SIZE_32 (32)
#define VASTAI_DIE_MAX_NUM (4)

/// 固件版本号
typedef struct vatools_fw_version_s {
	unsigned char ver[VASTAI_VER_LEN]; ///< 产品版本号
	unsigned char fw_ver[VASTAI_VER_LEN]; ///< 固件版本号
	unsigned char smcu_ver[VASTAI_VER_LEN]; ///< SMCU版本号
	unsigned char vdmcu_ver[VASTAI_VER_LEN]; ///< VDMCU版本号
	unsigned char vemcu_ver[VASTAI_VER_LEN]; ///< VEMCU版本号
	unsigned char vdsp_ver[VASTAI_VER_LEN]; ///< VDSP版本号
	unsigned char cmcu_ver[VASTAI_VER_LEN]; ///< CMCU版本号
	unsigned char lmcu_ver[VASTAI_VER_LEN]; ///< LMCU版本号
	unsigned char odsp_ver[VASTAI_VER_LEN]; ///< ODSP版本号
	unsigned char driver_ver[VASTAI_VER_LEN]; ///< 驱动版本号
} vatools_fw_version_t;

/// die 索引结构
typedef union vatools_die_index_data_u {
	u32 val; ///< device /die 标识
	struct {
		u32 die_id : 8; ///< die ID
		u32 dev_id : 16; ///< device ID
		u32 seq_num : 8; ///< die 序列号
	};
} vatools_die_index_data_t;

// linux defination: major 12 bit; minor 20 bit
#define MINOR_H(dev) ((unsigned int)(((dev) >> 16) & 0xf))
#define MINOR_L(dev) ((unsigned int)(((dev)) & 0xffff))
typedef union major_minor_u {
	u32 val; ///< 主次版本号值
	struct {
		u16 minor; ///< 次版本号
		u16 major : 12; ///< 主版本号
		u16 minor_h : 4; ///< 次版本号. 高 4bit
	};
} major_minor_t; ///< 主次版本号

typedef struct node_base_info_s {
	char name[VASTAI_BUF_SIZE_32];
	union major_minor_u majormin;
} node_base_info_t;

typedef struct vatools_die_info_s {
	/// die 标识
	union vatools_die_index_data_u die_index;
	/// vacc 名字
	struct node_base_info_s vacc;
	/// render 名字
	struct node_base_info_s render;
	/// video 名称
	struct node_base_info_s vastai_video;
	/// bbox type
	char bbox_type[VASTAI_BUF_SIZE_32];
} vatools_die_info_t;

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
struct card_info {
	int cnt;
	char buf[0];
};
#endif
#else
struct card_info {
	int cnt;
	char buf[0];
};
#endif

union pci_id {
	u32 val; ///< PCI ID 值
	struct {
		u16 vender_id; ///< vender ID
		u16 device_id; ///< 设备ID
	};
};

union pci_sub_id {
	u32 val; ///< PCI SUB ID 值
	struct {
		u16 sub_vender_id; ///< SUB vender ID
		u16 sub_device_id; ///< SUB device ID
	};
};

struct ai_video_cap {
	int ai_cap; ///< AI 能力集
	int video_cap; ///< VIDEO 能力集
};

// bar size check
typedef struct vatools_bar_address_s {
	u64 begin;
	u64 end;
} vatools_bar_address_t;

typedef struct vatools_dev_vfpf_flag_s {
	u32 is_physfn;
	u32 is_virtfn;
} vatools_dev_vfpf_flag_t;
typedef struct vatools_dev_info_s {
	int dev_id; ///< 设备ID
	char unid[VASTAI_BUF_SIZE_32]; ///< SN号
	char pcie_slot[VASTAI_BUF_SIZE_32]; ///< PCI slot. 格式 0000:01:00.00
	char card_type[VASTAI_BUF_SIZE_32]; ///< 卡类型
	char bbox_mode[VASTAI_BUF_SIZE_32]; ///< 卡bbox类型
	/// PCI ID 信息
	union pci_id pciid; ///< PCI ID 信息
	union pci_sub_id pcisubid;
	struct node_base_info_s kchar; ///< 主次版本号
	struct node_base_info_s vatools; ///< 主次版本号
	struct node_base_info_s vastai_ctrl; ///< 主次版本号
	struct node_base_info_s vastai_version; ///< 主次版本号
	struct ai_video_cap cap; ///< AI VIDEO 能力集
	struct vatools_bar_address_s bar_address[4][2]; ///< bar size
	int die_num; ///< die 数目
	vatools_die_info_t die_info[VASTAI_DIE_MAX_NUM]; ///< die信息
} vatools_dev_info_t;

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
/// 设备性能数据
struct vatools_performance_info {
	/// PCI 性能数据
	struct {
		u32 pcie_tx_vdsp_count[4]; ///< PCI 发送到 VDSP 的数据数量
		u32 pcie_rx_vdsp_count[4]; ///< PCI 接收到 VDSP 的数据数量
		u64 pcie_bandwidth_upstream; ///< PCI 上行带宽. 设备到主机.
		u64 pcie_bandwidth_downstream; ///< PCI 下行带宽. 主机到设备.
	} pcie_performance;
	/// CSRAM 信息
	u8 csram_info[0];
};
#endif
#else
/// 设备性能数据
struct vatools_performance_info {
	/// PCI 性能数据
	struct {
		u32 pcie_tx_vdsp_count[4]; ///< PCI 发送到 VDSP 的数据数量
		u32 pcie_rx_vdsp_count[4]; ///< PCI 接收到 VDSP 的数据数量
		u64 pcie_bandwidth_upstream; ///< PCI 上行带宽. 设备到主机.
		u64 pcie_bandwidth_downstream; ///< PCI 下行带宽. 主机到设备.
	} pcie_performance;
	/// CSRAM 信息
	u8 csram_info[0];
};
#endif

/// 设备ECC信息
struct vatools_ecc_entry {
	u32 addr_1; ///< 地址低位
	u32 addr_h; ///< 地址高位
	u32 axi_id; ///< axi ID
	u32 axi_data_l; ///< axi数据低位
	u32 axi_data_h; ///< axi 数据高位
	u32 errbit; ///< err bit
};

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
/// 设备ECC表
struct vatools_ecc_table {
	u32 entry_count; ///< entry 数目
	u32 rsvd_0; ///< 保留
	u32 rsvd_1; ///< 保留
	u32 rsvd_2; ///< 保留
	struct vatools_ecc_entry entry[0]; ///< ecc entry 数据
};
#endif
#else
/// 设备ECC表
struct vatools_ecc_table {
	u32 entry_count; ///< entry 数目
	u32 rsvd_0; ///< 保留
	u32 rsvd_1; ///< 保留
	u32 rsvd_2; ///< 保留
	struct vatools_ecc_entry entry[0]; ///< ecc entry 数据
};
#endif

typedef struct smi_cmd_header_s {
	u32 unit; ///< 命令操作的指定单元，从0开始，如果命令不需要解析，填0，如果是全部，填0xFFFF, 此字段也可以做命令扩展
	u16 data_len; ///< 指示发生给fw的数据或者fw返回的数据字节长度，以byte为单位
	u8 flag; ///< 指示fw是否已经准备好数据， 0x01U，数据准备好，
		///<  0x00U数据未准备好, 应用层发送命令时填写0x00U
	u8 cmd; ///< 具体命令
	u64 rw_addr; ///< 读写地址
} smi_cmd_header_t; ///< SMI命令格式, 共 64 bit

typedef struct smi_cmd_s {
	smi_cmd_header_t header; ///< smi 命令头
	u8 data[1024 -
		sizeof(smi_cmd_header_t)]; ///< 数据区; 取所有block的最大值; 1K bytes
} smi_cmd_t; ///< smi cmd, 包括头部和数据区

typedef struct smi_cmd_req_s {
	u32 block_id; ///< smi block id
	u32 wait_ack_timeout; ///< smi命令等待ack超时时间, 单位: 毫秒ms; 0 不使用 wait_ack, 直接返回
	smi_cmd_t req; ///< smi req 请求命令
	smi_cmd_t rsp; ///< smi rsp 返回数据
} smi_arg_t; ///< ioctl 传递的 smi 参数

//-----------------------------------------------------------------------------
// host 使用 ioctl 和驱动进行数据交互传输
//-----------------------------------------------------------------------------
/// ioctl arg header
typedef struct vatools_ioctl_arg_header_s {
	u32 type;
	vatools_die_index_data_t die_index;
	u64 address;
	u32 length;
	int err;
} vatools_ioctl_arg_header_t;

#if (TOOLS_WIN == 1)
#ifdef __cplusplus
/// ioctl arg
typedef struct vatools_ioctl_arg_s {
	vatools_ioctl_arg_header_t header;
	union {
		u8 body[0];
		vatools_dev_info_t dev_info[0];
		smi_arg_t smi;
		void *buffer;
	};
} vatools_ioctl_arg_t;
#endif
#else
/// ioctl arg
typedef struct vatools_ioctl_arg_s {
	vatools_ioctl_arg_header_t header;
	union {
		u8 body[0];
		vatools_dev_info_t dev_info[0];
		smi_arg_t smi;
		void *buffer;
	};
} vatools_ioctl_arg_t;
#endif

/// STORE ADDR OF HEARTBEAT COUNT

typedef struct core_heartbeat_s {
	u32 smcu_hb;
	u32 pmcu_hb;
	u32 cmcu_hb;
	u32 omcu0_hb;
	u32 omcu1_hb;
	u32 gmcu0_hb;
	u32 gmcu1_hb;
	u32 gmcu2_hb;
	u32 gmcu3_hb;
	u32 vemcu0_hb;
	u32 vemcu1_hb;
	u32 vemcu2_hb;
	u32 vemcu3_hb;
	u32 odsp0_hb;
	u32 odsp1_hb;
	u32 vdsp0_hb;
	u32 vdsp1_hb;
} core_heartbeat_t;

//TODO: ref: csram_partition.h
#define CORE_HEARTBEAT_ADDR 0x94209C
#define CORE_HEARTBEAT_LEN  (sizeof(struct core_heartbeat_s))

#define FW_VERSION_ADDR 0x8e1000

enum vatools_device_class_e {
	DEVICE_CLASS_CURRENT =
		0, // 当前设备, 通过 pci_info->dev->vendor, pci_info->dev->device 获取 pci_id
	DEVICE_CLASS_SV100 = 0x01001ec6,
	DEVICE_CLASS_SV100_VF = 0x01011ec6,
	DEVICE_CLASS_SG100_SERVER_PF = 0x02001ec6,
	DEVICE_CLASS_SG100_SERVER_PF_HARVEST1 = 0x02011ec6,
	DEVICE_CLASS_SG100_SERVER_PF_HARVEST2 = 0x02021ec6,
	DEVICE_CLASS_SG100_SERVER_VF = 0x020f1ec6,
	DEVICE_CLASS_SG100_PF0_GFX = 0x02041ec6,
	DEVICE_CLASS_SG100_PF1_AUDIO = 0x02051ec6,
	DEVICE_CLASS_UNKNOWN,
};

struct system_cfg_boot {
	unsigned char devfn;
	unsigned char pfn;
	unsigned char vfn;
	unsigned char vf_active;
	unsigned char stream_id;
	unsigned char gfx_mpu_en;
	unsigned char smmu_mpu_en;
	unsigned char gfx_mode;
	unsigned char pkg_id; //0:master pkg , 1: slave pkg
	unsigned char reserved01;
	unsigned char reserved02;
	unsigned char reserved03;
	unsigned int lo32_ddr_base;
	unsigned int hi32_ddr_base;
};

#define VATOOLS_PCI_BUS_SIZE (128)
typedef union {
	u8 rsvd[VATOOLS_PCI_BUS_SIZE];
	struct {
		unsigned char
			number; /* Bus number 所有属于同一个物理卡的 pf vf 有相同的 number */
		unsigned char primary; /* Number of primary bridge */
		unsigned char max_bus_speed; /* enum pci_bus_speed */
		unsigned char cur_bus_speed; /* enum pci_bus_speed */
		char name[48];
		unsigned int domain_id; /*pci domain*/
		unsigned int card_id; /*pci card id*/
	} pci_bus;
} vatools_pci_bus_u;

#define VATOOLS_SYSTEM_CFG_SIZE (256)
typedef union {
	u8 rsvd[VATOOLS_SYSTEM_CFG_SIZE];
	struct {
		unsigned char devfn;
		unsigned char pfn;
		unsigned char vfn;
		unsigned char vf_active;
		unsigned char stream_id;
		unsigned char gfx_mpu_en;
		//0: display disable 1:display enable
		unsigned char dp_en;
		unsigned char gfx_mode;
		//0:master pkg, 1: slave pkg
		unsigned char pkg_id;
		//0:ATU 1:GART
		unsigned char atu_or_gart;
		unsigned char fn_mode;
		unsigned char is_super_pf;
		unsigned char is_admin_pf;
		//bar4_5_cfg_size 0:normal cfg,vf-256MB PF-2GB
		//1:1GB 2:2GB 4:4GB 8:8GB 16:16GB 32:32GB 64:64GB
		unsigned char bar4_5_cfg_size;
		//0:EVB  1:AIC-ANYI 2:AIC_ZHAOGE
		unsigned char card_type;
		//16:16GB 32:32GB 64:64GB
		unsigned char sum_ddr_sz;
		unsigned int smmu_sync_01;
		unsigned int card_id;
		unsigned char total_pf_per_card;
		unsigned char total_vf_per_pf;
		unsigned char decoder_sriov_en;
		unsigned char cur_pf_vf_num;
		/*1MB assigned*/
		unsigned int gart_size;
		unsigned int reserved32_03;
	} sys_cfg;
} vatools_sys_cfg_u;

// get gpu device info
typedef struct vatools_gfx_render_info_s {
	int drm_major; // major node ; minor node is the same of below *_id
	int gfx_primary_id; // index in /dev/dri/cardxxx for gfx drm device.
	int gfx_render_id; // index in /dev/dri/renderxxx for gfx drm device.
	int nulldisp_primary_id; // index in /dev/dri/cardxxx for nulldisp drm device.
} vatools_gfx_render_info_t;

//ddr info
typedef enum VATOOLS_DDR_ENTRY_OBJ {
	VATOOLS_VF_MANAGE,
	VATOOLS_META_FW,
	VATOOLS_ENC_DEC_CMD_BUF,
	VATOOLS_AI_MODULE_OPCODE,
	VATOOLS_SMMU_CD_TABLE,
	VATOOLS_RESERVED_DDR,
	VATOOLS_RUNTIME,
	// VATOOLS_GART, 驱动新增, 排列变化, 放到最后
	VATOOLS_GPU_HEAP,
	VATOOLS_GPU_DISPLAY,
	VATOOLS_GART,
	VATOOLS_DDR_ENTRY_MAX,
} vatools_ddr_entry_index;

struct vatools_ddr_entry {
	u64 noc_addr;
	u64 fn_addr;
	u64 cpu_pa;
	u64 bar_offset;
	u64 size;
};

typedef struct vatools_ddr_info_s {
	u64 card_ddr_size; /*the card ddr sum size*/
	u64 fn_ddr_size; /*the function ddr sum size*/
	struct vatools_ddr_entry ddr_entry[VATOOLS_DDR_ENTRY_MAX];
	u8 rsvd[216];
} vatools_ddr_info_t;

#ifdef CONFIG_TOOLS_V2
// ================================================================
// ================================================================
// ================================================================
// ================================================================
// ================================================================

#define VATOOLS_MAGIC_CODE		0xA283419D

// MAJOR: 和 tools 发布大版本匹配. 目前写 3
// MIDDLE: 暂未定义. 写 0
// MINOR: 每次驱动增加feature，或者fix重大bug，加 1 . 应用层可以用来做兼容驱动处理
#define VATOOLS_DRV_VERSION_MAJOR_CODE	3
#define VATOOLS_DRV_VERSION_MIDDLE_CODE 6
#define VATOOLS_DRV_VERSION_MINOR_CODE	2

// sv100 log 地址配置
#define SV100_LOG_CORE_COUNT (29)
// 后面 32 byte为 ctrl byte
#define SV100_LOG_CTRL_LEN	    (SV100_LOG_CORE_COUNT * 16 + 32)
#define SV100_LOG_CTRL_INFO	    (0x08CF30A0)
#define SV100_LOG_MSG_FLAG	    (0x08CF3098)
#define SV100_LOGSYS_RPWP_STARTADDR SV100_LOG_CTRL_INFO
#define SV100_LOGSYS_RPWP_SIZE	    0x10

// sg100 log 地址配置
#define SG100_LOG_CORE_COUNT (17)
// 后面 32 byte为 ctrl byte
#define SG100_LOG_CTRL_LEN	    (SG100_LOG_CORE_COUNT * 16 + 32)
#define SG100_LOG_CTRL_INFO	    (0x008e1400)
#define SG100_LOG_MSG_FLAG	    (SG100_LOG_CTRL_INFO + 512 - 4)
#define SG100_LOGSYS_RPWP_STARTADDR SG100_LOG_CTRL_INFO
#define SG100_LOGSYS_RPWP_SIZE	    0x10

// spi 数据buffer长度
#define SPI_BUF_LEN_MAX (1000)

// 版本号定义
#define VASTAI_VER_COMMON_LEN	   (64) ///< 每个版本的最长字符数
#define VASTAI_VER_COMMON_MAX_ITEM (64) ///< 最大版本数量
typedef union {
	u8 fw_ver[VASTAI_VER_COMMON_MAX_ITEM][VASTAI_VER_COMMON_LEN];
	struct {
		u8 ver[VASTAI_VER_COMMON_LEN];
		u8 smcu_ver[VASTAI_VER_COMMON_LEN];
		u8 bmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 vdmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 vemcu_ver[VASTAI_VER_COMMON_LEN];
		u8 vdsp_ver[VASTAI_VER_COMMON_LEN];
		u8 cmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 lmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 odsp_ver[VASTAI_VER_COMMON_LEN];
		u8 driver_ver[VASTAI_VER_COMMON_LEN];
		u8 phy_ver[VASTAI_VER_COMMON_LEN];
		u8 bmcu_backup_ver[VASTAI_VER_COMMON_LEN];
	} sv100_fw_version;
	struct {
		u8 ver[VASTAI_VER_COMMON_LEN];
		u8 smcu_ver[VASTAI_VER_COMMON_LEN];
		u8 cmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 omcu_ver[VASTAI_VER_COMMON_LEN];
		u8 gmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 vemcu_ver[VASTAI_VER_COMMON_LEN];
		u8 odsp_ver[VASTAI_VER_COMMON_LEN];
		u8 vdsp_ver[VASTAI_VER_COMMON_LEN];
		u8 pmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 vdmcu_ver[VASTAI_VER_COMMON_LEN];
		u8 ver_bk[VASTAI_VER_COMMON_LEN];
		u8 bl0_ver[VASTAI_VER_COMMON_LEN];
		u8 bl0_ver_bk[VASTAI_VER_COMMON_LEN];
		u8 driver_ver[VASTAI_VER_COMMON_LEN];
		u8 phy_ver[VASTAI_VER_COMMON_LEN];
	} sg100_fw_version;
} vatools_v2_fw_version_u;

// V2 ioctl 命令 header 信息
#define VATOOLS_BASE_INFO_SIZE (256)
typedef union {
	u8 rsvd[VATOOLS_BASE_INFO_SIZE];
	struct {
		u32 rsvd[4];
		u32 magic_number;
		u32 security[4];
		u32 tools_ver_major;
		u32 tools_ver_middle;
		u32 tools_ver_minor;
		u32 device_number;
		u32 device_info_size; ///< 保存 device info 结构size
		u32 card_change_count; ///< 标识系统内卡情况变化, 每次改变加 1
	} info;
} vatools_v2_base_info_u;

// V2 get_device_info
#define VATOOLS_DIE_INFO_SIZE (1024 * 8)
typedef union {
	u8 rsvd[VATOOLS_DIE_INFO_SIZE];
	struct {
		// 32*u32 header
		u32 rsvd[32];
		/// die 标识
		vatools_die_index_data_t die_index;
		/// vacc 名字
		struct node_base_info_s vacc;
		/// render 名字
		struct node_base_info_s render;
		/// video 名称
		struct node_base_info_s vastai_video;
		/// bbox type
		char bbox_type[VASTAI_BUF_SIZE_32];
		char spi_buf[SPI_BUF_LEN_MAX]; ///< SPI 数据
		u32 pcie_nls; /* negotiated_link_speed */
		u32 pcie_nlw; /* negotiated_link_width */
		vatools_v2_fw_version_u fw_ver;
	} info;
} vatools_v2_die_info_u;

#define VATOOLS_DEVUCE_INFO_SIZE (1024 * 50)
typedef struct vatools_v2_device_info_s {
	// 32*u32 header
	u32 rsvd[32];
	// device info
	int dev_id; ///< 设备ID
	char unid[VASTAI_BUF_SIZE_32]; ///< SN号
	char pcie_slot[VASTAI_BUF_SIZE_32]; ///< PCI slot. 格式 0000:01:00.00
	char card_type[VASTAI_BUF_SIZE_32]; ///< 卡类型
	char bbox_mode[VASTAI_BUF_SIZE_32]; ///< 卡bbox模式
	char bbox_type[VASTAI_BUF_SIZE_32]; ///< 卡bbox类型
	/// PCI ID 信息
	union pci_id pciid; ///< PCI ID 信息
	union pci_sub_id pcisubid;
	struct node_base_info_s kchar; ///< 主次版本号
	struct node_base_info_s vatools; ///< 主次版本号
	struct node_base_info_s vastai_ctrl; ///< 主次版本号
	struct node_base_info_s vastai_version; ///< 主次版本号
	struct ai_video_cap cap; ///< AI VIDEO 能力集
	struct vatools_bar_address_s bar_address[4][2]; ///< bar size
	int die_num; ///< die 数目
	vatools_v2_die_info_u die_info[VASTAI_DIE_MAX_NUM]; ///< die信息
	vatools_dev_vfpf_flag_t dev_vfpf_flag;
	u64 smcu_access_ddr_address_limit[2]; ///< smcu 可以访问的地址区间
	struct sriov_number_s sriov_number;
	vatools_v2_fw_version_u fw_ver;
	vatools_sys_cfg_u sys_cfg; //sg100 csram_hw_cfg->system_cfg
	vatools_pci_bus_u pci_bus;
	node_base_info_t gfx_primary_node;
	node_base_info_t gfx_render_node;
	node_base_info_t gfx_nulldisp_primary_node;
	vatools_ddr_info_t ddr_info;
	u32 board_type; // sv100 or sg100
	u64 board_physical_id; // 标识同一个物理卡 // offset: 38616
	u64 capability0; // 标识驱动设备的能力. 按bit使用 // offset: 38624
} vatools_v2_device_info_t;

// 调整结构体分量后，需要手动修改这个size 值， 必须匹配。否则编译错误
#define SIZEOF_V2_DEVICE_INFO_STRUCT (38624)

typedef union {
	u8 rsvd[VATOOLS_DEVUCE_INFO_SIZE];
	vatools_v2_device_info_t info;
} vatools_v2_device_info_u;

typedef struct vatools_devices_info_s {
	vatools_v2_base_info_u base;
	vatools_v2_device_info_u *device_info_p;
} vatools_devices_info_t;

//TODO: capability0 使用定义
/**
bit0'0: bmcu 不支持 flash 无感升级
bit0'1: bmcu 支持 flash 无感升级
bit1'0: bl0/xspi 不支持 flash 无感升级
bit1'1: bl0/xspi 支持 flash 无感升级
bit2'0: pmcu 不支持 flash 无感升级
bit2'1: pmcu 支持 flash 无感升级

其他未使用。
*/
//TODO: change to vastai code later
enum vatools_flash_update_type_e {
	VATOOLS_FLASH_UPDATE_BMCU = 0,
	VATOOLS_FLASH_UPDATE_BL0,
	VATOOLS_FLASH_UPDATE_PMCU,
};

#define MAX_OCCUPY_DIE_NUM	 (VASTAI_DIE_MAX_NUM * MAX_DEVICE_NUM_PER_MANAGER)
#define MAX_VIDEO_DIE_CAPABILITY 20000
#define MIN_VIDEO_DIE_CAPABILITY 0
#define MAX_OCCUPY_DIE_SINGLE	 128

enum {
	ALLOC_VIDEO_ENCODE,
	ALLOC_VIDEO_DECODE,
	ALLOC_VIDEO_MAX,
};
struct vatools_video_cap_query {
	/// 应用调用输入参数
	u32 version; // 版本号, 现在写0
	u8 flag_encode_or_decode; // 0:编码  1:解码
	u8 flag_specify_die; /* 0: 不指定 1: specify die */
	u8 flag_allocate_policy; // 分配策略方式: 0: 取最小资源占用die
	u8 flag_rsvd;
	u32 die_weight; /* allocated die weight */
	u32 specified_die_seq; /* specified die seq */

	/// 接口返回数据
	/* optimal die seq */
	u32 die_seq;
	u32 die_weight_total; // die 经过此次申请分配后的资源值
	u32 rsvd[16];
	u32 die_array_len;
	u8 die_array[MAX_OCCUPY_DIE_SINGLE];
};

struct vatools_occupy_die {
	u32 die_seq;
	u32 die_weight;
	u8 flag_encode_or_decode; // 0:编码  1:解码
};

struct vatools_node {
	struct miscdevice misc;
	wait_queue_head_t wq;
	struct mutex node_mutex;
	// lupa add 2021-12-23 begin 整个业务的资源锁。保障处理该业务时，资源独享
	struct mutex node_sharedmem_mutex;
	struct mutex node_common_mutex;
	struct mutex node_profiler_mutex;
	struct mutex node_debugger_mutex;
	struct mutex node_logger_mutex;
	struct mutex node_smi_mutex;
	struct mutex node_dummy_mutex;
	struct mutex node_driver_mutex;
	struct mutex node_reader_mutex;

	// lupa add 2021-12-23 end 整个业务的资源锁。保障处理该业务时，资源独享
	struct list_head list_nodes;
	void *pci_dev;
	unsigned char *node_buffer;
	unsigned int size;
	unsigned int rsv; //适配arm服务器 需要8字节对齐
	struct list_head list_node_readers;
	struct list_head list_node_process_mutex;

	// pcie dma / msg ringbuf, for profiler timeline
	void *profiler_dma_ringbuf;
	void *profiler_msg_ringbuf;

	// core event ringbuf
	void *event_ringbuf;
	// core event mutex
	struct mutex event_mutex;
	// 等待 core 的 event; 例如 reset事件
	wait_queue_head_t event_wait_queue;
	vatools_v2_device_info_u *dev_info;
	u32 device_num;
	u32 rsvd; // for arm cpu, 8 byte align
	struct vatools_occupy_die die_weights[ALLOC_VIDEO_MAX]
					     [MAX_OCCUPY_DIE_NUM];
	struct vatools_occupy_die die_weights_real[ALLOC_VIDEO_MAX]
						  [MAX_OCCUPY_DIE_NUM];
	// app ringbuf, for profiler timeline
	void *profiler_app_ringbuf;
};

enum va_f_type {
	VATOOLS_OPEN,
	VATOOLS_READ,
	VATOOLS_WRITE,
	VATOOLS_IOCTL,
	VATOOLS_CLOSE,
};

struct vatools_pid_entry {
	struct pid *pid;
	struct list_head node;
	int refcount;
	enum va_f_type type;
};

struct vatools_reader {
	struct vatools_node *node;
	struct list_head list_readers;
	struct list_head
		malloc_pointers; // TODO: 保存每个 open 的 fd 申请的内存指针, 如果fd关闭时, 循环释放空间
	// sharedmem
	struct list_head t_sharedmem_mem_info_head;
	// struct list_head t_sharedmem_signal_info_head;
	//添加一个信号量用于触发等待事件
	struct completion debug_comp; // 用于记录触发信号使用 lupa add 2021-12-15
	struct fasync_struct *sharedmem_pt_fasync;
	struct mutex sharedmem_mutex;
	int n_sharedmem_init_done; // 标识是否初始化过; 1-完成初始化 0-未初始化
	// reader 通用变量. 暂未使用.
	size_t r_off;
	int r_all;
	int r_ver;
	unsigned int
		profiler_checkpoint_corebitmap; ///< 记录开启profiler checkpoint 的core , 使用 corebitmap记录, 每个core 一个bit

	T_SMI_IOCTL_TRANS_CATEGORY
	trans_category; // 适配arm服务器, 和host交互的结构, 需要注意 8 byte 对齐
	int exit; //是否退出
	// 适配arm服务器, 需要8字节对齐, trans_category 暂不修改, 这里使用保留字段对齐.
	u64 event_timestamp_ns; ///< 标识此时间以及之前的event都已经发送到host线程; 每次发送event到host后, 更新此时间
	u32 ioctl_version; ///< VATOOLS_IOCTL_V2_MAGIC: v2 版本
	int rsvd; // for arm cpu, 8 byte align

	// share mem filter
	union vatools_filter filter;
	struct vatools_occupy_die own_dies;
};

// SPI 命令 unit bit
#define SPI_BLOCK_CODE	       0x1 /// <spi flash code 代码
#define SPI_BLOCK_ECC	       0x2 ///< spi flash user setting 信息
#define SPI_BLOCK_PRODUCT_INFO 0x4 ///< spi flash productinfo Inventory 产品信息
#define SPI_BLOCK_MFG_INFO     0x8 ///< spi flash MFG information 信息
#define SPI_BLOCK_BBOX_INFO    0x10 ///< spi flash production bbox
#define SPI_BLOCK_EEPROM       0x20 ///< spi flash eeprom, gpu inventory

/// ===================================================================
/// ===================================================================
/// ===================================================================
/// ===================================================================
/// ===================================================================
// ioctl 通用命令 V2 版本 vvvvvvvvvvvvvvvvvvv
/// ===================================================================
#define VATOOLS_IOCTL_V2_MAGIC 0xA2
/// 测试命令
#define VATOOLS_IOCTL_V2_TEST _IO(VATOOLS_IOCTL_V2_MAGIC, 0x00)
/// 设置打开的文件fd的类别
#define VATOOLS_IOCTL_V2_SET_APP_CATEGORY _IO(VATOOLS_IOCTL_V2_MAGIC, 0x01)
/// 获取device info
#define VATOOLS_IOCTL_V2_GET_DEVICE_INFO _IO(VATOOLS_IOCTL_V2_MAGIC, 0x02)
enum e_ioctl_get_device_info_sub_cmd {
	VATOOLS_IOCTL_DEVICE_INFO_NONE = 0,
	VATOOLS_IOCTL_DEVICE_INFO_REFRESH =
		1, // 不读取缓存, 重新从芯片读取相关数据
};

/// 普通方式读取数据 //TODO: 针对不同地址存取逻辑, 放到common里面?
#define VATOOLS_IOCTL_V2_READ_BUF _IO(VATOOLS_IOCTL_V2_MAGIC, 0x03)
/// 普通方式写入数据
#define VATOOLS_IOCTL_V2_WRITE_BUF _IO(VATOOLS_IOCTL_V2_MAGIC, 0x04)

/// 获取reset event
#define VATOOLS_IOCTL_V2_DEVICE_EVENT _IO(VATOOLS_IOCTL_V2_MAGIC, 0x05)

/// core timestamp sync
#define VATOOLS_IOCTL_V2_CORE_TIME_SYNC _IO(VATOOLS_IOCTL_V2_MAGIC, 0x06)
enum e_ioctl_core_time_sync_sub_cmd {
	VATOOLS_IOCTL_CORE_TIME_SYNC_STOP = 0, ///< 停止时钟同步
	VATOOLS_IOCTL_CORE_TIME_SYNC_START = 1, ///< 开始时钟同步
	VATOOLS_IOCTL_CORE_TIME_SYNC_READ = 2, ///< 读取csram时钟同步数据
};

/// 通过 smi 读写数据, 先写,触发中断到smcu, 后读, 读写通过一次调用完成
#define VATOOLS_IOCTL_V2_SMI_CMD _IO(VATOOLS_IOCTL_V2_MAGIC, 0x07)
/// ioctl smi sub cmd
enum e_ioctl_smi_sub_cmd {
	VATOOLS_IOCTL_SMI_NONE = 0,
	VATOOLS_IOCTL_SMI_READ = 1,
	VATOOLS_IOCTL_SMI_WRITE = 2,
	VATOOLS_IOCTL_SMI_FETCH = 3,
};

/// 通过PCIE处理的命令族
#define VATOOLS_IOCTL_V2_PCIE_CMD _IO(VATOOLS_IOCTL_V2_MAGIC, 0x08)
/// ioctl pcie type/cmd 命令, 不使用smcu. 驱动直接处理
enum e_ioctl_pcie_sub_cmd {
	VATOOLS_IOCTL_PCIE_NONE = 0,
	VATOOLS_IOCTL_PCIE_BANDWIDTH = 1,
	VATOOLS_IOCTL_PCIE_RESET = 2,
	VATOOLS_IOCTL_PCIE_REBOOT = 3,
	VATOOLS_IOCTL_PCIE_STRING = 4,
	VATOOLS_IOCTL_PCIE_FW_VERSION = 5,
	VATOOLS_IOCTL_PCIE_DDR_ECC_1BIT = 6,
	VATOOLS_IOCTL_PCIE_DDR_ECC_2BIT = 7,
	VATOOLS_IOCTL_PCIE_VDSP_COUNT = 8,
	VATOOLS_IOCTL_PCIE_AI_COUNT = 9, // 256 bytes  PERFORMANCE_AI_BASE
	VATOOLS_IOCTL_PCIE_RING_BUF_STATISTIC = 10,
	VATOOLS_IOCTL_PCIE_SET_VIDEO_MULTI_CORE =
		11, ///< 设置video使用multicore; 0: 不使用; 1: 使用
	VATOOLS_IOCTL_PCIE_GET_VIDEO_MULTI_CORE =
		12, ///< 读取video multicore 的mode和job count
	VATOOLS_IOCTL_PCIE_MAX
};

#define VATOOLS_IOCTL_V2_PROFILER _IO(VATOOLS_IOCTL_V2_MAGIC, 0x0a)
enum e_ioctl_profiler_sub_cmd {
	VATOOLS_IOCTL_PROFILER_NONE = 0,
	VATOOLS_IOCTL_PROFILER_PERFMON_READ = 1, ///< 读取 perfmon 寄存器
	VATOOLS_IOCTL_PROFILER_PERFMON_WRITE = 2, ///< 写入 perfmon 寄存器
	// profiler 采集数据的命令码
	VATOOLS_IOCTL_PROFILER_TIMELINE_STOP = 3, ///< 停止采集
	VATOOLS_IOCTL_PROFILER_TIMELINE_START = 4, ///< 开始采集
	VATOOLS_IOCTL_PROFILER_TIMELINE_READ_RPWP =
		5, ///< 读取读写指针. fw 不会收到此命令
	VATOOLS_IOCTL_PROFILER_TIMELINE_WRITE_RPWP =
		6, ///< 写入读写指针. fw 不会收到此命令
	VATOOLS_IOCTL_PROFILER_TIMELINE_READ_DATA =
		7, ///< 读取 DDR 数据. fw 不会收到此命令
	VATOOLS_IOCTL_PROFILER_TIMELINE_READ_CTRL = 8, ///< 读控制
	VATOOLS_IOCTL_PROFILER_TIMELINE_READ_PCIE_DMA =
		9, ///< PCIE dma 数据采集
	VATOOLS_IOCTL_PROFILER_TIMELINE_READ_PCIE_MSG =
		10, ///< PCIE msg 数据采集
	VATOOLS_IOCTL_PROFILER_MAX
};

#define VATOOLS_IOCTL_V2_FLASH _IO(VATOOLS_IOCTL_V2_MAGIC, 0x0b)
enum e_ioctl_flash_sub_cmd {
	VATOOLS_IOCTL_FLASH_NONE = 0,
	VATOOLS_IOCTL_FLASH_BMCU_FW = 1, /// 烧入bmcu fw版本
	VATOOLS_IOCTL_FLASH_XSPI_FW = 2, /// 烧入xspi fw版本
	VATOOLS_IOCTL_FLASH_GET_FLASH_STATUS = 3, /// 获取烧写状态
	VATOOLS_IOCTL_FLASH_SWITCH_BMCU = 4, /// 切换bmcu版本
	VATOOLS_IOCTL_FLASH_PMCU_FW = 5, /// 烧入pmcu fw版本
	VATOOLS_IOCTL_FLASH_FULL_BL0_FW = 6, /// 烧入full bl0 fw版本
};

/// 获取 firmware log status
#define VATOOLS_IOCTL_V2_LOG_STATUS _IO(VATOOLS_IOCTL_V2_MAGIC, 0x0c)
/// DMA
#define VATOOLS_IOCTL_V2_DMA _IO(VATOOLS_IOCTL_V2_MAGIC, 0x0d)
enum e_ioctl_dma_sub_cmd {
	VATOOLS_IOCTL_DMA_NONE = 0,
	VATOOLS_IOCTL_DMA_ALLOC = 1, /// 分配 DMA 内存
	VATOOLS_IOCTL_DMA_START = 2, /// 开始 DMA 传输数据
	VATOOLS_IOCTL_DMA_FREE = 3, /// 释放 DMA 内存
};

/// 使用内核mutex实现进程互斥保护
#define VATOOLS_IOCTL_V2_GUARD _IO(VATOOLS_IOCTL_V2_MAGIC, 0x0f)
enum e_ioctl_guard_sub_cmd {
	VATOOLS_IOCTL_GUARD_NONE = 0,
	VATOOLS_IOCTL_GUARD_LOCK = 1, /// 加锁
	VATOOLS_IOCTL_GUARD_UNLOCK = 2, /// 解锁
	VATOOLS_IOCTL_GUARD_TRYLOCK = 3, /// trylock
	VATOOLS_IOCTL_GUARDU_IS_LOCKED = 4, /// is locked
};
#define VATOOLS_IOCTL_GUARD_NAME_LENGTH (256)

/// 共享内存
#define VATOOLS_IOCTL_V2_SHARE_MEM _IO(VATOOLS_IOCTL_V2_MAGIC, 0x10)
enum e_ioctl_share_mem_sub_cmd {
	VATOOLS_IOCTL_SHARE_MEM_NONE = 0,
	VATOOLS_IOCTL_SHARE_MEM_CREATE = 1, /// 创建共享内存信息
	VATOOLS_IOCTL_SHARE_MEM_DELETE = 2, /// 删除共享内存信息
	VATOOLS_IOCTL_SHARE_MEM_READ = 3, /// 获取共享内存信息
	VATOOLS_IOCTL_SHARE_MEM_WRITE = 4, /// 写入共享内存信息
	VATOOLS_IOCTL_SHARE_MEM_POLL = 5, /// 等待信息开始
};

/// video debug. 和共享内存共用子命令
#define VATOOLS_IOCTL_V2_VIDEO_DEBUGGER _IO(VATOOLS_IOCTL_V2_MAGIC, 0x11)
enum e_ioctl_video_debugger_sub_cmd {
	VATOOLS_IOCTL_VIDEO_DEBUGGER_NONE = 0,
	VATOOLS_IOCTL_VIDEO_DEBUGGER_START = 11, /// 开始video debugger信息
	VATOOLS_IOCTL_VIDEO_DEBUGGER_STOP = 12, /// 停止video  debugger信息
	VATOOLS_IOCTL_VIDEO_DEBUGGER_READ = 13, /// 读取video  debugger信息
	VATOOLS_IOCTL_VIDEO_DEBUGGER_WRITE = 14, /// 写入video debugger信息
	VATOOLS_IOCTL_VIDEO_DEBUGGER_FUNCTION_CREATE = 15, /// 附加回调函数
	VATOOLS_IOCTL_VIDEO_DEBUGGER_FUNCTION_DELETE = 16, /// 删除回调函数
};

/// ai debug
#define VATOOLS_IOCTL_V2_AI_DEBUGGER _IO(VATOOLS_IOCTL_V2_MAGIC, 0x12)
enum e_ioctl_ai_debugger_sub_cmd {
	VATOOLS_IOCTL_AI_DEBUGGER_NONE = 0,
	VATOOLS_IOCTL_AI_DEBUGGER_CONFIG = 1, /// 配置调试工具命令
	VATOOLS_IOCTL_AI_DEBUGGER_SET = 2, /// 设置调试工具命令
	VATOOLS_IOCTL_AI_DEBUGGER_GET = 3, /// 读取调试工具命令
	VATOOLS_IOCTL_AI_DEBUGGER_FETCH = 4, /// 获取调die_index试工具命令
};

/// get vatools_v2_base_info_u, version and device_number etc.
#define VATOOLS_IOCTL_V2_BASE_INFO _IO(VATOOLS_IOCTL_V2_MAGIC, 0x13)

/// 命令作用域
enum e_ioctl_cmd_domain {
	VATOOLS_IOCTL_DOMAIN_NONE = 0, /// 无作用域信息
	VATOOLS_IOCTL_DOMAIN_DEVICE = 1 << 0, /// 卡级命令
	VATOOLS_IOCTL_DOMAIN_DIE = 1 << 1, /// die 级命令
	VATOOLS_IOCTL_DOMAIN_DRIVER = 1 << 2, /// driver 级命令, 不下发到 SMI
	VATOOLS_IOCTL_DOMAIN_MAX = 1 << 3, ///
};

typedef struct buf_ptr_s {
	u32 buf_size;
	// void *buf_addr;
	u64 buf_addr;
} buf_ptr_t;

// host 使用 ioctl 和驱动进行数据交互传输
typedef struct ioctl_arg_s {
	u32 sub_cmd; // 根据ioctl 命令的不同, 解析为对应命令的子命令
	union die_index_data die_index; //die index信息
	u32 block_id; // SMI 命令使用的block ID, 每个blockId有自己的csram 区域
	u32 lock_domain; // 命令作用域, 用来做加锁判断
	i64 errcode; //调用内核ioctl返回值
	u64 address; // 通用数据地址参数
	u64 value; // 通用数据值参数
	u32 count; // 通用计数参数
	buf_ptr_t input_buf; // host侧要写入 fw 的数据buffer. 数据: host->fw
	buf_ptr_t output_buf; // host侧保存 fw 返回的数据buffer. 数据: fw->host

#if (TOOLS_WIN == 1) // for win DeviceIoControl
	LPDWORD lpBytesReturned;
	u64 lpOverlapped; /*LPOVERLAPPED*/
#else
	u64 rsvd1; // 用来和 win 驱动字节对齐
	u64 rsvd2; // 用来和 win 驱动字节对齐
#endif
	u32 rsvd[8];
} ioctl_arg_t;

/// dma 内存分配命令
typedef struct dma_alloc_cmd_s {
	HANDLE dma_buf_fd;
	UINT64 hostva;
	u32 size;
	u32 die_index;
} dma_alloc_cmd_t;

/// dma 启动命令
typedef struct dma_start_cmd_s {
	u32 is_dev_to_host;
	HANDLE dma_buf_fd;
	u64 axi_addr;
	u32 size;
	u32 die_index;
} dma_start_cmd_t;

// 用户空间内存直接传递到内核, 使用前无需 dma alloc 内存
typedef struct dma_trans_cmd_s {
	u32 is_dev_to_host;
	u64 vir_addr;
	u64 axi_addr;
	u32 length;
	u32 die_index;
	int pid;
} dma_trans_cmd_t;

/// ===================================================================
// ioctl 通用命令 V2 版本 ^^^^^^^^^^^^^
/// ===================================================================
/// ===================================================================
/// ===================================================================
/// ===================================================================
/// ===================================================================
#endif

/// ===================================================================
// smi 命令使用频率序号
/* PLL frequence clk ID  */
enum SMI_PLL_SUBCMD_e {
	PLL_LEFT_VCLK,
	PLL_LEFT_LCCLK,
	PLL_LEFT_VDSPCLK,
	PLL_LEFT_LUCLK,
	PLL_LEFT_DCLK,
	PLL_LEFT_LPVTCLK,
	PLL_RIGHT_RCCLK,
	PLL_RIGHT_ECLK,
	PLL_RIGHT_RUCLK,
	PLL_RIGHT_GCLK,
	PLL_RIGHT_RPVTCLK,
	PLL_BOTTOM_CEDARCLK,
	PLL_BOTTOM_BCCLK,
	PLL_BOTTOM_PERIPHCLK,
	PLL_BOTTOM_XPHYCLK,
	PLL_BOTTOM_BPVTCLK,
	PLL_BOTTOM_DPI2S0CLK,
	PLL_BOTTOM_DPI2S1CLK,
	PLL_BOTTOM_DPAUXCLK,
	PLL_BOTTOM_APBDPCLK,
	PLL_BOTTOM_DP_PHY_CLK,
	PLL_BOTTOM_PIXLCK_DP0,
	PLL_BOTTOM_OCLK,
	PLL_BOTTOM_PIXLCK_DP1,
	PLL_BOTTOM_ODSPCLK,
	PLL_MAX_COUNT
};

// 获取当前进程的信息
typedef struct vatools_current_process_info_s {
	u32 die_index;
	u32 pid;
	u32 vpid;
	u32 level;
	u64 ns;
	u32 resvd[4];
} vatools_current_process_info_t;

//TODO: rutime info
// struct from vaccrt
// defined in vastai_ai.h

// runtime info struct for tools
// 每个 die 一个结构
typedef struct vatools_runtime_info_head_s {
	u32 die_index;
	u32 die_id; // is vacc0, vacc1 ...; not device.die_id
	u32 ai_version;
	u32 zone_count;
	u32 process_count;
	char ai_version_str[32];
} vatools_runtime_info_head_t;
// 每个 die 一个结构
typedef struct vatools_runtime_zone_usage_s {
	u32 die_index;
	u64 ddr_total_size;
	vacc_zone_usage_t zone_usage[zone_count];
} vatools_runtime_zone_usage_t;
// 每个 进程 一个结构
typedef struct vatools_runtime_process_info_s {
	u32 die_index;
	u32 pid;
	u32 vpid;
	u32 level;
	u64 ns;
	u64 zone_used[zone_count];
} vatools_runtime_process_info_t;

typedef struct vastai_runtime_statistic_s {
	u32 info_head_max_num; // 可以存取数据的最大值
	u32 info_head_num; // 读取到的数据最大值
	u64 info_head_p; // vatools_runtime_info_head_t *
	u32 zone_usage_max_num; // 可以存取数据的最大值
	u32 zone_usage_num; // 读取到的数据最大值
	u64 zone_usage_p; // vatools_runtime_zone_usage_t *
	u32 process_info_max_num; // 可以存取数据的最大值
	u32 process_info_num; // 读取到的数据最大值
	u64 process_info_p; // vatools_runtime_process_info_t *
	vatools_current_process_info_t current_process_info; // 获取当前进程的信息
} vastai_runtime_statistic_t;

// 获取heartbeat 统计信息
//TODO: tobedone remove it when pcie define this
#define HEARTBEAT_MAX_CNT 100 /* Max record 1Min: 100 * 3Sec */

typedef struct vatools_heartbeat_count_s {
	u32 die_index;
	u32 heartbeat_counts[HEARTBEAT_MAX_CNT][HEARTBEAT_CNT_REG_NUM];
} vatools_heartbeat_count_t;

// DDR bandwidth
#define DDR_MC_PHY_MAX		  (16)
#define DDR_MC_PHY_PORT_MAX	  (16)
#define SG100_DDR_MC_PHY_MAX	  (8)
#define SV100_DDR_MC_PHY_MAX	  (4)
#define SG100_DDR_MC_PHY_PORT_MAX (4)
#define SV100_DDR_MC_PHY_PORT_MAX (5)

/**
sv100
Port0: PCIe EP Master
Port1: ODMA0/1 rd/wr, wddma rd, odsp wr/rd, data_export wr, ctrans rd. (DAP_MNOC_mst_rd, DAP_MNOC_mst_wr)
Port2: encoder/decoder, VMCU dma.(DEC0-4_AXI_mst, ENC0-3_AXI_mst, vmcu dma)
Port3: V3D, Video DSP
Port4: SMCU/CMCU, Security DMA, PCIe RC Master

sg100
Port0: gfx
Port1：video
Port2: pcie ep rc, tcu,gmcu
Port3: pmcu,cedar,xspi,qspi,jtag,vdsp,odma,oak_ctrans,dataexp,wddma,lmcu,odsp,cmcu,dsu,smcu

*/

typedef struct __attribute__((packed)) vastai_ddr_bandwidth_mc_s {
	u64 upstream_count_mb; /* UPSTREAM read from ddr*/
	u64 downstream_count_mb; /* DOWNSTREAM write to ddr*/
} vastai_ddr_bandwidth_mc_t;

typedef struct __attribute__((packed)) vastai_ddr_bandwidth_s {
	vastai_ddr_bandwidth_mc_t ddr_bandwidth
		[SG100_DDR_MC_PHY_MAX]; // 按 MC_PHY 采集的数据， 单位 MB， 兼容之前驱动
} vastai_ddr_bandwidth_t;

// CPU和卡设备拓扑关系字符串长度
#define CPU_AND_CARD_TOPO_STR_LEN 1024 * 10
// 获取devinfo时， 强制不使用 cache 数据。 1：不使用缓存 0：使用缓存
#define TOOLS_DEBUG_NO_DEV_INFO_CACHE (1)

// win兼容32/64bit
struct file_operations_tool {
	struct module *owner;
	loff_t (*llseek)(struct file *, loff_t, int);
	ssize_t (*read)(struct file *, char __user *, size_t, loff_t *);
	ssize_t (*write)(struct file *, const char __user *, size_t, loff_t *);
	ssize_t (*read_iter)(struct kiocb *, struct iov_iter *);
	ssize_t (*write_iter)(struct kiocb *, struct iov_iter *);
	unsigned int (*poll)(struct file *, struct poll_table_struct *);
	long (*unlocked_ioctl)(struct file *, unsigned int, IOCTL_ARG_T);
	long (*compat_ioctl)(struct file *, unsigned int, IOCTL_ARG_T);
	int (*mmap)(struct file *, struct vm_area_struct *);
	int (*open)(struct inode *, struct file *);
	int (*release)(struct inode *, struct file *);
	int (*fasync)(int, struct file *, int);
};

// gfx cmd
enum gfx_cmd_enum {
	TOOL_CMD_GFX_NONE = 0,
	TOOL_CMD_GFX_GET_DRIVER_STATUS = 1,
	TOOL_CMD_GFX_GET_GPU_UTILIZATION = 2,
	TOOL_CMD_GFX_GET_MEMORY_USAGE = 3,
	TOOL_CMD_GFX_NUM_TYPE = 4,
};

#define GFX_PF_MAX (128) //0xFFFF // vf: pf_index >> 16
typedef struct gfx_cmd_input_args_s {
	u32 pf_num; // 指定pf数量, 默认全部: PF_MAX
	u32 pf_index[GFX_PF_MAX]; // 按pf_num指定的值排列数据
	u64 input_data_addr; // 输入参数地址
	u32 input_data_size; // 输入参数长度
} gfx_cmd_input_args_t;

// unit: KBytes
typedef struct gfx_memory_usage_pf_s {
	u32 pf_index; // 标识数据所属 pf
	u32 MemoryTotal;
	u32 MemoryUsageKMalloc;
	u32 MemoryUsageKMallocMax;
	u32 MemoryUsageVMalloc;
	u32 MemoryUsageVMallocMax;
	u32 MemoryUsageAllocPTu32_MemoryUMA;
	u32 MemoryUsageAllocPTu32_MemoryUMAMax;
	u32 MemoryUsageVMapPTUMA;
	u32 MemoryUsageVMapPTUMAMax;
	u32 MemoryUsageAllocPTu32_MemoryLMA;
	u32 MemoryUsageAllocPTu32_MemoryLMAMax;
	u32 MemoryUsageIORemapPTLMA;
	u32 MemoryUsageIORemapPTLMAMax;
	u32 MemoryUsageAllocGPUMemLMA;
	u32 MemoryUsageAllocGPUMemLMAMax;
	u32 MemoryUsageAllocGPUMemUMA;
	u32 MemoryUsageAllocGPUMemUMAMax;
	u32 MemoryUsageAllocGPUMemUMAPool;
	u32 MemoryUsageAllocGPUMemUMAPoolMax;
	u32 MemoryUsageMappedGPUMemUMA_LMA;
	u32 MemoryUsageMappedGPUMemUMA_LMAMax;
	u32 MemoryUsageDmaBufImport;
	u32 MemoryUsageDmaBufImportMax;
	u32 MemoryUsageDisplay_Heap_Size;
	u32 MemoryUsageDisplay_Heap_Use;
} gfx_memory_usage_pf_t;

typedef struct memory_usage_info_s {
	u32 pf_num;
	gfx_memory_usage_pf_t gfx_memory_usage[GFX_PF_MAX];
} gfx_memory_usage_info_t;

typedef struct gfx_utilization_pf_s {
	u32 pf_index; // 标识数据所属 pf
	u32 utilization;
} gfx_utilization_pf_t;

typedef struct gfx_utilization_info_s {
	u32 pf_num; // default PF_MAX: all pf
	gfx_utilization_pf_t utilization[GFX_PF_MAX];
} gfx_utilization_info_t;

#ifdef __cplusplus
}
#endif
#pragma pack(pop)

#endif //__VATOOLS_DEFINE_H__
