#ifndef __VASTAI_RENDER_H__
#define __VASTAI_RENDER_H__

#include "gfx_drv.h"
#include "vastai_dec.h"
#include "vastai_enc.h"

#define VASTAI_VIDEO_DEBUG_DIR     "va_video"
#define VASTAI_VIDEO_DEBUG_NAME    "debug"

#define VASTAI_DEBUG_PARAM_DIEINDEX  "dieindex"
#define VASTAI_DEBUG_PARAM_ENCMODE   "enc_mode"
#define VASTAI_DEBUG_PARAM_ENC_LOGLEVEL  "enc_loglevel"
#define VASTAI_DEBUG_PARAM_DEC_LOGLEVEL  "dec_loglevel"

struct vastai_video_info{
	dec_device_handle_t *dec_device_handle;
	enc_device_handle_t *enc_device_handle;
	struct enc_chn_info *enc_info;
	struct vastai_render_file *render_file;
};

struct vastai_gfx_limit {
	unsigned long long gfx_ddr_min;
	unsigned long long gfx_ddr_max;
};

struct vastai_render_file {
	struct vastai_file_info file_info;
	struct vastai_pci_info *pci_info;
	void* private_data;
	void *dec_private_data;
	void *enc_private_data;
	struct list_head node;
	unsigned int die_index;
	vastai_hw_type_t hw_type;
	vastai_video_workmode_t enc_work_mode;
	vastai_video_workmode_t dec_work_mode;
	struct vastai_gfx_limit gfx_ddr;
};

int vastai_video_init(void *pcie_dev, unsigned int die_num);
void vastai_video_deinit(struct vastai_pci_info *);

#endif
